'use strict';
 
var app = angular.module('myApp', [
    'ngTouch',
    'ngRoute',  
    'ngResource',
    'ngSanitize',
    'ngDraggable',
    'luegg.directives',
    'ngScrollbar',
    'myApp.controllers', 
    'myApp.AJAX',
    'myApp.me',
    'myApp.player',
    'myApp.equipment',
    'myApp.draft',
    'myApp.skillpoints',
    'timer',
    'myApp.team',
    'myApp.comp',
    'myApp.wall',
    'myApp.account',
    'myApp.manageTeam',
    'myApp.live',
    'myApp.games',
    'myApp.gameLog',
    'myApp.notifications',
    'myApp.conversations',
    'myApp.fastclick',
    'myApp.cyberpoints',
    'myApp.payments',
    'myApp.wc',
    'myApp.events',
    'myApp.country',
    'myApp.pickupGames',
    'myApp.halloffame',
    'myApp.oneOnOne',
    'myApp.confirm',
    'http-with-fallback',
    'DeferredWithUpdate',
    'myApp.tutorial',
    'myApp.allstar',
    'myApp.chat'
]).
config(['$routeProvider', '$compileProvider',
    function ($routeProvider, $compileProvider) {
       $compileProvider.aHrefSanitizationWhitelist(/^\s*(https?|http|ftp|mailto|file|ghttps?|ms-appx|x-wmapp0):/);

    //$compileProvider.imgSrcSanitizationWhitelist(/^\s*(https?|ftp|file|http|ms-appx|x-wmapp0):|data:image\//);
    //always true.. i've had it with WP8 
    $compileProvider.imgSrcSanitizationWhitelist(/(?=.*[a-z])/);
  
        
    $routeProvider.when('/login', 				{templateUrl: 'partials/login.html', 				controller: 'loginCtrl'}); 
    $routeProvider.when('/home', 				{templateUrl: 'partials/home.html',			 	controller: 'homeCtrl'  });
    $routeProvider.when('/setLanguage/:iso', 			{templateUrl: 'partials/home.html'			, 	controller: 'setLanguageCtrl'});
    $routeProvider.when('/linkLogin/:username/:password', 	{templateUrl: 'partials/home.html'			, 	controller: 'loginCtrl'});
    $routeProvider.when('/newCompetitions/:day/',		{templateUrl: 'partials/competition/newCompetitionsSetup.htm' , controller: 'newCompetitionsCtrl'});
    $routeProvider.when('/events/:which/',			{templateUrl: 'partials/events/homepage.htm' ,			controller: 'eventsCtrl'});
    $routeProvider.when('/auction/:id/',			{templateUrl: 'partials/events/auction.htm' ,			controller: 'auctionCtrl'});
   
    
    $routeProvider.when('/draft/:playerId', 			{templateUrl: 'partials/draft/draftTemplate.html', 		controller: 'draftCtrl'  });
    //the idea here is, there seems to be a delay when visiting the SQL or rest. So send the variables like this. Its cheaper.
    $routeProvider.when('/draftHere/:playerId/:pos/:leagueId/:timestamp/:simtime/:human/:fromPage', {templateUrl: 'partials/draft/draftHereTemplate.html', controller: 'chooseDraftTeamCtrl'  });
    $routeProvider.when('/draftHere/:playerId/:pos/:leagueId/:timestamp/:simtime/:human', {templateUrl: 'partials/draft/draftHereTemplate.html', controller: 'chooseDraftTeamCtrl'  });
    $routeProvider.when('/equipment/:playerId/', 		{templateUrl: 'partials/equipment/equipmentView.html', 		controller: 'equipmentCtrl'  });
    $routeProvider.when('/inventory/:itemType/:playerId/', 	{templateUrl: 'partials/equipment/inventoryView.html', 		controller: 'inventoryCtrl'  });
    $routeProvider.when('/equipmentStore/:itemType/:playerId/', {templateUrl: 'partials/equipment/equipmentStoreView.html', 	controller: 'equipmentStoreCtrl'  });
    $routeProvider.when('/team/:teamId/:season',  	 	{templateUrl: 'partials/team/teamProfile.html',           	controller: 'teamProfileCtrl'});
    $routeProvider.when('/team/:teamId',           		{templateUrl: 'partials/team/teamProfile.html',           	controller: 'teamProfileCtrl'});
    $routeProvider.when('/club/:teamId',           		{templateUrl: 'partials/team/teamProfile.html',           	controller: 'teamProfileCtrl'});
    $routeProvider.when('/manageTeam/:teamId',     		{templateUrl: 'partials/manageTeam/manageTeamView.html',  	controller: 'manageTeamCtrl'     }); 
    $routeProvider.when('/signOwnPlayers/:teamId',     		{templateUrl: 'partials/manageTeam/signOwnPlayers.html',  	controller: 'signOwnPlayersCtrl'     }); 
   
    $routeProvider.when('/teamTactics/:teamId',    		{templateUrl: 'partials/manageTeam/teamTacticsView.html',  	controller: 'teamTacticsCtrl'     });  
    $routeProvider.when('/playerSearch/:teamId',   		{templateUrl: 'partials/manageTeam/playerSearch.html',     	controller: 'playerSearchCtrl'     });  
    $routeProvider.when('/offer/:what/:playerId/:teamId',  	{templateUrl: 'partials/manageTeam/offerContract.html' ,  	controller: 'offerContractCtrl'  });
    $routeProvider.when('/offer/:what/:playerId', 		{templateUrl: 'partials/manageTeam/offerContract.html' ,  	controller: 'offerContractCtrl'  });
    $routeProvider.when('/games/', 				{templateUrl: 'partials/games/gamesListView.html', 		controller: 'gamesListCtrl'  });
    $routeProvider.when('/games/:day', 				{templateUrl: 'partials/games/gamesListView.html', 		controller: 'gamesListCtrl'  });
    $routeProvider.when('/game/:gameId/:live',	 		{templateUrl: 'partials/games/gameView.html', 			controller: 'gameCtrl'});
    $routeProvider.when('/game/:gameId',	 		{templateUrl: 'partials/games/gameView.html', 			controller: 'gameCtrl'});
    $routeProvider.when('/openThread/:id/',			{templateUrl: 'partials/wall/threadView.html', 			controller: 'threadCtrl'}); 
    $routeProvider.when('/thread/:id/:location/:moduleId/:highlight',	{templateUrl: 'partials/wall/threadView.html', 		controller: 'threadCtrl'});
    $routeProvider.when('/thread/:id/:location/:moduleId',	{templateUrl: 'partials/wall/threadView.html', 			controller: 'threadCtrl'});
    $routeProvider.when('/forum/:which/:open',	 		{templateUrl: 'partials/wall/forumView.html', 			controller: 'forumCtrl'}); 
    $routeProvider.when('/refresh/forum/:which/',	 	{templateUrl: 'partials/wall/forumView.html', 			controller: 'forumCtrl'}); 
   
    $routeProvider.when('/forum/:which',	 		{templateUrl: 'partials/wall/forumView.html', 			controller: 'forumCtrl'});
    $routeProvider.when('/forum/',	 			{templateUrl: 'partials/wall/forumView.html', 			controller: 'forumCtrl'});
    $routeProvider.when('/notifications/',	 		{templateUrl: 'partials/notifications/notificationsView.html', 	controller: 'notificationsCtrl'});
    $routeProvider.when('/notifications/:ids',	 		{templateUrl: 'partials/notifications/notificationsView.html', 	controller: 'notificationsCtrl'});
   
    $routeProvider.when('/notificationSettings/',	 			{templateUrl: 'partials/notifications/notificationSettingsView.html', 	controller: 'notificationSettingsCtrl'});
    $routeProvider.when('/notificationSettings/:highlight/',	 		{templateUrl: 'partials/notifications/notificationSettingsView.html', 	controller: 'notificationSettingsCtrl'});
    
    
    $routeProvider.when('/conversation/:conversationId',	{templateUrl: 'partials/conversations/conversationView.html', 	controller: 'conversationCtrl'});
    $routeProvider.when('/conversation/new/:username',		{templateUrl: 'partials/conversations/conversationView.html', 	controller: 'newConversationCtrl'});
    
    $routeProvider.when('/simulateDemo/:pid',	 		{templateUrl: 'partials/games/simulateDemoView.html', 		controller: 'simulateDemoCtrl'});
    $routeProvider.when('/simulatingDemo',			{templateUrl: 'partials/games/simulatingNow.html', 		controller: 'simulatingNowCtrl'});
    $routeProvider.when('/training/:pid',	 		{templateUrl: 'partials/player/trainingView.html', 		controller: 'trainingCtrl'});
    $routeProvider.when('/signup/',				{templateUrl: 'partials/account/signupView.html', 		controller: 'signupCtrl'});
    $routeProvider.when('/forgotten/',				{templateUrl: 'partials/account/forgottenView.html', 		controller: 'signupCtrl'});
    $routeProvider.when('/set_username/',			{templateUrl: 'partials/account/setUsernameView.html', 		controller: 'setUsernameCtrl'});
    $routeProvider.when('/language/',				{templateUrl: 'partials/language/languageView.html', 		controller: 'languageCtrl'});
    $routeProvider.when('/setFooterPosition/:height',		{templateUrl: 'partials/player/trainingView.html', 		controller: 'setFooterPositionCtrl'});
    
     
    $routeProvider.when('/logout/',				{templateUrl: 'partials/login.html', 				controller: 'logoutCtrl'});
    $routeProvider.when('/choose_team_to_buy/:leagueId',	{templateUrl: 'partials/cyberpoints/chooseTeamToBuy.html', 	controller: 'chooseTeamToBuyCtrl'});
    $routeProvider.when('/choose_team_to_buy/',			{templateUrl: 'partials/cyberpoints/chooseTeamToBuy.html', 	controller: 'chooseTeamToBuyCtrl'});   
    $routeProvider.when('/buy_team/:buyTeam',           	{templateUrl: 'partials/team/teamProfile.html',           	controller: 'teamProfileCtrl'});
    $routeProvider.when('/tournaments/',			{templateUrl: 'partials/competition/competitionListView.html', controller: 'tournamentsCtrl'});   
    
    $routeProvider.when('/cyberpoints/spend/:module/:playerId/:subModule',	{templateUrl: 'partials/cyberpoints/cyberpointsOptionView.html', 	controller: 'cyberpointsOptionCtrl'});
    $routeProvider.when('/cyberpoints/spend/:module/:playerId',	{templateUrl: 'partials/cyberpoints/cyberpointsOptionView.html', 	controller: 'cyberpointsOptionCtrl'});
    $routeProvider.when('/points/',				{templateUrl: 'partials/cyberpoints/cyberpointsSwitchView.html', 	controller: 'cyberpointsCtrl'});
    $routeProvider.when('/cyberpoints/',			{templateUrl: 'partials/cyberpoints/cyberpointsSwitchView.html', 	controller: 'cyberpointsCtrl'});
    $routeProvider.when('/cyberpoints/get/',			{templateUrl: 'partials/cyberpoints/cyberpointsGet.html', 		controller: 'cyberpointsGetCtrl'});
    $routeProvider.when('/cyberpoints/spend/',			{templateUrl: 'partials/cyberpoints/cyberpointsSpend.html', 		controller: 'cyberpointsSpendCtrl'});
    
    
    $routeProvider.when('/halloffame/',				{templateUrl: 'partials/hall/halloffameSwitch.html', 			controller: 'hallSwitchCtrl'});
    $routeProvider.when('/hall/',				{templateUrl: 'partials/hall/halloffameSwitch.html', 			controller: 'hallSwitchCtrl'});
    $routeProvider.when('/hall/:ranking',			{templateUrl: 'partials/hall/halloffame.html', 				controller: 'hallCtrl'});
    $routeProvider.when('/halloffame/:ranking',			{templateUrl: 'partials/hall/halloffame.html', 				controller: 'hallCtrl'});
    $routeProvider.when('/hall/:ranking/:rank',			{templateUrl: 'partials/hall/halloffame.html', 				controller: 'hallCtrl'});
    $routeProvider.when('/halloffame/:ranking/:rank',		{templateUrl: 'partials/hall/halloffame.html', 				controller: 'hallCtrl'});
    $routeProvider.when('/hall/:ranking/:rank/:rankType/:rankSubdivision',		{templateUrl: 'partials/hall/halloffame.html', 				controller: 'hallCtrl'});
    $routeProvider.when('/halloffame/:ranking/:rank/:rankType/:rankSubdivision',	{templateUrl: 'partials/hall/halloffame.html', 				controller: 'hallCtrl'});
   
    
    
    $routeProvider.when('/skillpointGoals/:idPlayer',	 	{templateUrl: 'partials/skillpoints/skillpointGoalsView.html', 	controller: 'skillpointGoalsCtrl'});
    $routeProvider.when('/country/:countryId/:country',	 	{templateUrl: 'partials/country/countryView.html', 		controller: 'countryCtrl'});   
    $routeProvider.when('/contract/:contractId',	 	{templateUrl: 'partials/player/contractView.html', 		controller: 'contractCtrl'});
    $routeProvider.when('/wc/',					{templateUrl: 'partials/wc/wcList.html', 			controller: 'wcCtrl'});
    $routeProvider.when('/wc/voting/:countryId',		{templateUrl: 'partials/wc/wcVoting.html', 			controller: 'wcVotingCtrl'});
    $routeProvider.when('/pickupgames/:teamId',			{templateUrl: 'partials/pickupgames/pickupGamesView.html', 	controller: 'pickupgamesCtrl'});
    $routeProvider.when('/pickupgames/:teamId/:clubType',			{templateUrl: 'partials/pickupgames/pickupGamesView.html', 	controller: 'pickupgamesCtrl'});
    
    $routeProvider.when('/user/:userId',	 		{templateUrl: 'partials/account/accountProfile.html', 		controller: 'accountProfileCtrl'});
    $routeProvider.when('/account/:username', 	 		{templateUrl: 'partials/account/accountProfile.html', 		controller: 'accountProfileCtrl'});
    
    $routeProvider.when('/skillpoints/:playerId/', 		{templateUrl: 'partials/skillpoints/assignSPParentTemplate.html', controller: 'skillpointsCtrl'  });
    $routeProvider.when('/player/create/', 			{templateUrl: 'partials/player/create.html', 			controller: 'playerCreateCtrl'});
    $routeProvider.when('/player/create/:superstar', 		{templateUrl: 'partials/player/create.html', 			controller: 'playerCreateCtrl'});
    
    $routeProvider.when('/competition/:type/:compId/:season/:fromPage/:crazyLink', 	{templateUrl: 'partials/competition/competitionView.html', 	controller: 'competitionCtrl'});
    $routeProvider.when('/competition/:type/:compId/:season', 	{templateUrl: 'partials/competition/competitionView.html', 	controller: 'competitionCtrl'});
    $routeProvider.when('/competition/:type/:compId', 		{templateUrl: 'partials/competition/competitionView.html', 	controller: 'competitionCtrl'});
     
    
    $routeProvider.when('/player/:playerId',  	 		{templateUrl: 'partials/player/playerProfile.html'	, 	controller: 'playerCtrl'});
    $routeProvider.when('/playerTactics/:playerId',   		{templateUrl: 'partials/player/playerTactics.html'	, 	controller: 'playerTacticsCtrl'});
    $routeProvider.when('/myPlayer/:playerId', 			{templateUrl: 'partials/player/myPlayer.html'		, 	controller: 'myPlayerCtrl'});
    $routeProvider.when('/confirm/:module/:id', 		{templateUrl: 'partials/confirm/confirmView.html'	, 	controller: 'confirmCtrl'});
    
    $routeProvider.when('/1on1/', 				{templateUrl: 'partials/oneOnOne/oneOnOneHome.html', 		controller: 'oneOnOne1on1Ctrl'});
    $routeProvider.when('/1on1/:idTournament/:season/:day',     {templateUrl: 'partials/oneOnOne/tournamentHome.html', 		controller: 'oneOnOneTournamentCtrl'});
    $routeProvider.when('/1on1/signup/', 			{templateUrl: 'partials/oneOnOne/oneOnOneSignup.html', 		controller: 'oneOnOne1on1SignupCtrl'});
    $routeProvider.when('/1on1/:gameId',     			{templateUrl: 'partials/oneOnOne/gameHome.html', 		controller: 'oneOnOne1on1GameCtrl'});
    $routeProvider.when('/1on1/:gameId/:gameName',     		{templateUrl: 'partials/oneOnOne/gameHome.html', 		controller: 'oneOnOne1on1GameCtrl'});
    $routeProvider.when('/simulateDemos/', 			{templateUrl: 'partials/games/demosList.html', 			controller: 'demosListCtrl'});
    $routeProvider.when('/skillpointsReceived/:idGame/:idPlayers', 	{templateUrl: 'partials/skillpoints/skillpointsReceived.html', 			controller: 'skillpointsReceivedCtrl'});
    $routeProvider.when('/question/:idQuestion',     		{templateUrl: 'partials/tutorial/tutorialQuestion.html', 		controller: 'tutorialQuestionCtrl'});
    $routeProvider.when('/tutorialQuestion/:idQuestion',     		{templateUrl: 'partials/tutorial/tutorialQuestion.html', 		controller: 'tutorialQuestionCtrl'});
     
    
    $routeProvider.otherwise({redirectTo: '/login'});
    
}])
.config(function ($compileProvider) {
        // http://msdn.microsoft.com/en-us/library/windows/apps/xaml/jj655406.aspx
        //
        //var whitelist = "https|x-wmapp0|ms-appx|ms-appx-web|ms-appdata|chrome-extension|http|file|ftp|blob|cdvfile|content|tel";

        // Whitelist the Windows Runtime URL schemes so Angular does not flag as 'unsafe'.
        //
        
        //$compileProvider.imgSrcSanitizationWhitelist(whitelist);
        //$compileProvider.aHrefSanitizationWhitelist(whitelist);
    }) 
.directive("outsideClick", ['$document','$parse', function( $document, $parse ){
    return {
        link: function( $scope, $element, $attributes ){
            var scopeExpression = $attributes.outsideClick,
                onDocumentClick = function(event){
                    var isChild = $element.find(event.target).length > 0;

                    if(!isChild) {
                        $scope.$apply(scopeExpression);
                    }
                };

            $document.on("click", onDocumentClick);

            $element.on('$destroy', function() {
                $document.off("click", onDocumentClick);
            });
        }
    }
}]) .directive('aDisabled', function() {
    return {
        compile: function(tElement, tAttrs, transclude) {
            //Disable ngClick
            tAttrs["ngClick"] = ("ng-click", "!("+tAttrs["aDisabled"]+") && ("+tAttrs["ngClick"]+")");

            //Toggle "disabled" to class when aDisabled becomes true
            return function (scope, iElement, iAttrs) {
                scope.$watch(iAttrs["aDisabled"], function(newValue) {
                    if (newValue !== undefined) {
                        iElement.toggleClass("disabled", newValue);
                    }
                });

                //Disable href on click
                iElement.on("click", function(e) {
                    if (scope.$eval(iAttrs["aDisabled"])) {
                        e.preventDefault();
                    }
                });
            };
        }
    };
})
.directive('backImg', function(){
    return function(scope, element, attrs){
        var url = attrs.backImg;
        element.css({
            'background-image': 'url(' + url +')',
             
        });
    };
}) 
.directive('schrollBottom', function () {
  return { 
    link: function (scope, element) {
    	
      scope.$watchCollection('schrollBottom', function (newValue) {
        if (newValue)
        {
          $(element).scrollTop($(element)[0].scrollHeight);
        }
      });
    }
  }
})
.directive('stopEvent', function () {
    return {
        restrict: 'A',
        link: function (scope, element, attr) {
            element.bind('click', function (e) {
            		  
                e.stopPropagation();
            });
        }
    };
 });
  


