'use strict';

angular.module('myApp.controllers', ['timer','ui.bootstrap'])
    .controller('MainCtrl', ['$scope', '$rootScope', '$window', '$location' ,'me','AJAX','liveGamesListener', 'tutorial','chat','ngDraggable', function ($scope, $rootScope, $window, $location ,me, AJAX, liveGamesListener, tutorial, chat,ngDraggable) {
    			    
        //controller gets hit before all the current controller. so define here whatever you`ll need sitewide
    	$scope.slide 		= '';
    
    	//console.log("root params="+me.getIso());
    	me.checkLanguage();
    
    	if( me.canSvg() != 1 )
    	{
    		loadjscssfile("css/png.css", "css");
    	}
        $scope.settings     	= me.getSettings();
        
        $scope.API   		= me;
        $scope.live 		= liveGamesListener.data; 
        $scope.popup		= {'open':'','searching':0,'searchString':'', searchItems: []};
        $scope.searching	= 0;
        $scope.liveListen	= liveGamesListener;
        $scope.tutorial		= tutorial;
        
        /* SET CHAT VARS && CONNECT */
        $scope.chat			= chat; 
        $scope.chat.setVar('textbox-class','hidden');
        if( !$scope.chat.isConnected() )
        	$scope.chat.socksConnect();
        $scope.chat.persistenSockConnection();
        $scope.chat.openChatJS();
        $scope.chat.setVar('chat-friends-list', 'hidden');
        $scope.chat.start();
        
        
        
       // $scope.chat.setVar('chat-friends-list', 'chat-friends-list inactive');
        //$scope.chat.load();
        
        //$scope.live.setScopePointer( $scope ); 
        //$scope.live.connect();
         
        $scope.tr		= function( text, vars){ 
        				return tr( text, vars);
        }; 
        
        
        $rootScope.back 	= function() {
        				$scope.API.clearErrors(); 
        				document.body.focus(); 
        				if( typeof $scope.API.backButton == 'undefined' )
        				{
        					$scope.slide = 'slide-right';
        					$window.history.back();
        				}
        				else
        					$scope.API.backButton(); 
        				
        }
        $rootScope.go = function(path, extra){
        	 
        				document.body.focus();
        				$scope.API.clearErrors();
        				$scope.slide = 'slide-left';
        				 
        				$location.url(path);
        				try{ $rootScope.$apply(); }catch(e){};
        				
        				if( typeof extra != 'undefined' )
        					$scope.popup		= {'open':''};
        }
        
        $rootScope.closeMenu = function(path){
        	 
        	$scope.popup.open = '';
        }
         
        //first visit / not loggedin?
   
        if( typeof me.getToken() == 'undefined'  )
        	$rootScope.go('login'); 
        else if( me.getToken() == "-1" ){
        $rootScope.go('login');}
        else if(  me.getToken() == '' )
        	$rootScope.go('login');
        else;
        
        
        
    }]) 
    .controller('playerCreateCtrl', ['$scope', '$routeParams', '$location', 'player', 'me', 'AJAX','$q','skillpoints', 'tutorial', function ($scope, $routeParams, $location, player, me ,AJAX,$q, skillpoints, tutorial) { 
    		
    		$scope.tutorial		= tutorial;
    		$scope.skillpoints	= skillpoints; 
    		$scope.settings		= { title: tr('New Player') }; 
    		$scope.data		= { 'skillpoints':8000, 'title':tr('New Player')};
    		  
    		$scope.form	    	= {step:'playerInfo', value:{},'help': skillpoints.getHelp('player_create'),'skills': me.get('skills')}; 
    		$scope.text  	    	= { 'skillpointsBalance': tr('Skillpoints (SP)'),'save':tr('Give him life'),'nextStep':tr('Set skills'),'type':tr('Player Type'),'weight':tr('Weight'), 'height':tr('Height'),'country':tr('Country of Origin'),'position':tr('Position'),'first_name':tr('First Name'), 'last_name':tr('Last Name')  }
    		$scope.text.error	= { 'first_name': {'short':tr('First name is too short'), 'long':tr('First name is too long')},'last_name': {'short':tr('Last name is too short'), 'long':tr('Last name is too long')}};
    		$scope.text.pos	    	= me.getPositionText();
    		$scope.text.playerType  = {playmaker: tr('Playmaker'), stealer: tr('Stealer'), hustleRebounder: tr('Hustle Rebounder'), hustleBlocker:tr('Hustle Blocker'), powerBlocker:tr('Power Blocker'), powerRebounder:tr('Power Rebounder'), slasher:tr('Slasher'), sharpshooter: tr('Sharpshooter'), insideForce:tr('Inside Force'), jumpShooter: tr('Jump Shooter')};
    		$scope.text.superstarCost= 2000;
    		$scope.player		= {};
    		
    		
    		
    		$scope.skillpoints.setLocation( $location );
    		$scope.skillpoints.setScope( $scope );
    		console.log("BALANCE>>>>>"+skillpoints.getBalance( )+" me.get = "+ me.getSkillpoints( $scope.API.getDay() )+" <<< ");
    		$scope.skillpoints.setBalance( me.getSkillpoints( $scope.API.getDay() ) );  
    		if( $routeParams.superstar == 'superstar' )
    		{
    			$scope.form.superstar   = 1;
    			$scope.player.superstar = 1;
    			$scope.data.skillpoints = 10000;	
    			
    		}
    		else{ 
    			$scope.form.superstar = 0;
    			$scope.player.superstar = 0;
    		}
    		$scope.skillpoints.setBalance( me.getSkillpoints(  $scope.API.getDay(),$scope.form.superstar ) ); 
    		$scope.skillpoints.setPlayerType( 'Jump Shooter' );
    		$scope.skillpoints.setFormType( 'createPlayer' );
    		$scope.form.save 	= function( trash, form  ){  $scope.skillpoints.save( $scope, form ); };
    		
    }]) 
    .controller('skillpointsCtrl', ['$scope', '$routeParams', '$location', 'player', 'me', 'AJAX','$q','skillpoints', 'tutorial', function ($scope, $routeParams, $location, player, me ,AJAX,$q, skillpoints, tutorial) { 
    		
    		$scope.tutorial		= tutorial;
    		$scope.form	    	= {step:'skillpoints', help: skillpoints.getHelp('skillpoints'), value:{},'skills': me.get('skills')}; 
    		$scope.text  	    	= { 'skillpointsBalance': tr('Skillpoints (SP)'),'save':tr('Assign Skillpoints') }; 
    		$scope.data 		= {};
    		//once the info has been gathered from the database
    		$scope.$watch('data.fields.skillpoints', function() { 
    			 
    			$scope.skillpoints	= skillpoints; 	
    			$scope.skillpoints.setFormType( 'skillpoints' );
    			$scope.skillpoints.setScope( $scope );	
    			$scope.form.save 	= function(){  $scope.skillpoints.save( ); };
    			
    			$scope.form.save 	= function(){ $scope.skillpoints.save( $scope, $scope.player ); };
    			$scope.skillpoints.setBalance( $scope.data.fields.skillpoints );
    			$scope.skillpoints.setLocation( $location );
    			 
    			$scope.skillpoints.setSkills( $scope.data.skills );
    			for( var sk in $scope.data.skills )
    			{  
    				$scope.skillpoints.setBoosted( sk, 0 );
    				$scope.skillpoints.setSkill( sk, parseInt( $scope.data.skills[sk] ) );
    			}
    			
    		});
    		
    		player.get( 'skillpoints', $routeParams.playerId, $scope, 'REST' );
    }])
    .controller('chooseDraftTeamCtrl', ['$scope', '$routeParams', '$location', 'player', 'me', 'AJAX','$q','draft','tutorial', function ($scope, $routeParams, $location, player, me ,AJAX,$q, draft, tutorial) { 
    		//when drafting after you've chosen a league, when it is time to choose a team to draft into
    		 
    		$scope.tutorial		= tutorial;
    		
    		
    		$scope.crazyLink	= $routeParams.playerId+'-'+$routeParams.pos+'-'+$routeParams.leagueId+'-'+$routeParams.timestamp+'-'+$routeParams.simtime+'-'+$routeParams.human;
    		$scope.form		= {totalAvailableHere:0,help: draft.getHelp('teams'), fromPage:'' };
    		if( $routeParams.fromPage ) $scope.form.fromPage = $routeParams.fromPage;  
    		$scope.data		= { title:tr('Choose Team'),hidden:0,player:{pos:$routeParams.pos,id: $routeParams.playerId},league:{id:$routeParams.leagueId,human:$routeParams.human,time:$scope.API.getTime( $routeParams.timestamp ),simtime:$routeParams.simtime} };   		
    		$scope.draft		= draft;
    		$scope.text		= { draft:tr('Draft'),'chooseTeam':tr('Choose team'),'andDraft':tr('And Draft'), 'viewLeague':tr('View League'), 'place':tr('League Position'),'humans':tr('Human Players') };
    		
		draft.getTeams( $scope.data.league.id, $scope );  
    		
    }]) 
    .controller('newCompetitionsCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','comp','wall', function ($scope, $routeParams, player, me ,AJAX, comp,wall ) {		
    		comp.setScopePointer( $scope );
    		$scope.comp = comp;
    		$scope.getCompetitionsSetup( $routeParams.day );
    }])
    .controller('draftCtrl', ['$scope', '$routeParams', '$location', 'player', 'me', 'AJAX','$q','draft','tutorial', function ($scope, $routeParams, $location, player, me ,AJAX,$q, draft, tutorial) { 
    		//when drafting first VIEW -> choosing a league
    		$scope.tutorial		= tutorial;    
    		$scope.data		= {title:tr('Choose League')};
    		$scope.form		= {added:0, help: draft.getHelp('leagues') };
    		$scope.draft		= draft;  
    		$scope.draft.setScopePointer( $scope );
    		$scope.text		= {already:tr('This player is already signed to a team. You can not draft into another team while under contract.')}; 

		
    		/*
    		me.get('myTeams').then( function( response ){$scope.myTeams = response;} );
    		$scope.$watch('data.fields.pos', function() { 
    			 
    			if( $scope.data.fields.id_club == 0 )
    			{
    				console.log("aici???");
				draft.getLeagues( $scope.data.career.career, $scope, $scope.data.fields.id );
				$scope.text	= {'league_draft':tr('LEAGUE NAME & SIMTIME'),'pos':tr('DRAFTING SPOTS @ {pos}',$scope.data.fields)};
			}
		});*/
		
		 
    		player.get( 'draft', $routeParams.playerId, $scope, 'noRest' );  
    		
    }]) 
    .controller('equipmentCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','equipment', function ($scope, $routeParams, player, me ,AJAX, equipment ) { 
    		//equipment VIEW 
    		$scope.form	 = {'class':'', help: equipment.getHelp('player') };
    		$scope.data	 = {title:tr('Equipment')}; 
    		$scope.clickedSomewhereElse = function(){ 
    			if( $scope.form.class == 'active' ) 
    				$scope.form.class = 'not-active'; 
    		};
    		
    		 
    		$scope.text	 = {unequip:tr('Unequip'),custom:tr('Create signature equipment'),inventory:tr('Equip from inventory'),buy:tr('Buy from store')};
    		$scope.equipment = equipment;
    		$scope.equipment.init();
    		$scope.equipped = equipment.getEquipped();
    		$scope.equipment.getInventory( $routeParams.playerId, $scope  );  	   
    }])
    .controller('equipmentStoreCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','equipment', function ($scope, $routeParams, player, me ,AJAX, equipment ) { 
    		$scope.data	 	= {title:tr('Equipment Store')}; 
    		$scope.data.title	= tr('Equipment Store');
    		$scope.equipped 	= {};
    		$scope.form	 	= {'class':'', help: equipment.getHelp('store')};
    		$scope.filter		= '';
    		$scope.clickedSomewhereElse = function(){ 
			if( $scope.form.class == 'active' ) 
				$scope.form.class = 'not-active'; 
		};
    		$scope.text	 	= {'buy_equip':tr('BUY & EQUIP'),'buyUsing':tr('BUY USING CASH FROM ALL MY PLAYERS'),'cancel':tr('CANCEL'),shoes:tr('Buying <b>shoes</b> for <b>{first_name} {last_name}</b> (${cash})'),accessory:tr('Buying <b>accessory</b> for <b>{first_name} {last_name}</b> (${cash})'), 'under clothing':tr('Buying <b>under clothing</b> for <b>{first_name} {last_name}</b> (${cash})'),filter:tr('Filter by Skill')};
    		$scope.text.intro	= $scope.text[$routeParams.itemType];
    		$scope.equipment 	= equipment;
    		$scope.equipment.init();
    		$scope.equipment.getStore( $routeParams.playerId,$routeParams.itemType, $scope  );  			
    }])
    .controller('teamProfileCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','team','wall','cyberpoints', function ($scope, $routeParams, player, me ,AJAX, team,wall, cyberpoints ) { 
    		//team profile VIEW   
    		$scope.form	 = {'addingMSG':[],modelHistory: 0, optionsHistory: [] };
    		if( typeof $routeParams.buyTeam != 'undefined' )
    		{
    			$routeParams.teamId = $routeParams.buyTeam;
    			$scope.form.buyTeam = 1;
    			var v 		    = {};
    			v['num'] 	    = 2;
    			$scope.form.buy_2   = tr('Buy team for {num} seasons',v);
    			v['num'] 	    = 3;
    			$scope.form.buy_3   = tr('Buy team for {num} seasons',v);
    			$scope.buyTeam 	    = function( clubId, seasons )
    			{
    				cyberpoints.setScope( $scope );
    				cyberpoints.buyTeam( clubId, seasons);
    			};
    		}
    		$scope.text	 = {wall:tr('Private Wall'),expiration:tr('Owned until'),cash:tr('Cash'),career:tr('Career stage'),posValue:tr('POS & VAL'),playerUser:tr('PLAYER & USER'),teamAndPos:tr('TEAM & POSITION'), victories: tr('WIN'), losses:tr('L'),manager:tr('Manager'),league:tr('League'),awards:tr('Awards'),teamStats:tr('Team Stats'),playerStats:tr('Player Stats'),lineup:tr('Lineup'),matches:tr('Recent & Upcoming Games'),'points': tr('PTS'), 'assists':tr('AST'),'minutes':tr('MIN'),'fouls':tr('FLS'),'steals':tr('STL'),'blocks':tr('BLK'),'rebounds':tr('REB')};
    		$scope.data	 = {positionText:tr('Standing in their league')}; 
    		$scope.team 	 = team;  
    		
    		
    		$scope.wall	 = wall;
    		$scope.wall.init( $scope );
    		$scope.wall.setId( $routeParams.teamId );
    		$scope.wall.setType( 25 );
    		$scope.API.setForm('wall',1);
    		$scope.API.setForm('story',1);
    		$scope.filter	 = '-stats.points'; 
    		$scope.form.howStats  = 'per_game'; 
    		$scope.team.get( $routeParams.teamId, $scope, $routeParams.season  );  
    }])
    .controller('countryCtrl', ['$scope','$routeParams','me','AJAX','country','wall', function( $scope, $routeParams, me, AJAX, country, wall ){
    		 
    	    	$scope.form	 = {'help': country.getHelp('country'),id_country:$routeParams.countryId, 'addingMSG':[],modelHistory: 0, optionsHistory: [] };
    	    	$scope.data 	 = {title: $routeParams.country};
    	    	$scope.text	 = {wall:tr('Wall')};
    		$scope.wall	 = wall;
    		$scope.wall.init( $scope );
    		$scope.wall.setId( $routeParams.countryId );
    		$scope.wall.setType( 24 );
    		$scope.API.setForm('wall',1);   
    		$scope.country   = country;
    		country.get( $routeParams.countryId, $scope );
    		//$scope.wall.get( $routeParams.countryId, 24, $scope);  	    	    
    }])
    .controller('wcCtrl', ['$scope','$routeParams','me','AJAX','wc', function( $scope, $routeParams, me, AJAX, wc ){
    		  
    		$scope.form	 = {'help': wc.getHelp('wcSwitch') };
    		$scope.wc = wc;
    		$scope.wc.setPage( 'switch' );
    		$scope.v  = { num: me.get('season') };
    		wc.get( $scope );  	    	    
    }]) 
    .controller('wcVotingCtrl', ['$scope','$routeParams','me','AJAX','wc', function( $scope, $routeParams, me, AJAX, wc ){
    		  
    		$scope.form	 = {countryOptions:[],selectCountry:{},'help': wc.getHelp('wcSwitch') };
    		$scope.wc = wc;
    		$scope.v  = { num: me.get('season') };
    		$scope.wc.setPage( 'voting' );
    		$scope.wc.setIdCountry( $routeParams.countryId );
    		wc.getVoting( $routeParams.countryId,  $scope );  	    	    
    }])
    .controller('pickupgamesCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','team','wall', 'pickupGames','manageTeam', function ($scope, $routeParams, player, me ,AJAX, team,wall,pickupGames,manageTeam ) { 
    
    		
    		$scope.manage 	   = manageTeam;
    		$scope.pickupGames = pickupGames;
    		$scope.form	   = { sendPassword:'',sim:{}, games:'',password:'', noPassword:0,filter:{},filterOptions:[],  help: pickupGames.getHelp(), 'status':'list','class':'not-active',id_item:0,'addingMSG':[],modelHistory: 0, optionsHistory: [] };
    		$scope.filter	   = {};
    		$scope.playWith	   = {};
    		$scope.manage.setId( $routeParams.teamId );
    		$scope.manage.setScope( $scope );
    		$scope.pickupGames.get( $routeParams.teamId, $scope,  $routeParams.clubType );
    			    
    	//pickupgames
    }])
    .controller('oneOnOne1on1Ctrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','oneOnOne', function ($scope, $routeParams, player, me ,AJAX, oneOnOne ) { 
    
    		$scope.obj 	   = oneOnOne;
    		$scope.data  	   = {title: tr('1on1')};
    		$scope.form	   = {optionsHistory:[],selectedHistory:{},help: $scope.obj.getHelp('home')};
    		$scope.filter	   = {};
    		$scope.obj.setIdAccount( me.get('id_account') );  
    		$scope.obj.get( $scope ); 
    }]) 
    .controller('oneOnOne1on1GameCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','oneOnOne', function ($scope, $routeParams, player, me ,AJAX, oneOnOne ) { 
    
    		$scope.obj 	   = oneOnOne;
    		
    		$scope.form	   = {help:$scope.obj.getHelp('game'),optionsHistory:[],selectedHistory:{},title: $routeParams.gameName};
    		$scope.filter	   = {};
    		me.setForm('pbp',1);
    		me.setForm('stats',1);
    		$scope.obj.setIdAccount( me.get('id_account') );  
    		$scope.obj.getGame( $scope, $routeParams.gameId ); 	    
    }])
    .controller('oneOnOne1on1SignupCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','oneOnOne', function ($scope, $routeParams, player, me ,AJAX, oneOnOne ) { 
    
    		$scope.obj 	   = oneOnOne;
    		$scope.player	   = player;
    		$scope.data  	   = {title: tr('Signup')};
    		$scope.form	   = { help: $scope.obj.getHelp('signup'),types:{},shooting:{},selected:{},options:{},status:'form'};
    		$scope.form.shootingQuickset	   = [{value:0,name:tr('Quickset')},{value:'3pt_shooting',name:tr('3PT @ 90%')},{value:'inside_shooting',name:tr('INSIDE @ 90%')},{value:'floor_shooting',name:tr('MID RANGE @ 90%')}];
    		$scope.model	   = {types:{},shooting: {}, shootingQuickset:$scope.form.shootingQuickset[0]};  		
    		$scope.filter	   = {};
    		$scope.obj.getSignup( $scope ); 
    }]) 
    .controller('oneOnOneTournamentCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','oneOnOne', function ($scope, $routeParams, player, me ,AJAX, oneOnOne ) { 
     
    		$scope.obj 	   = oneOnOne; 
    		$scope.form	   = { help:$scope.obj.getHelp('tournament'), season:$routeParams.season, ziua:$routeParams.day   };
    		$scope.filter	   = {};
    		$scope.obj.setSeason( $routeParams.season );
    		$scope.obj.setDay(    $routeParams.day    );
    		$scope.obj.setIdAccount( me.get('id_account') );
    		$scope.obj.ajaxTournament( $routeParams.idTournament, $scope );
    }]) 
    .controller('manageTeamCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','team','wall', 'manageTeam', 'games','allstar', function ($scope, $routeParams, player, me ,AJAX, team,wall,manageTeam,game,allstar ) { 
    		//MANAGE TEAM VIEW GENERATED HERE ;)
    		$scope.manage 	 = manageTeam;
    		$scope.allstar	 = allstar;
    		$scope.game	 	 = game;
    		$scope.allstar.setVar( 'prev-draft', 0 );
    		$scope.allstar.setVar( 'next-draft', 0 );
    		$scope.selectTeam = [];
    		$scope.text	 = {wall:tr('Private Wall'),expiration:tr('Owned until'),cash:tr('Cash'),career:tr('Career stage'),posValue:tr('POS & VAL'),playerUser:tr('PLAYER & USER'),teamAndPos:tr('TEAM & POSITION'), victories: tr('WIN'), losses:tr('L'),manager:tr('Manager'),league:tr('League'),awards:tr('Awards'),teamStats:tr('Team Stats'),playerStats:tr('Player Stats'),lineup:tr('Lineup'),matches:tr('Games'),'points': tr('PTS'), 'assists':tr('AST'),'minutes':tr('MIN'),'fouls':tr('FLS'),'steals':tr('STL'),'blocks':tr('BLK'),'rebounds':tr('REB')};
    		$scope.data	 = {positionText:tr('Standing in their league')}; 
    		$scope.promotionOptions = [];
    		$scope.selectPromotion  = [];
    		$scope.teamClass 	= team; 
    		$scope.teamClass.setScope( $scope );
    		$scope.allstar.setScope( $scope );
    		$scope.newName   	= '';
    		 
    		
    		var rndList = {};
    		for(var i=1;i<=15;i++)
    			rndList[i] = tr('Round {runda}',{'runda':i});
    		
    		$scope.form	   		= {selectTeam:{},draftRounds:rndList, andPos:{value:0}, userList: [], playerSearchOption: [], countryOptions:[],selectCountry:{}, promotesTo:0,help: team.getHelp('manageTeam'), 'newName':'', 'status':'form','class':'not-active',id_item:0,'addingMSG':[],modelHistory: 0, optionsHistory: [] };
    		$scope.form.allstarSort 	= manageTeam.getAllStarSort();
    		$scope.form.allstarSortValue 	= $scope.form.allstarSort[0];
    		
    		var countries	   = me.get('countries');
    		var item	   = {};
    		for( var i in countries )
    		{
    			item       = {};
    			item.value = i;
    			item.name  = countries[i];
    			$scope.form.countryOptions.push(item);
    		}
    		$scope.wall	   = wall;
    		$scope.wall.init( $scope );
    		$scope.wall.setId( $routeParams.teamId );
    		$scope.wall.setType( 25 );
    	
    		$scope.API.setForm('wall',1);
    		$scope.API.setForm('story',1);
    		$scope.filter	 = '-stats.points'; 
    		$scope.howStats  = 'per_game'; 
    		$scope.manage.setPointer( $scope );
    		$scope.manage.get( $routeParams.teamId, $scope, $routeParams.season  );   
    }])
    .controller('signOwnPlayersCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','team','wall', 'manageTeam', function ($scope, $routeParams, player, me ,AJAX, team,wall,manageTeam ) { 
    		$scope.data	      = {};
    		$scope.teamId	      = $routeParams.teamId;
    		manageTeam.setPointer( $scope );
    		manageTeam.setId( $routeParams.teamId );
    		 
    		me.get('myTeams').then( function( response ){ $scope.teams = response; manageTeam.loadTeam( 'team' ); } );
    		me.get('myPlayers').then( function( response ){ $scope.data.players = response;} );
    		 
    		$scope.data.title     = tr('Sign your own players');
    }])
    .controller('offerContractCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','team','wall', 'manageTeam', function ($scope, $routeParams, player, me ,AJAX, team,wall,manageTeam ) { 
    		$scope.manage 	 	= manageTeam;
    		$scope.API.setForm('misc',1); 
    		$scope.API.setForm('contractDuration',1); 
    		$scope.API.setForm('cashToPlayer',1);
    		$scope.API.setForm('cashToTeam',1);
    		$scope.v 		= {};
    		$scope.data 		= {};
    		$scope.form		= {help: player.getHelp('contract_offer') };
    		$scope.getHelp	    = function( which, what ){ return player.getHelp( which, what ); };
    		
    		$scope.offer 		= {'autoAccept':true,'release_clause':'play/2', end_season: parseInt(me.get('season'))+1, end_day:1};
    		$scope.manage.getOfferInfo( $routeParams.playerId, $routeParams.teamid, $routeParams.type, $scope ); 
    }])
    .controller('languageCtrl', ['$scope', '$routeParams', 'me', 'AJAX', function ($scope, $routeParams, me ,AJAX, player) { 
    		$scope.setLanguage = function( iso )
    		{ 
    			$scope.API.setLanguage( iso, function()
    			{ 
    				$scope.go('/login/'); 
    			});
    			
    		}
    }])
    .controller('eventsCtrl', ['$scope', '$routeParams', 'me', 'AJAX', 'events', 'wall', function ($scope, $routeParams, me ,AJAX, events, wall) { 
    		$scope.events = events; 
    		$scope.form   = {event:  $routeParams.which ,'addingMSG':[],viewingComments:[],commentViewerOptions:[]};
    		$scope.API.setForm('wall',1);
    		$scope.text		= {wall:tr('Discuss')};
    		
    		$scope.wall 		= wall; 
    		$scope.wall.setCanPost( 0 );
    		$scope.wall.setPointer( $scope );
    		events.get( $routeParams.which, $scope );
    }])	
    .controller('auctionCtrl', ['$scope', '$routeParams', 'me', 'AJAX', 'events', function ($scope, $routeParams, me ,AJAX, events) { 
    		
    		$scope.events = events; 
    		$scope.form   = {idAuction: $routeParams.id, amount:0, madeBid:0};
    		events.getAuction( $routeParams.id, $scope );
    }])
    .controller('setLanguageCtrl', ['$scope', '$routeParams', 'me', 'AJAX', function ($scope, $routeParams, me ,AJAX) { 
    		console.log("current language="+me.getIso());
     		me.setLanguage(  $routeParams.iso, function(){window.SC().go('new-language-set');} );
    }])
    .controller('contractCtrl', ['$scope', '$routeParams', 'me', 'AJAX','player', function ($scope, $routeParams, me ,AJAX, player) { 
    	
    		$scope.player 	 	= player; 
    		$scope.form		= {help: player.getHelp('contract') };
    		$scope.data		= {title:tr('Offer')};
    		$scope.API.setForm( 'releaseClause', 1 		);
    		$scope.API.setForm( 'contractDuration', 1 	);
    		$scope.API.setForm( 'cashToPlayer', 1 		);
    		$scope.API.setForm( 'cashToTeam', 1 		);
    		$scope.player.getContract( $routeParams.contractId, $scope );  
    }]) 
    .controller('conversationCtrl', ['$scope', '$routeParams', '$location', 'me', 'AJAX','conversations', function ($scope, $routeParams, $location, me ,AJAX, conversations) { 
    			    
    		$scope.conversation 	= conversations; 
    		$scope.data		= {title:tr('Conversation'),messages:[]}; 
    		//$location.hash( 'bottom' );
    		$scope.conversation.getConversation( $routeParams.conversationId, $scope );   
    }])
    .controller('newConversationCtrl', ['$scope', '$routeParams', '$location', 'me', 'AJAX','conversations', function ($scope, $routeParams, $location, me ,AJAX, conversations) { 
    			    
    		$scope.conversation 	= conversations; 
    		$scope.data		= {title:tr('Conversation'),messages:[]}; 
    		//$location.hash( 'bottom' );
    		$scope.conversation.clearUsers();
    		$scope.conversation.setConversationId( 'new' );
    		$scope.conversation.addUser( $routeParams.username );
    		$scope.conversation.setScope( $scope );  
    		
    }])
    .controller('threadCtrl', ['$scope', '$routeParams', '$location', 'me', 'AJAX', 'wall', function ($scope, $routeParams, $location, me ,AJAX, wall) { 
    	
    		$scope.wall 		= wall; 
    		$scope.data		= {title:tr('Thread'),disableLoadMore:1,hideLoadMore:1}; 
    		$scope.form		= {'addingMSG':[],viewingComments:[],commentViewerOptions:[]};
    		$scope.text		= {wall:''};
    		if( typeof $routeParams.highlight != 'undefined' )
    			$scope.form.highlight = $routeParams.highlight;
    		$scope.API.setForm('wall',1);
    		$scope.wall.getThread( $routeParams.id, $routeParams.location, $routeParams.moduleId, $scope );  
    }])
    .controller('teamTacticsCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','team','wall', 'manageTeam', function ($scope, $routeParams, player, me ,AJAX, team,wall,manageTeam ) { 
    		$scope.manage 	 	= manageTeam;
    		$scope.getHelp	    	= function( which, what ){ return team.getHelp( which, what ); };
    		$scope.playerAPI	= player;
    		$scope.data 		= {};
    		$scope.form		= {status: 'form', q:1, pos:'SG','help':team.getHelp('tactics')};
    		$scope.restrictable	= [];
    		$scope.changes		= 0;
    		$scope.sharingOptions 	= {};
    		$scope.sharingModel	= {};
    		$scope.manage.setId( $routeParams.teamId );
    		$scope.manage.getTacticsInfo( $routeParams.teamId, $scope );  
    }]) 
     .controller('playerSearchCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','team','wall', 'manageTeam', function ($scope, $routeParams, player, me ,AJAX, team,wall,manageTeam ) { 
    		$scope.manage 	 	= manageTeam;	
    		 
    		$scope.playerAPI	= player;
    		$scope.form		= {help: team.getHelp('playerSearch')};
    		$scope.data 		= {}; 
    		$scope.sortOptions 	= {};
    		$scope.sortModel	= {};
    		$scope.manage.getPlayerSearch( $routeParams.teamId, $scope );  
    }])  
    .controller('competitionCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','comp','wall', function ($scope, $routeParams, player, me ,AJAX, comp,wall ) { 
    		//competition profile VIEW   
    		$scope.page		= 'competition';
    		$scope.isNumber		= angular.isNumber; 
    		$scope.comp 	 	= comp;  
    		$scope.wall		= wall; 
    		$scope.wall.init( $scope );
    		$scope.wall.setId( $routeParams.compId );
    		$scope.wall.setType( $routeParams.type );
    		$scope.form		= {help: comp.getHelp('page'),'addingMSG':[],type:$routeParams.type,season:(typeof $routeParams.season != 'undefined' ? $routeParams.season : me.get('season') ) };
    		$scope.parseInt		= function( num ){ return parseInt( num ); }; 
    		
    		if( typeof $routeParams.crazyLink != 'undefined' ){
    			var crazyLink = $routeParams.crazyLink.split("-");
    			 
    			$scope.form.crazyLink = '';
    			var text = '';
    			for( var i in crazyLink ){
    				$scope.form.crazyLink += text + crazyLink[i];
    				text		  = '/';	
    			}
    			$scope.form.pid = crazyLink[0];
    		}
    		$scope.API.setForm('wall',1);
    		$scope.data	 	= {};
    		$scope.knockSelector 	= [];
    		$scope.fromPage		= $routeParams.fromPage;
    		$scope.loading	 	= {next_round:0,last_round:0};
    		$scope.selector	 	= { model: {'last_round':[],'next_round':[],'previousSeasons':[], 'allstar_manager': []}, options: {'last_round':[],'next_round':[],'previousSeasons':[], 'allstar_manager': []}};
    		
    		$scope.text	 	= { wall:tr('Wall'),points:tr('Leaders in Points'), rebounds:tr('Leaders in Rebounds'), blocks: tr('Leaders in Blocks'), steals:tr('Leaders in Steals'), assists:tr('Leaders in Assists')};
    		$scope.comp.get( $routeParams.type, $routeParams.compId, $scope,$routeParams.season  );
   		
    }])
    .controller('chooseTeamToBuyCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','comp', function ($scope, $routeParams, player, me ,AJAX, comp ) { 
    		
    		if( typeof $routeParams.leagueId == 'undefined' )
    		{
    			$scope.form		= { step:1, page:'chooseTeam', options: {careerList: []}, careerSelection: {} };
			$scope.data		= {title: tr('Choose a league') };
			$scope.API.setForm('leagues',1);  
			$scope.comp		= comp;
			comp.setPage( 'leagues' ); 
			comp.getList(  1, $scope );
			comp.createSelectOption( 1 );
		}
		else
		{
			$scope.text		= { 'place':tr('League Position'),'humans':tr('Human Players') };
			$scope.data		= { id_league: $routeParams.leagueId,'cost': 1000, title: tr('Choose a team') };
			$scope.form		= { step:2, page:'chooseTeam', help:comp.getHelp('buy')  };
			comp.getTeamList(  $routeParams.leagueId, $scope );
		}
    }])
    .controller('tournamentsCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','comp', function ($scope, $routeParams, player, me ,AJAX, comp ) { 
    		 
    		$scope.page		= 'tournaments';
    		$scope.form		= { page:'tournaments', options: {careerList: []}, careerSelection: {} };
		$scope.data		= { title:tr('My Tournaments'),hidden:0,player:{pos:$routeParams.pos,id: $routeParams.playerId},league:{id:$routeParams.leagueId,human:$routeParams.human,time:$scope.API.getTime( $routeParams.timestamp ),simtime:$routeParams.simtime} };   		
		$scope.comp		= comp;
    		$scope.text		= { draft:tr('Draft'),'chooseTeam':tr('Choose team'),'andDraft':tr('And Draft'), 'viewLeague':tr('View League'), 'place':tr('League Position'),'humans':tr('Human Players') };
    		comp.setPage( 'tournaments' );
    		$scope.API.setForm('leagues',1);  
    		
		comp.getList(  'mine', $scope );
		comp.createSelectOption( 'mine' );
    		
    }]) 
    .controller('accountProfileCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','account','wall', function ($scope, $routeParams, player, me ,AJAX, account,wall ) { 
  
    		$scope.account 	 	= account;  
    		$scope.wall		= wall;
    		$scope.text		= {wall:tr('Wall')};
    		$scope.data		= {};
    		$scope.count            = {'awards':0,'players':0,'clubs':0};
    		$scope.wall.init( $scope );
    		if( typeof $routeParams.userId != 'undefined' )
    			$scope.wall.setId( $routeParams.userId );  		
    		$scope.wall.setType( 99 );
    		$scope.form		= {'addingMSG':[], 'help': account.getHelp( 'profile' ) };
    		$scope.API.setForm('wall',1); 
    		$scope.account.setType( 'profile' );
    		 
    		$scope.account.get( $routeParams.userId, $routeParams.username, $scope  );		
    }])
    
    .controller('inventoryCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','equipment', function ($scope, $routeParams, player, me ,AJAX, equipment ) { 
    		//equipment VIEW 
    		
    		$scope.data		= {title:tr('Account inventory')}; 
    		$scope.equipped		= {};
    		$scope.form		= { help: equipment.getHelp('inventory'), id_item:0, class:'not-active', added:0, itemType:$routeParams.itemType };
    		$scope.filter		= '';
    		$scope.text		= {sell:tr('Sell'),'cancel':tr('Cancel'), 'equip':tr('equip'),none:tr('None of your players have any equipment'),filter:tr('Filter by Skill')};
    		 
    		
    		$scope.equipment 	= equipment;   
    		$scope.equipment.init();
    		$scope.equipment.getAccountInventory( $routeParams.itemType,$routeParams.playerId,  $scope  );  	
 
    }])
    .controller('playerCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','$q', 'team', function ($scope, $routeParams, player, me ,AJAX,$q, team) { 
    		//My Crib equivalent
    		
    		$scope.timerRunning = true;
    		$scope.text  	    = { 'needTeam':tr("You don't have a team"),'draft':tr('Draft Now'),'contract':tr('Contract'),'manager':tr('Manager'),'league':tr('League'),'team':tr('Team'),'score': tr('SCORE'),'points': tr('PTS'), 'assists':tr('AST'),'minutes':tr('MIN'),'fouls':tr('FLS'),'steals':tr('STL'),'blocks':tr('BLK'),'rebounds':tr('REB'), 'days':tr('days'), 'day' : tr('day'), 'at': tr('@'), 'vs' : tr('vs'), 'W' : tr('W'), 'L' : tr('L'), 'skillpoints' : tr('Skillpoints'), 'equipment' : tr('Equipment'), 'tactics' : tr('Tactics'), 'simulatedemo' : tr('Simulate Demo') };
    		$scope.API   	    = me;
    		$scope.form	    = { 'help': player.getHelp( 'profile' ) };
    		$scope.team	    = team;
    		$scope.getHelp	    = function( which, what ){ return player.getHelp( which, what ); };
    		$scope.form.statsFilter  = [];
    		$scope.form.statsFilter.push( {name: tr('Sort by'), value: '' } );
    		$scope.form.statsFilter.push( {name: tr('Points'), value: '-points' } );
    		$scope.form.statsFilter.push( {name: tr('Assists'), value: '-assists' } );
    		$scope.form.statsFilter.push( {name: tr('Blocks'), value: '-blocks' } );
    		$scope.form.statsFilter.push( {name: tr('Steals'), value: '-steals' } );
    		$scope.form.statsFilter.push( {name: tr('Rebounds'), value: '-rebounds' } );
    		$scope.form.statsFilter.push( {name: tr('Fouls'), value: '-fouls' } );
    		$scope.form.statsFilter.push( {name: tr('Minutes'), value: '-minutes' } );
    		$scope.form.statsFilter.push( {name: tr('Season'), value: '-season' } );
    		$scope.filter	    = $scope.form.statsFilter[0]; 
    		 
    			
    		//apparently this is 'bad practice'. $scope is updated and given AJAX promises inside the model.
    		player.get( 'playerProfile', $routeParams.playerId, $scope );    		 
    }])   
    .controller('playerTacticsCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','$q', 'team', 'tutorial', function ($scope, $routeParams, player, me ,AJAX,$q, team, tutorial) { 
    		//Player Tactics !
    		$scope.API   	      = me;
    		$scope.player	      = player;
    		 
    		$scope.form	      = { model: {}, options: {}, help: player.getHelp( 'tactics' ) };				  
    		$scope.form.model     = { play_intensity: [], play_style: [], off_the_ball_d: [], defensive_bonus: [] };
    		$scope.form.options   = { play_intensity: [], play_style: [], off_the_ball_d: [], defensive_bonus: [] };
    		$scope.form.model.passing_preferences   = {};
    		$scope.form.options.passing_preferences = {};
    		$scope.form.model.shooting_parameters 	= {};
    		$scope.form.options.shooting_parameters = {};
    		$scope.form.options.tacticsType   = [];
                $scope.form.options.tacticsType.push( {name:tr('Club Tactics'),value:'club'} );
                $scope.form.options.tacticsType.push( {name:tr('National team tactics'),value:'national'} );
                $scope.form.options.tacticsType.push( {name:tr('Allstar team tactics') ,value:'allstar'}  );
                $scope.form.model.tacticsType = $scope.form.options.tacticsType[0];	
    		
            $scope.form.copyThese       = false;
            $scope.player.setScope( $scope );
    		$scope.player.setTacticsType( 'club' );
    		
    		 
    		 
    		//apparently this is 'bad practice'. $scope is updated and given AJAX promises inside the model.
    		player.getTactics( $routeParams.playerId, $scope ); 
    		
    }])  
    .controller('myPlayerCtrl', ['$scope', '$routeParams', 'player', 'me', 'AJAX','$q','tutorial', '$location', function ($scope, $routeParams, player, me ,AJAX,$q,tutorial, $location) { 
    		//My Crib equivalent
    		 
    		$scope.tutorial	    = tutorial;
    		$scope.timerRunning = true;
    		$scope.text  	    = { 'needTeam':tr("You don't have a team"),'draft':tr('Draft Now'),'contract':tr('Contract'),'manager':tr('Manager'),'league':tr('League'),'team':tr('Team'),'score': tr('SCORE'),'points': tr('PTS'), 'assists':tr('AST'),'minutes':tr('MIN'),'fouls':tr('FLS'),'steals':tr('STL'),'blocks':tr('BLK'),'rebounds':tr('REB'), 'days':tr('days'), 'day' : tr('day'), 'at': tr('@'), 'vs' : tr('vs'), 'W' : tr('W'), 'L' : tr('L'), 'skillpoints' : tr('Skillpoints'), 'equipment' : tr('Equipment'), 'tactics' : tr('Tactics'), 'simulatedemo' : tr('Simulate Demo') };
    		$scope.API   	    = me;
    		$scope.form	    = { 'help': player.getHelp( 'crib' ) };
    		$scope.player	    = player;
    		$scope.lifeSettings  = { 'numMonths': 21, 'numCareers': me.getMaxCareers(), 'numGames':30  };
    		
    			
    		//apparently this is 'bad practice'. $scope is updated and given AJAX promises inside the model.
    		player.get( 'mine', $routeParams.playerId, $scope );  	 
    }])
    .controller('confirmCtrl', ['$scope', '$routeParams', 'player', 'confirm', 'me', 'AJAX','$q', function ($scope, $routeParams, player, confirm, me ,AJAX,$q) { 
    		 
    		$scope.data	    = {'title':tr('Retirement')};
    		$scope.confirm	    = confirm;
    		$scope.confirm.setScope( $scope );
    		$scope.confirm.setModule( $routeParams.module );
    		$scope.confirm.setId( $routeParams.id );
    }])
    .controller('homeCtrl', ['$scope', '$routeParams', 'me', 'account', 'wall', 'notifications', 'tutorial', function ($scope, $routeParams, me, account, wall, notifications, tutorial) { 
    		//account home equivalent
    		
    		if( getPlatform() == 'ios' )
			if( typeof StatusBar != 'undefined' )
				StatusBar.backgroundColorByHexString("#F6F6F6");
    	
		$scope.page			= 'home';
		$scope.tutorial			= tutorial;
		
		if( $scope.tutorial )
			$scope.tutorial.doneStep( 'homepage' );
		
    		$scope.wall         		= wall;
    		$scope.account      		= account;
    		$scope.account.setType('home');
    		$scope.count	    		= { players:0, clubs:0};
    		$scope.data	    		= { players:[], clubs:[] };
    		$scope.data.trueVar 		= true;
    		$scope.wall.init( $scope );
    		$scope.wall.setId( me.get('id_account') );  		
    		$scope.wall.setType( 99 );
    		
    		$scope.form		= {'page':'home','addingMSG':[], 'help': account.getHelp( 'home' ) }; 
    		$scope.getHelp = function( module, submodule ){ return account.getHelp( module, submodule ); };
    		$scope.form.showEntryTooltip = me.getShowEntryTooltip();
    		 
    		$scope.account.get( me.get('id_account'), null, $scope );
    		 
    		//GET PUSH NOTIFICATION ID
    		//alert("pushPossible"+pushPossible());
    		//alert("localStorageId"+(localStorage.getItem( 'oneSignalId'  )));
    		//alert(me.daysAgo( localStorage.getItem( 'reqNotifications'  ) ));
    		 
				
    		if( pushPossible() )
			if(  me.getOneSignalId(   ) == null ||  me.getOneSignalId(   ) == 'UNKNOWN' 
				||  me.getOneSignalId(  ) == '' ||  me.getOneSignalId( ) == 'blank' )
			{
			
				window.plugins.OneSignal.getIds(function(ids) { 
					notifications.setScopePointer( $scope );
					notifications.updatePushSettings( ids );
					me.setOneSignalId(  ids.userId  );
				  //document.getElementById("OneSignalUserID").innerHTML = "UserID: " + ids.userId;
				  //document.getElementById("OneSignalPushToken").innerHTML = "PushToken: " + ids.pushToken;
				  //console.log('getIds: ' + JSON.stringify(ids));
				});
				
				if( getPlatform() == 'android' )
					window.plugins.OneSignal.registerForPushNotifications();
				
				if( getPlatform() == 'ios' )
				{
					if(  parseInt(me.daysAgo( me.getVar( 'reqNotifications') )) >= 7 )
					{ 
						 me.setVar('reqNotifications'  , me.today() );
						
						// process the confirmation dialog result
						 
						
						// Show a custom confirmation dialog    
						//
						
						navigator.notification.confirm(
						    tr('Would  you like to receive push notifications for contract offers, private messages, game results, etc.?'),  // message
						    function onConfirm(buttonIndex) {
						    	    if(buttonIndex==1 )
						    	    	    window.plugins.OneSignal.registerForPushNotifications();
						    }
						    ,              // callback to invoke with index of button pressed
						    tr('Notifications'),            // title
						    ''+tr('Yes')+','+tr('No')+''          // buttonLabels
						);
						
					}
				}
				
			}
             
    		 
    		$scope.text         = { wall:tr('Wall'),'newPlayer': tr('Create Player'), 'PF' : tr('PF'), 'C' : tr('C'), 'SG' : tr('SG'), 'SF' : tr('SF') };		
    }])  
    .controller('gamesListCtrl', ['$scope', '$routeParams', 'me', 'AJAX','games','$location', function ($scope, $routeParams, me ,AJAX, games,$location) { 
    
    		$scope.gamesApi 	 	= games;
    		$scope.data 		= {};   
    		$scope.gameList		= { live:[], fixtures: [], results: []}; 
    		$scope.API.setForm('comp_45',1);
		$scope.API.setForm('comp_130',1);
		$scope.API.setForm('comp_35',1);
		$scope.API.setForm('comp_32',1);
		$scope.API.setForm('comp_33',1);
		$scope.API.setForm('comp_80',1);
		$scope.API.setForm('comp_40',1);
		$scope.API.setForm('comp_140',1);
		$scope.API.setForm('comp_10',1);
		$scope.API.setForm('comp_60',1);
		$scope.API.setForm('comp_90',1);
		
		if( $scope.tutorial )
			$scope.tutorial.doneStep( 'viewGames' );
		
    		$scope.form		= {page: 'myGames','help':games.getHelp('gameList')};
    		//console.log("Day>>>>>>>>>>>>>>>>>>"+($routeParams.day)+"<<<");
    		if( typeof $routeParams.day == 'undefined' )
    			$scope.gamesApi.setSelectedDay( me.get('day') );
    		else
    			$scope.gamesApi.setSelectedDay( $routeParams.day );
    		//$scope.gamesApi.setLocation( $location );
    		$scope.gamesApi.getList( $scope ); 
    	 
    }])  
    .controller('simulateDemoCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','player', 'tutorial', function ($scope, $routeParams, $sce, me ,AJAX, player, tutorial) { 
     
    		$scope.tutorial		= tutorial;
    		$scope.player 	 	= player;
    		var pid			= $routeParams.pid;
    		$scope.data 		= {};    
    		$scope.form		= {help: player.getHelp('demo'), 'model':{'player':{}},'options':{'players':[]}}; 
    		$scope.links		= {'a':'<a ng-click="go(\'/playerTactics/'+pid+'\');" class="blue">','/a':'</a>','/d':'</a>', 'b':'<a ng-click="go(\'/equipment/'+pid+'\');" class="blue">', 'c':'<a ng-click="go(\'/cyberpoints/skillpoints/'+pid+'/\');" class="blue">', '/link':'</a>'};
    		$scope.introT 		= tr('We recommend simming a demo after: {a}setting tactics{/link}, {b}buying equipment{/a} or {c}getting and using extra skillpoints{/d}',$scope.links);
    		$scope.introText 	= $sce.trustAsHtml($scope.introT);
    		$scope.data.id		= $routeParams.pid;
    		$scope.player.get( 'demo', $routeParams.pid, $scope );  
    }]) 
    .controller('demosListCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','player', function ($scope, $routeParams, $sce, me ,AJAX, player) { 
     
    			    var pid     = 1;
    		$scope.player 	 	= player; 
    		$scope.data 		= {};    
    		$scope.form		= {help: player.getHelp('demo')}; 
    		$scope.links		= {'a':'<a ng-click="go(\'/playerTactics/'+pid+'\');" class="blue">','/a':'</a>','/d':'</a>', 'b':'<a ng-click="go(\'/equipment/'+pid+'\');" class="blue">', 'c':'<a ng-click="go(\'/cyberpoints/skillpoints/'+pid+'/\');" class="blue">', '/link':'</a>'};
    		$scope.introT 		= tr('We recommend simming a demo after: {a}setting tactics{/link}, {b}buying equipment{/a} or {c}getting and using extra skillpoints{/d}',$scope.links);
    		$scope.introText 	= $sce.trustAsHtml($scope.introT);
    		//$scope.data.id		= $routeParams.pid;
    		$scope.player.get( 'demos', null, $scope );  
    }]) 
      
    .controller('skillpointsReceivedCtrl', ['$scope', '$routeParams', 'me', 'AJAX','player', 'tutorial', function ($scope, $routeParams, me ,AJAX, player, tutorial) { 
    		var what		= {id_game:$routeParams.idGame, id_players: $routeParams.idPlayers };
    		$scope.player 	 	= player; 
    		$scope.data 		= {};  
    		$scope.player.get( 'skillpointsReceived', 1, $scope, null, what );  
    }])	
    .controller('skillpointGoalsCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','player','tutorial', function ($scope, $routeParams, $sce, me ,AJAX, player, tutorial) { 
    		$scope.data		= {'title':tr('Skllpoint Goals')};
    		$scope.pid		= $routeParams.idPlayer;
    		$scope.player 	 	= player;
    		$scope.tutorial		= tutorial;
    		$scope.form		= {help: player.getHelp('goals'),model:{player:{}},options:{players:[]} };
    		$scope.v		= {'num':10};
    		$scope.API.setForm('possible',1);
    		$scope.player.get( 'goals', $routeParams.idPlayer, $scope );   
    }])
    .controller('signupCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','account', function ($scope, $routeParams, $sce, me ,AJAX, account) { 
    		$scope.account		= account; 
    		$scope.account.init( $scope );
    }])
    .controller('simulatingNowCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','player', function ($scope, $routeParams, $sce, me ,AJAX, player) { 
     
    		 
    }])
    .controller('tutorialQuestionCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','player', function ($scope, $routeParams, $sce, me ,AJAX, player) { 
    		$scope.form	= {'answer':''};
    		$scope.tutorial.getQuestion($routeParams.idQuestion, $scope  );
    }])
    .controller('cyberpointsCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','account', 'cyberpoints', 'payments', function ($scope, $routeParams, $sce, me ,AJAX, account, cyberpoints, payments) { 
    		$scope.count 		= {}; 
    		payments.setScope( $scope );
    		$scope.payment		= payments;
    		 
    		$scope.payment.initStores();
    		$scope.clickedSomewhereElse = function(){ 
    			if( $scope.form.class == 'active' ) 
    				$scope.form.class = 'not-active'; 
    		};
    		$scope.data  		 = {title: tr('CyberPoints')};
    		$scope.form 		 = {payment_businesses: 'PayPal & Skrill', email:me.get('contact_email'),selected:{},equipmentName:'',equipmentPlayer:[], equipment:{value:'shoes'},reminder:45,player_slot_cost:200,'b':'<B>','/b':'</B>','award_referral':10,'amount':10,'around_cyberpoints':1600,'help':cyberpoints.getHelp( 'home' ), options: {players:[]}, players:{} };
    		var v = {};
    		v['num'] = 3; v['price'] = 3*$scope.form.player_slot_cost;
    		$scope.text		 = {numHours:48,cdpReviewReward: 400, deviceList: 'Android device, iOS device, Amazon device, Windows phone, Chrome browser','buy_3': tr('{num} player slots',v), 'buy_3_cost': tr('{price} CyberPoints',v)};
    		v['num'] = 5; v['price'] = 5*$scope.form.player_slot_cost;
    		$scope.text.buy_5	 = tr('{num} player slots',v);
    		$scope.text.buy_5_cost   = tr('{price} CyberPoints',v);
    		var skills 		 = me.get('skills' );
    		for( var sk in skills ) 
    			$scope.form[skills[sk]] = 0; 
    		
    		$scope.getHelp	    = function( which, what ){ return cyberpoints.getHelp( which, what ); }; 
    		//$scope.form.consumable = JSON.parse('[{"purchaseToken":"tokenabc","developerPayload":"mypayload1", "packageName":"com.example.MyPackage","purchaseState":0,"orderId":"12345.6789", "purchaseTime":1382517909216,"productId":"example_subscription"}, {"purchaseToken":"tokenxyz","developerPayload":"mypayload2", "packageName":"com.example.MyPacakge","purchaseState":0,"orderId":"98765.4321", "purchaseTime":1382435077000,"productId":"example_product"}]');
    		if( getPlatform() == 'android' )
    		{
    			if( typeof inappbilling != 'undefined' )
    				inappbilling.getPurchases(function( scs ){  $scope.form.consumable = scs; } , function( scs ){} ); 
    		}
    		cyberpoints.setScope( $scope );
    		cyberpoints.createCustomEquipmentOptions();
    		$scope.cyberpoints 	= cyberpoints;
    		$scope.API.setForm('purchase',0); 
    		$scope.API.setForm('translations',0); 
    		$scope.API.setForm('login_bonus',0); 
    		$scope.API.setForm('referrals',0); 
    		$scope.API.setForm('own_team',0); 
    		$scope.API.setForm('more_players',0); 
    		$scope.API.setForm('custom_equipment',0); 
    		$scope.API.setForm('extra_skillpoints',0); 
    		account.setType('cyberpoints');
    		account.setSelectedPlayer( -1 );
    		account.get( me.get('id_account'), me.get('username'), $scope ); 
    		if( $scope.tutorial )
    			if( $scope.tutorial.getStep() == 'cyberpoints' )
    				$scope.tutorial.requestQuestion();
    }]) 
    .controller('cyberpointsGetCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','account', 'cyberpoints', 'payments', function ($scope, $routeParams, $sce, me ,AJAX, account, cyberpoints, payments) { 
    		$scope.count 		= {}; 
    		payments.setScope( $scope ); 
    		$scope.getHelp	    	= function( which, what ){ return cyberpoints.getHelp( which, what ); }; 
    		$scope.payment		= payments; 
    		$scope.payment.initStores();  
    		//$scope.form.consumable = JSON.parse('[{"purchaseToken":"tokenabc","developerPayload":"mypayload1", "packageName":"com.example.MyPackage","purchaseState":0,"orderId":"12345.6789", "purchaseTime":1382517909216,"productId":"example_subscription"}, {"purchaseToken":"tokenxyz","developerPayload":"mypayload2", "packageName":"com.example.MyPacakge","purchaseState":0,"orderId":"98765.4321", "purchaseTime":1382435077000,"productId":"example_product"}]');
    		if( getPlatform() == 'android' )
    		{
    			if( typeof inappbilling != 'undefined' )
    				inappbilling.getPurchases(function( scs ){  $scope.form.consumable = scs; } , function( scs ){} ); 
    		}
    		$scope.data  		 = {title: tr('Get CyberPoints')};
    		$scope.form 		 = {payment_businesses: 'PayPal & Skrill', email:me.get('contact_email'),selected:{},equipmentName:'',equipmentPlayer:[], equipment:{value:'shoes'},reminder:45,player_slot_cost:200,'b':'<B>','/b':'</B>','award_referral':10,'amount':10,'around_cyberpoints':1600,'help':cyberpoints.getHelp( 'home' ), options: {players:[]}, players:{} };
    		var v = {};
    		v['num'] = 3; v['price'] = 3*$scope.form.player_slot_cost;
    		$scope.text		 = {step1: {num:1},step2:{num:2},numHours:48,cdpReviewReward: 400, deviceList: 'Android device, iOS device, Amazon device, Windows phone, Chrome browser'};
    		$scope.text2		 = {fbInvites:tr('Inviting {numInv} people to join you in {WHICH__GAME} will give you another {num} CyberPoints. You can do this <b> each week </b> as well.',$scope.text)};
    		if( $scope.tutorial )
			$scope.tutorial.doneStep( 'cyberpoints-earn' );
    		$scope.API.setForm('own_team',0); 
    		$scope.API.setForm('more_players',0); 
    		$scope.API.setForm('custom_equipment',0); 
    		$scope.API.setForm('extra_skillpoints',0); 
    		$scope.cyberpoints  = cyberpoints;
    		 
    		cyberpoints.setScope( $scope );
    		account.setType('cyberpointsGet');
    		account.setSelectedPlayer( -1 );
    		account.get( me.get('id_account'), me.get('username'), $scope ); 
    
    }]) 
     .controller('cyberpointsSpendCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','account', 'cyberpoints', 'payments', function ($scope, $routeParams, $sce, me ,AJAX, account, cyberpoints, payments) { 
    		$scope.count 		= {}; 
    		payments.setScope( $scope );
    		$scope.payment		= payments;
    		$scope.payment.initStores();
    		$scope.getHelp	    = function( which, what ){ return cyberpoints.getHelp( which, what ); }; 
    		//$scope.form.consumable = JSON.parse('[{"purchaseToken":"tokenabc","developerPayload":"mypayload1", "packageName":"com.example.MyPackage","purchaseState":0,"orderId":"12345.6789", "purchaseTime":1382517909216,"productId":"example_subscription"}, {"purchaseToken":"tokenxyz","developerPayload":"mypayload2", "packageName":"com.example.MyPacakge","purchaseState":0,"orderId":"98765.4321", "purchaseTime":1382435077000,"productId":"example_product"}]');
    		if( getPlatform() == 'android' )
    		{
    			if( typeof inappbilling != 'undefined' )
    				inappbilling.getPurchases(function( scs ){  $scope.form.consumable = scs; } , function( scs ){} ); 
    		}
    		$scope.data  		 = {title: tr('Spend CyberPoints')};
    		$scope.form 		 = {payment_businesses: 'PayPal & Skrill', email:me.get('contact_email'),selected:{},equipmentName:'',equipmentPlayer:[], equipment:{value:'shoes'},reminder:45,player_slot_cost:200,'b':'<B>','/b':'</B>','award_referral':10,'amount':10,'around_cyberpoints':1600,'help':cyberpoints.getHelp( 'home' ), options: {players:[]}, players:{} };
    		var v = {};
    		v['num'] = 3; v['price'] = 3*$scope.form.player_slot_cost;
    		$scope.text		 = {numHours:48,cdpReviewReward: 400, deviceList: 'Android device, iOS device, Amazon device, Windows phone, Chrome browser','buy_3': tr('{num} player slots',v), 'buy_3_cost': tr('{price} CyberPoints',v)};
    		v['num'] = 5; v['price'] = 5*$scope.form.player_slot_cost;
    		$scope.text.buy_5	 = tr('{num} player slots',v);
    		$scope.text.buy_5_cost   = tr('{price} CyberPoints',v);
    		$scope.text.superstarCost= 2000;
    		cyberpoints.setScope( $scope );
    		cyberpoints.createCustomEquipmentOptions();
    		$scope.cyberpoints 	= cyberpoints;

    		$scope.API.setForm('purchase'		,0); 
    		$scope.API.setForm('translations'	,0); 
    		$scope.API.setForm('login_bonus'	,0); 
    		$scope.API.setForm('referrals'		,0); 
    		$scope.API.setForm('reviews'		,0); 
    		$scope.API.setForm('fb_invites'		,0); 
    		$scope.cyberpoints  = cyberpoints;
    		 
    		cyberpoints.setScope( $scope );
    		account.setType('cyberpointsSpend');
    		account.setSelectedPlayer( -1 );
    		account.get( me.get('id_account'), me.get('username'), $scope ); 
    
    }]) 
    .controller('cyberpointsOptionCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','account', 'cyberpoints', 'payments', function ($scope, $routeParams, $sce, me ,AJAX, account, cyberpoints, payments) { 
    		$scope.data  		= {title: cyberpoints.getTitle( $routeParams.module ) };
    		$scope.form 		= {help: cyberpoints.getHelp($routeParams.module), module: $routeParams.module, email:me.get('contact_email'),selected:{},equipmentName:'',equipmentPlayer:[], equipment:{value:$routeParams.subModule},reminder:45,player_slot_cost:200,'b':'<B>','/b':'</B>','award_referral':10,'amount':10,'around_cyberpoints':1600, options: {players:[]}, players:{}  };
    		$scope.count 		= {};
    		$scope.getHelp	    = function( which, what ){ return cyberpoints.getHelp( which, what ); };
    		
    		var skills 		 = me.get('skills' );
    		for( var sk in skills ) 
    			$scope.form[skills[sk]] = 0; 
    		$scope.API.setForm('custom_equipment',1); 
    		$scope.API.setForm('extra_skillpoints',1); 
    		cyberpoints.setScope( $scope );
    		cyberpoints.setSelectedEquipmetType( $routeParams.subModule );
    		cyberpoints.createCustomEquipmentOptions();
    		$scope.cyberpoints 	= cyberpoints;
    		account.setType('cyberpoints');
    		account.setSelectedPlayer( $routeParams.playerId );
    		account.get( me.get('id_account'), me.get('username'), $scope ); 
    		if( $routeParams.module == 'skillpoints' )
    			cyberpoints.skillpointsSelect( $routeParams.playerId );
    			 
    }]) 
    .controller('trainingCtrl', ['$scope', '$routeParams', '$sce', 'me', 'AJAX','player', function ($scope, $routeParams, $sce, me ,AJAX, player) { 
     
    		$scope.player 	 	= player; 
    		$scope.data 		= {};    
    		$scope.form		= {'help':player.getHelp('training'),'model':{'player':{}, 'value':{}},'options':{'players':[],'skills':[]}}; 
    		$scope.API.setForm('trainingSettings',1);
    		$scope.player.get( 'training', $routeParams.pid, $scope );  
    }])  
    .controller('notificationsCtrl', ['$scope', '$routeParams', 'me', 'AJAX','notifications', function ($scope, $routeParams, me ,AJAX, notifications) { 
    	   
    		notifications.setPushChanges( 0 );
    		$scope.notifications 	 	= notifications; 
    		$scope.form			= {page: 'notifications'};
    		$scope.alerts			= [];
    		$scope.data 			= { title: tr('Notifications') };    
    		$scope.notifications.get( $scope, 0, $routeParams.ids );  
    }])   
    .controller('hallSwitchCtrl', ['$scope', '$routeParams', 'me', 'AJAX','halloffame', function ($scope, $routeParams, me ,AJAX, hall) { 
          
    	    	$scope.hall			= hall;
    	    	$scope.data			= {title: tr('Hall Of Fame'), selection: 'game',categories: hall.getDefault()};
    	    	$scope.myRankings		= {}; 
    	    	$scope.hall.setIdAccount( me.get('id_account') );
    	    	$scope.hall.get( $scope );
    }])
    .controller('hallCtrl', ['$scope', '$routeParams', 'me', 'AJAX','halloffame', function ($scope, $routeParams, me ,AJAX, hall) { 
     
    		 
    	    	$scope.hall			= hall;
    	    	$scope.list			= [];
    	    	$scope.hallOptions		= hall.getTopPlayerOptions();
    	    	$scope.data			= {item: $routeParams.ranking,firstRank:-1, lastRank:'', title: tr('Hall Of Fame')};
    	    	$scope.myRankings		= {};
    	    	 
    	    	$scope.hall.setIdAccount( me.get('id_account') );
    	    	if( typeof $routeParams.rankType != 'undefined' )
    	    		$scope.hall.setRankType( $routeParams.rankType );
    	    			else
    	    				$scope.hall.setRankType( 'rank' );
    	    	if( typeof $routeParams.rankSubdivision != 'undefined' )
    	    		$scope.hall.setRankSubdivision( $routeParams.rankSubdivision ); 
    	    			
    	    	
    	    	$scope.hall.getHall( $routeParams.ranking, $routeParams.rank, $scope );
    	    	$scope.hall.getTopPlayerSelectedOption();
    }])
    .controller('notificationSettingsCtrl', ['$scope', '$routeParams', 'me', 'AJAX','notifications', function ($scope, $routeParams, me ,AJAX, notifications) { 
     
    		$scope.notifications 	 	= notifications;  
    		
    		$scope.text			= { aa: '', '/bb': '' };
    		$scope.data 			= { title: tr('Notification Settings'),email_summary_settings:{interval:3} };    
    		$scope.form			= { help:  notifications.getHelp('pushSettings'), status: 'default' };
    	 
    		if( typeof $routeParams.highlight != 'undefined' )
    			$scope.form.highlight = $routeParams.highlight;
    		else
    			$scope.form.highlight = 'asdssdsadsadasdsadsdas';
    		$scope.notifications.ajaxPushSettings( $scope );  
    }])  
    
    .controller('forumCtrl', ['$scope', '$routeParams', 'me', 'AJAX','wall', function ($scope, $routeParams, me ,AJAX, wall) { 
    	
    		if( typeof $routeParams.which == 'undefined' )
    			var which = '';
    				else
    					var which = $routeParams.which;
    			    
    		$scope.form		 = {page: 'forum',help: wall.getHelp('forum'),status: 'form',title:'',message:'', which:which, forumOptions:[],forumChoice:{}};
    		
    		$scope.wall 	 	 = wall; 
    		$scope.wall.setPointer( $scope );
    	 
    		$scope.form.browsingList = $scope.wall.getBrowsingList();
    		$scope.data 		 = { title: tr('Discussions') };   
    		if( typeof $routeParams.open != 'undefined' )
    			$scope.API.setForm( $routeParams.open, 1 );
    		 
    		$scope.wall.getForum( $routeParams.which , $scope ); 
    	 
    }])		    
    .controller('gameCtrl', ['$scope', '$routeParams', 'me', 'AJAX','games','gameLog', 'tutorial', function ($scope, $routeParams, me ,AJAX, games,gameLog, tutorial) { 
   
    		$scope.tutorial		= tutorial;
    		games.setGameId( $routeParams.gameId );
    		$scope.game 	 	= games; 
    		$scope.data 		= {};  
    		$scope.text		= {'points': tr('PTS'), 'assists':tr('AST'),'minutes':tr('MIN'),'fouls':tr('FLS'),'steals':tr('STL'),'blocks':tr('BLK'),'rebounds':tr('REB')};
    		$scope.data.title	= tr('Game Summary');
    		$scope.form		= {'show':0,'pbpShow':0,'bench':false, selectedQ:{},'help':games.getHelp('page')};
 
    		$scope.stories		= []; 
    	 
    		$scope.stories		= [];
    		$scope.teamTypes	= [ 'home_team','away_team' ];
    	 
    		$scope.game.getGame( $routeParams.gameId, $scope );  
    		if( $routeParams.live == 'live' )
    		{
    			$scope.pbpOrder = 'moment';
    			$scope.game.connectLiveGame( $routeParams.gameId , $scope );
    		}
    		
    		if( $routeParams.live == 'fakeLive' )
    		{
    			$scope.fakeLive        = 1;	
    			$scope.current_quarter = 4;
    			$scope.current_moment  = 718;
    		}
    }]) 
    .controller('forgottenCtrl', ['$scope','$routeParams','me' ,'$http','AJAX','$location', 'account', function ($scope,$routeParams,me,$http,AJAX,$location, accounts) {
    		$scope.text 	= { username: tr('Username') };
    		$scope.credentails = {};
    		$scope.account  = accounts;
    		$scope.account.setScope( $scope );
    		  
     }]) 
     .controller('setFooterPositionCtrl', ['$scope','$routeParams','me' ,'$http','AJAX','$location', 'account', function ($scope,$routeParams,me,$http,AJAX,$location, accounts) {
    		$scope.API.setFooterPosition( $routeParams.height );
     }])
    .controller('setUsernameCtrl', ['$scope','$routeParams','me' ,'$http','AJAX','$location', 'account', function ($scope,$routeParams,me,$http,AJAX,$location, accounts) {
    		$scope.text 	= { username: tr('Username') };
    		$scope.credentails = {};
    		$scope.account  = accounts; 
    		$scope.account.setScope( $scope );
    		 
     }])
    .controller('logoutCtrl', ['$scope','$routeParams','me' ,'$http','AJAX','$location', function ($scope,$routeParams,me,$http,AJAX,$location) {
    		$scope.text = { username: tr('Username \\ Email'), password: tr('Password'), introduction: tr('Control a single player or a team of human players'), 
    		        link: 'www.cyberdunk2.com', login: tr('Login'), signup: tr('Sign up')};
    		$scope.API.logout( $scope );   
     }])  
    .controller('loginCtrl', ['$scope','$routeParams','me' ,'$http','AJAX','$location', function ($scope,$routeParams,me,$http,AJAX,$location) {
    	 
    	
    	$scope.text = { username: tr('Username \\ Email'), password: tr('Password'), introduction: tr('Control a single player or a team of human players'), 
    		        link: 'www.cyberdunk2.com', login: tr('Login'), signup: tr('Sign up')};
    	    
    	$scope.loading = false;
    	$scope.form    = { missedLogin: 0 };
    	  
    	
    	 
    	//function to login.
        $scope.login= function( credentials )
    	{ 
    		$scope.loading = true;
    		
    		if( typeof credentials  == 'undefined' ) 
    			credentials = {username:'',password:''};
    		
    		if( typeof credentials.username  == 'undefined' ) 
    			credentials = {username:'',password:''};
    		
    		if( typeof credentials.password  == 'undefined' ) 
    			credentials = {username:'',password:''};
    		//ajax credentials 
    		var credentialsArr = {username:credentials.username, password: md5(sha1(sha1(md5(credentials.password)))) }; 
		var responsePromise = AJAX.get('ACCOUNTS_LOGIN',credentialsArr);

                responsePromise.success(function(data, status, headers, config) {
                		 
                		$scope.loading = false; 
                		//succesful login 
                		if( data.status == 'SUCCESS' )
                		{
					$scope.API.login( data );  
					$scope.go('/home/');
				}
				else
				{
					$scope.form.missedLogin = 1;
					$scope.API.setError(data.ret.message, $scope);
				}
		});
                responsePromise.error(function(data, status, headers, config) {
                		$scope.loading = false;
                		 
                		$scope.API.setError( 'REST', $scope );
                });  
    	}
    	
    	if( typeof $routeParams.username != 'undefined' )
    	{ 
    		$scope.login( {username: $routeParams.username, password: $routeParams.password} );
    	}
    	else
    	{
		if( me.get('id_account') > 0 )
			$scope.go('/home/');
	}
    	
    
    	$scope.facebookLogin = function()
    	{
    		 
    		if( typeof window.cordova != 'undefined' )	
		{
			 
			//window.cordova.platformId == "browser"
			if (window.cordova.platformId == "browser" || getPlatform() == 'windowsphone' ) {
			    facebookConnectPlugin.browserInit(me.get('facebookAppId'));
			    // version is optional. It refers to the version of API you may want to use.
			}
		}
		else
		{
			//facebookConnectPlugin.browserInit(me.get('facebookAppId'));
		}
		
    		facebookConnectPlugin.login( ["email"], 
                    function (response) { 
                    	    //SUCCESFUL CONNETION WITH FACEBOOK
                    	  
                    	    //USER-ID RECEIVED, CHECK WITH CYBERDUNK2 SERVER
                    	    //EXISTS OR NEW ACCOUNT ? 
                    	    var credentialsArr 		  = {};
                    	    credentialsArr['userId'] 	  = response['authResponse']['userID'];
                    	    credentialsArr['accessToken'] = response['authResponse']['accessToken'];
                    	    var responsePromise = AJAX.put('FACEBOOK_CONNECT',credentialsArr);
                    	    
                    	    responsePromise.success(function(data, status, headers, config) {
                		
                		$scope.loading = false; 
                		//succesful login 
                		if( data.status == 'SUCCESS' )
                		{
                			//EXISTS - LOGIN
                			if( data.ret.connectType == 'login' )
                			{
						$scope.API.login( data );  
						$scope.go('/home/');
					}
					else
					{
						//EXISTS - NEW ACCOUNT - SET USERNAME
						if( $scope.tutorial.getStepNum() == 0 )
        						$scope.tutorial.setStep( 1 );
						//$scope.API.setShowEntryTooltip( 1 );
						$scope.API.login( data ); 
						$scope.go('/set_username/');	
						
					}
				}
				else
				{
					$scope.form.missedLogin = 1;
					$scope.API.setError(data.ret.message, $scope);
				}
				
			});
			responsePromise.error(function(data, status, headers, config) {
					$scope.loading = false;
					$scope.API.setError( 'REST', $scope );
			}); 
                    	
                    },
                    function (response) { 
                    	    //ERROR CONNECTING WITH FACEBOOK
                    	    console.log("error >> "+JSON.stringify( response ) );
                    	    $scope.API.setError(tr('There was an error connecting with facebook') ,$scope ); 
                    });	
    	}
    	
    	if( getPlatform() == 'browser' || getPlatform() == 'windowsphone' )
	{ 
		if( 1 )
		{ 
			var parts = document.location.href.split("&code=");   
			if( typeof parts[1] != 'undefined' )
				if( parts[1].length >= 15 )
				{      
					setTimeout( function(){  
							console.log( typeof facebookConnectPlugin );
						$scope.facebookLogin();
					}, 1500);
				}
		}
	}
	 
    	
    
    }]) .run(function($window, $rootScope) {
    	    //getPlatform() !='browser'&& getPlatform() != 'unknown'
      if( getPlatform() !='browser'&& getPlatform() != 'unknown' )
      {
	      $rootScope.online = navigator.onLine;
	      $window.addEventListener("offline", function () {
		$rootScope.$apply(function() {
		  $rootScope.online = false;
		});
	      }, false);
	      $window.addEventListener("online", function () {
		$rootScope.$apply(function() {
		  $rootScope.online = true;
		});
	      }, false);
      }
      else
      	      $rootScope.online = true;
})   
    .directive('compile', ['$compile', function ($compile) {
	  return function(scope, element, attrs) {
	    scope.$watch(
	      function(scope) {
		return scope.$eval(attrs.compile);
	      },
	      function(value) {
		element.html(value);
		$compile(element.contents())(scope);
	      }
	   )};
	  }]);
    

    
app.run(function(liveGamesListener) {});
 
angular.module('myApp.fastclick', []).
  run(function() {
    FastClick.attach(document.body);
});
 
 
    
 
