'use strict';
(function () {

	var token;
	var iso	      = 'UNKNOWN';
	var APILink   = 'http://cyberdunk2.com/API/';

	 angular.module('myApp.AJAX', [])
	 .service( 'AJAX', [ '$http','$location','httpWithFallback',
            function ( $http,$location,httpWithFallback ) {
                return {
                	getIsoString: function()
                	{
                		if( iso != 'UNKNOWN' )
                			return '&language='+iso;		
                				else
                					return '';
                	},
                	
                	setIso: function( to )
                	{ 
                		iso = to;	
                	}, 

                	setToken: function( to )
                	{
                		token = to; 
                	},

                	getToken: function(   )
                	{ 
                		 
                		return token;
                	},
                	
                	getDevice: function()
                	{ 
                		if( typeof device != 'undefined' )
                		{ 
                			if( typeof device.platform != 'undefined' )
                				return '&platform='+(device.platform);
                					else
                						return '&platform=unknown';
                		}
                		else
                			return '&platform=browser';
                	},

                	get: function(module, args, withCache){
                		 
                		var parsedArgs = '?app=mobile'+this.getIsoString()+'&notifications=1&platform='+(getPlatform())+'&token='+this.getToken();
                		
                		if( typeof window.SC() != 'undefined' )
                		{ 
                			if( typeof window.SC().tutorial != 'undefined' )
						if( window.SC().tutorial.getStepNum() >0 && window.SC().tutorial.getStepNum() <= 12 )
							parsedArgs += '&t_step='+window.SC().tutorial.getStepNum();
				}
                		for( var i in args )
                		{
                			if( typeof args[i] == 'object' ){
                				
                				for( var j in args[i] )
                					 parsedArgs += '&'+i+'['+j+']='+args[i][j];
                				
                				}
                				else
                					parsedArgs += '&'+i+'='+args[i];
                		}

                		var urllink = APILink+""+module+"/GET/"+parsedArgs+"";
                		console.log( "GET.AJAX "+urllink+" <>");
                		 
                		return httpWithFallback.get(urllink,{
					method:		"GET", 
					timeout: 	5000,
					warningAfter: 	2000,
					headers: 	{'Content-Type': 'application/x-www-form-urlencoded;charset:utf-8'}
					},withCache);

                		/*
				return $http(
					{
					method:		"GET",
					url: 		urllink,
					timeout: 	10000,
					warningAfter: 	2000,
					headers: 	{'Content-Type': 'application/x-www-form-urlencoded;charset:utf-8'}
					}
				);*/
                	},

                	put: function(module, args){
 
                		var parsedArgs = '?app=mobile'+this.getIsoString()+'&notifications=1&platform='+(getPlatform())+'&token='+this.getToken();
                		for( var i in args )
                			parsedArgs += '&'+i+'='+args[i];

                		var urllink =  APILink+""+module+"/PUT/"+parsedArgs+"";
                		console.log( "PUT.AJAX "+urllink+" <>");
						return $http(
							{
							method:		"GET",
							url: 		urllink,
							timeout: 	5000,
							warningAfter: 	2000,
							headers: 	{'Content-Type': 'application/x-www-form-urlencoded;charset:utf-8'}
							}
						);
                	},
                	hit: function( urllink )
                	{
                		console.log( "HIT.AJAX "+APILink+""+urllink+" <>");
                		return $http(
					{
					method:		"GET",
					url: 		APILink+""+urllink,
					timeout: 	5000,
					warningAfter: 	2000,
					headers: 	{'Content-Type': 'application/x-www-form-urlencoded;charset:utf-8'}
					}
				);
				
				
                	},

                	patch: function(module, args){

                		var addFields = '?app=mobile'+this.getIsoString()+'&notifications=1&platform='+(getPlatform())+'&token='+this.getToken();
                		for( var i in args )
                			if( i!= 'edit' )
                			{
                				
                				if( typeof args[i] == 'object' )
                				{
                					for( var k in args[i] ) 
                					{
                						console.log("typeof = "+(typeof args[i][k])+" <<");
                						if( typeof args[i][k] == 'object' )
                						{
                							for( var j in args[i][k] ) 
									{
										if( typeof args[i][k][j] == 'object' )
										{
											addFields += '&'+i+'['+k+']['+j+']='+args[i][k][j]; 
										}
										else
											addFields += '&'+i+'['+k+']['+j+']='+args[i][k][j];;
									}
                						}
                						else
                							addFields += '&'+i+'['+k+']='+args[i][k];
                					}
                				}
                				else
                					addFields += '&'+i+'='+args[i];	
                			}

                		if( typeof args['edit'] != 'undefined' )
					for(var i in args['edit'])
						addFields = addFields + '&edit['+encodeURIComponent(i)+']='+encodeURIComponent(args['edit'][i]);

                		var urllink = APILink+""+module+"/PATCH/"+addFields+"";
                	 
                		console.log( "PATCH.AJAX "+urllink+" <>");
				return $http(
					{
					method:		"GET",
					url: 		urllink,
					timeout: 	5000,
					warningAfter: 	2000,
					headers: 	{'Content-Type': 'application/x-www-form-urlencoded;charset:utf-8'}
					}
				);
                	}

                }
}]);

}());


/*
angular.module('myApp.restServices', ['ngResource','http'])
    .factory('Employee', ['$resource',
        function ($resource) {
            return $resource('http://localhost:3000/employees/:employeeId', {});
        }])
    .factory('AJAX', ['$resource',
        function ($resource  ) {

            return $resource('https://cyberdunk2.com/:module/:method/:vars', {});
        }])
    .factory('Reporttt', ['$resource',
        function ($resource ) {

            return $resource('https://cyberdunk2.com/:module/:method/:vars', {});
        }]);
    */
