(function() {

    var vars = {};
    var scopePointer;
    angular.module('myApp.allstar', ['myApp.AJAX', 'myApp.me'])
        .service('allstar', ['AJAX', 'me',
            function(AJAX, me) {
                return {

                    setScope: function(angularScope) {
                        scopePointer = angularScope;
                    },

                    setVar: function(which, to) {
                        vars[which] = to;
                    },

                    getVar: function(which, to) {
                        return vars[which];
                    },


                    connect: function() {
                        obj = this;
                        var sockjs_url = 'https://cyberdunk2.com:44555';

                        var sockjs = new SockJS(sockjs_url);

                        var data = {
                            type: 'auth',
                            id_account: me.get('id_account'),
                            username: me.get('username') + ' (APP)',
                            token: me.get('token'),
                            view: {
                                'draft': 1
                            }
                        };

                        //auth.login
                        sockjs.onopen = function() {

                            sockjs.send(JSON.stringify(data));

                            setInterval(function() {
                                sockjs.send(JSON.stringify({
                                    type: 'heartbeat'
                                }));
                            }, 10000);

                        };
                        sockjs.onclose = function() {};
                        sockjs.onmessage = function(e) {
                            //console.log( JSON.stringify( e ) );
                            if (typeof e.data != 'undefined') {
                                var o = tryParseJSON(e.data);

                                if (o !== false)
                                    if (typeof o.current != 'undefined') {
                                        //call update
                                        var link = window.location.href;
                                        var info = link.split("/");
                                        
                                        //basically it seems that it wont disconnect if we change pages
                                        if (info[5] == 'manageTeam' || info[6] == 'manageTeam') {
                                            if (o.notify.id_club == info[7] || o.notify.id_club == info[6]) {
                                                scopePointer.API.call('TEAM:GET', {
                                                    get: 'allstar',
                                                    id_team: scopePointer.data.fields.id,
                                                    randomizer: Math.random()
                                                }, 1, function(data) {

                                                    if (data.status == 'SUCCESS')
                                                        
                                                    	
                                                    var second = '';
                                                    if (o.next)
                                                        second = '<BR>' + tr('PICK {overall_pick}', o.next) + ': ' + tr("It's <b>{username}</b>'s turn.", o.next);
                                                    scopePointer.API.setMessage(tr('PICK {overall_pick}', o.current) + ': ' + tr('<B>{username}</b> drafted <b>{name}</b>', o.current) + '</B>' + second);
                                                    
                                                 
													scopePointer.data.allstar = data.ret.allstar;
													scopePointer.allstar.parseAllStar();
                                                
                                                });
                                            } else {
                                            	
                                                console.log("close connection");
                                                this.close();
                                            }
                                        } else {
                                        	
                                            console.log("close connection");
                                            this.close();
                                        }
                                    }
                            }
                        }
                    },

                    parseAutodraft: function(sentence) {
                        //console.log("???"+sentence+"????");
                        for (var i in scopePointer.form.allstarSort) {
                            //console.log(">>>>>>>>>>>>"+JSON.stringify(scopePointer.form.allstarSort[i]));
                            if (sentence == 'rebounds')
                                return tr('Rebounds');

                            if (sentence == 'rebounds:minute')
                                return tr('Rebounds per minute');

                            if (scopePointer.form.allstarSort[i].value == sentence) {
                                return scopePointer.form.allstarSort[i].name;
                            }
                        }
                    },

                    updateAllStarPlayersAvailable: function(loadMore) {

                        var getWhat = {
                            'get': 'availablePlayers'
                        };
                        
                        if( typeof scopePointer.form.playerSearchOption != 'undefined' )
                        	getWhat.idAccount = scopePointer.form.playerSearchOption.id;
                        getWhat.sort = scopePointer.form.allstarSortValue.value;
                        getWhat.pos = document.getElementById('dynamicDraftPos').value;
                        getWhat.where_id = scopePointer.data.fields.id_league;
                        getWhat.location = scopePointer.data.fields.club_type;

                        if (loadMore)
                            getWhat.from = scopePointer.data.allstar.availablePlayers.length;

                        var promise = AJAX.get('ALLSTAR_DRAFT', getWhat);
                        promise.success(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);

                            if (data.status == 'SUCCESS') {
                                if (loadMore)
                                    for (var i in data.ret.availablePlayers)
                                        scopePointer.data.allstar.availablePlayers.push(data.ret.availablePlayers[i]);
                                else
                                    scopePointer.data.allstar.availablePlayers = data.ret.availablePlayers;
                                //console.log("MULT?>>>>>>>"+JSON.stringify(scopePointer.player)+"<<<");
                            } else scopePointer.API.setError('REST', scopePointer);
                        });

                        promise.error(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },
                    
                    clearAutodraft: function( runda ){
                    	
                    	 var getWhat =  {'delete':1, 'runda': runda, teamId: scopePointer.data.fields.id};
                    	 var promise = AJAX.patch('ALLSTAR_AUTODRAFT', getWhat);
                         promise.success(function(data, status, headers, config) {
                         		 if (data.status == 'SUCCESS') {
                         		 	 scopePointer.data.allstar.autodraft[runda] = [];
                         		 	 scopePointer.setMessage(tr('Done'));
                         		 }
                         		 else
                         		 	 	 scopePointer.API.setError('REST', scopePointer);
                         });
                    },

                    submitAutodraft: function(runda) {
                        var getWhat = {};
                        getWhat.idAccount = scopePointer.form.playerSearchOption.id;
                        var autodraft = scopePointer.form.allstarSortValue.value;
                        if (autodraft == 'offensive_rebounds+defensive_rebounds')
                            autodraft = 'rebounds';
                        else if (autodraft == 'offensive_rebounds+defensive_rebounds:minute')
                            autodraft = 'rebounds:minute';
                        else
                            autodraft = scopePointer.form.allstarSortValue.value;

                        getWhat.sort = autodraft;
                        getWhat.pos = document.getElementById('dynamicDraftPos').value;
                        getWhat.where_id = scopePointer.data.fields.id_league;
                        getWhat.location = scopePointer.data.fields.club_type;
                        getWhat.runda = scopePointer.form.editAutodraftRound;
                        getWhat.teamId =  scopePointer.data.fields.id;

                        var promise = AJAX.put('ALLSTAR_AUTODRAFT', getWhat);
                        promise.success(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);
                            if (data.status == 'SUCCESS') {
                                if (scopePointer.data)
                                    if (scopePointer.data.allstar)
                                        if (scopePointer.data.allstar.autodraft) {
                                            if (!scopePointer.data.allstar.autodraft[scopePointer.form.editAutodraftRound])
                                                scopePointer.data.allstar.autodraft[scopePointer.form.editAutodraftRound] = [];

                                            //alert( JSON.stringify(data.ret['return']) );
                                            scopePointer.data.allstar.autodraft[scopePointer.form.editAutodraftRound] = data.ret['return'][scopePointer.form.editAutodraftRound];
                                            scopePointer.allstar.parseAllStar();
                                        }
                                scopePointer.API.setMessage(data.ret.message);
                            } else scopePointer.API.setError('REST', scopePointer);
                        });

                        promise.error(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });

                    },

                    saveAllstarNotifications: function(to) {

                        var req = {
                            'edit': {}
                        };
                        req['edit']['notifications'] = to;
                        req['id_team'] = id;
                        req['where_id'] = scopePointer.data.fields.id_league;
                        req['location'] = scopePointer.data.fields.club_type;
                        scopePointer.API.call('patch', 'ALLSTAR_DRAFT', req, 0, 'allstar.notifications');

                    },

                    makeAllstarDraftPick: function(id_player) {


                        var promise = AJAX.put('ALLSTAR_DRAFT_PICKS', {
                            id_player: id_player,
                            id_team: scopePointer.data.fields.id
                        });
                        promise.success(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            if (data.status == 'SUCCESS') {
                                scopePointer.API.setMessage(data.ret.message);
                                scopePointer.data.allstar = data.ret['return'];
                            } else
                                scopePointer.API.setError(data.ret.message);

                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });

                    },

                    myDraftTurn: function() {
                        if (scopePointer.data.allstar)
                            if (scopePointer.data.allstar.picks)
                                for (var i in scopePointer.data.allstar.picks) {
                                    var choice = scopePointer.data.allstar.picks[i];
                                    if (choice.id_account == me.get('id_account'))
                                        if (choice.stat == 1 || choice.stat == 0)
                                            return choice;
                                }

                        return {
                            'stat': 3
                        };
                    },
                    //#save reload
                    //#node.js
                    //#cron
                    //#teste
                     
                    meetsShowFilter: function(item) {

                        //default: current_pick-3 AND current_pick+3 
                        var currentPick = parseInt(scopePointer.data.allstar.fields.currentPick);
                        // console.log("current pick = "+currentPick+" <<< ");
                        var browsePick = parseInt(item.overall_pick);
                        if (currentPick > browsePick) {

                            if (item.stat == 1) return 1;

                            if (this.getVar('prev-draft') == 1)
                                return 1;

                            if (currentPick - 4 < browsePick)
                                return 1;
                            else
                                return 0;
                        }

                        if (currentPick < browsePick) {

                            if (item.stat == 1) return 1;

                            if (this.getVar('next-draft') == 1)
                                return 1;

                            if (currentPick + 5 > browsePick)
                                return 1;
                            else
                                return 0;
                        }
                        return 1;
                    },

                    parseAllStar: function(allstar) {
                        if (typeof scopePointer.data.allstar.users != 'undefined') {
                            scopePointer.data.allstar.users.unshift({
                                id: 0,
                                username: tr('All Users')
                            });
                            scopePointer.form.playerSearchOption = scopePointer.data.allstar.users[0];
                        }

                    },

                }

            }
        ]);
}());