(function() {

    var vars 		= {};
    var scopePointer;
    var lastSearch  = '';
    var friends		= {};
    var opened		= {};
    var heads		= [];
    var users		= {};
    var usersByChat = {};
    var maxMessages = 20;
    var messages	= [];
    var sockjs;	
    var sendingInterval 		= {};
    var announcedTyping 		= {};
    var announcedNOTTyping 		= {};
	var unseenMessages			= {};
	var persistentSockConnection;
	var searchTimer;
    
    angular.module('myApp.chat', ['myApp.AJAX', 'myApp.me'])
        .service('chat', ['AJAX', 'me',
            function(AJAX, me) {
                return {
                	
                persistenSockConnection: function(){
		
						var obj = this;
						persistentSockConnection = setInterval(function(){
									
									//console.log("connected ?");
									if( !obj.isConnected() ){
										//console.log("NO ! reconnect !!");
										obj.socksConnect(); 	
									}
										 
						}, 7000 ); 	
				},
				
				disconnectSocks: function(){
				 
					sockjs.close();
					clearInterval( persistentSockConnection );
				 
					
				},
	
				socksConnect: function(){
					//console.log("in load cu search ="+search);
					var sockjs_url 	= 'https://cyberdunk2.com:33399'; 
					sockjs 	= new SockJS(sockjs_url);
					var login = {
								'type'	 		: 'auth',
								'id_account'	: me.get('id_account'),
								'username'		: me.get('username'),
								'token'			: me.get('token'),
								'platform'		: getPlatform()
					}; 
					var obj = this; 
					sockjs.onopen    = function()  {  
							this.send( JSON.stringify(login) );   
					}; 
					 
					sockjs.onmessage = function(e){
					 
						//sockjs.send( JSON.stringify({'type':'isLoggedIn','id_account':1 } ) );   
						if (typeof e.data != 'undefined') {
							var o = tryParseJSON(e.data);
			
						//console.log("["+o.type+"] ---> am primit mesaj "+console.log(JSON.stringify(e)));
							
						if (o !== false)
							if (typeof o.type != 'undefined')
								switch (o.type) {
									case "sent":
									case "confirm": 
										obj.modify( o );
									break;
									case "error":
										obj.modify( {'tempId':o.tempId,'chatId':o.chatId, 'what':'error' } );
									break;
									
									case "seen":
										for( var i in o.messages ){
											//console.log(">>>>"+JSON.stringify(o.messages[i]) );
											obj.modify( {'id':o.messages[i].id,'chatId':o.chatId,'type':'seen','seen':o.messages[i].seen} );
										}
									break;
									
									case "typing":
										obj.setVar('typing-'+o.chatId,1);
										window.SC().$apply();
									break;
									
									case "not-typing":
										obj.setVar('typing-'+o.chatId,0);
										window.SC().$apply();
									break;
									
									case "unread":
									    obj.setVar('minimized-heads','minimized-heads');
								 
										obj.setHeads( 'unread',  o.unread ); 
										window.SC().$apply();
									break;
									
									case "message":
									
										var chatId = o.chatId;
										 
										//if chat is open, print message
										//console.log("chat is opened ? chatid = "+chatId+">>>"+(obj.is( 'opened', chatId ))+" << ");
										if( obj.opened().id == chatId ){
											obj.saveMessage( obj.opened(),o, 'append' );
											obj.addUnseenMessage( o );
											obj.lookForUnseen( chatId ); 
											window.SC().$apply();
										}
										
										
										//if chat is not open, open heads and play sound 
										if( !obj.isOpen(chatId)   )
										{
											var audio = new Audio('sounds/chat-notification.mp3');
											audio.volume = 0.3;
											audio.play();
											
												if( !obj.openedHead( o.chatId ) ){
												
													obj.ajaxHead( o.chatId, 'dont-minimize' ); 
													obj.playSound();
												}
											else
											{  
												//chat heads are either opened or minimized :) 
												obj.setVar('active-'+chatId, ' animated fadeInDown ');
												obj.setUnreadChats( chatId, '+' );  
												obj.newMsgAnimation( chatId); 
												obj.playSound();
												window.SC().$apply();
											}
										} 
									 
									break;
								}
						} 
						};
					},
					
					newMsgAnimation: function( chatId ){
						//JQUERY DEPENDENT :(
						var obj = this;
						$('#unread-'+chatId).replaceWith($('#unread-'+chatId).clone(true).html( obj.chatInfo(chatId).unread )); 
					},
					
					chatInfo: function( chatId ){
						for( var i in heads )
							if( heads[i].id == chatId )
								return heads[i];
							
						for( var i in friends )
							if( friends[i].id == chatId )
								return friends[i];
							
						return {}; 
					},
					
					playSound: function(){
						
					},
					
					ajaxHead: function( chatId, DONTMINIMIZE ){
						 
						var promise = AJAX.get('CHAT', 
                    							{'id_chat'  : chatId,
                    							 'get'		: 'friends',
                    							 'search-type'   : 'specific'
                    							},1);
                    						
                    	var obj = this;
                    	
                    	obj.setVar('active-'+chatId, ' hidden ');
                    	promise.success(function(data, status, headers, config) {  
							 
                    		if( data.status == 'SUCCESS' ){
                    			for( var i in data.ret.friends )
                    				obj.addHead(data.ret.friends[i]);	
                    			
                    			if( typeof DONTMINIMIZE == 'undefined' )
                    				obj.setVar('minimized-heads','minimized-heads');
                    			
                    		} 
                    	});
                    	
                    	promise.update(function(data, status, headers, config) {  
                    			if( data.status == 'SUCCESS' ){
                    				for( var i in data.ret.friends )
                    					obj.addHead(data.ret.friends[i]);		
                    				 
                    			obj.setVar('active-'+chatId, ' animated fadeInDown ');
                    			}else{
                    				setTimeout( function(){ obj.ajaxHead(chatId); }, 5000 );				
                    		}
                    	});
											
                    	promise.error(function(data, status, headers, config) {  
							setTimeout( function(){ obj.ajaxHead(chatId); }, 5000 ); 
                    	});
						
					},
					
					modify: function( arr ){
						 
						//console.log("MODIFY ["+arr.type+"] ==> "+JSON.stringify(arr)+" << ");
						if( typeof messages[arr.chatId] != 'undefined' )
							for( var i in messages[arr.chatId] ){
								var m = messages[arr.chatId][i];
								
								//console.log(m.tempId+" == "+arr.tempId+" || "+ m.id + " ==  " + arr.id );
								if( m.tempId == arr.tempId  || m.id == arr.id )
								{
									switch( arr.type ){
										case "sent":
											
											messages[arr.chatId][i].seen = [];
											messages[arr.chatId][i].id	 = arr.id_message;
											//console.log("seen ==> ["+i+"] ==> "+arr.chatId+" >>> ");
										break;
										case "error":
										
										break;
										case "seen":
											messages[arr.chatId][i].seen = arr.seen;
										break;
									}
								}	
							}
							 
							window.SC().$apply();
					}, 
                	onDropComplete: function( data, evt ){
                		this.removeChatHead( data );
                	},
                	removeChatHead: function( obj ){
                		//console.log("delete remove chat head" );
                		//alert('da');
                		for( var i in heads )
                		{
                			//console.log("id = "+( heads[i].id )+" == "+( obj.id )+" << ");
                			if( heads[i].id == obj.id )
                			{
                				//console.log('delete');
                				heads.splice(i,1);
                				//console.log("heads ===> "+JSON.stringify(heads) );
                				if( typeof this.opened().id != 'undefined' )
                					if( this.opened().id == obj.id )
                						this.closeChats();
                			}
                		}
                		
                		
                		if( heads.length == 0 )
                			chat.getVar('minimized-heads','');
                		else{
                			for( var i in heads ){
                				if( heads[i].id !="-1" ){
									//alert(JSON.stringify(heads[i]));
									this.openChat(heads[i], 'slideInUp');
									return 1;
                				}
                			}
                		}
                		
                		
                	},
                 
                	
                	getWriter: function(){
                		return 	{'id_account':me.get('id_account'),'username':me.get('username'),'picture':me.get('picture')};
                	},
                	
                	isConnected: function(){ 
                		if( typeof sockjs == 'undefined' )
                			return 0;
                		
						if( sockjs['readyState'] == 3 )
							return 0;
						
						return 1;
					},
                	getTemporaryId: function(){
						var N = 6;
						return 'a'+( Array(N+1).join((Math.random().toString(36)+'00000000000000000').slice(2, 18)).slice(0, N) );
					},
					getLastMessage: function( chat ){
						for( var i in this.getMessages(chat) ){
							
						}
					},
					announceTyping: function(   ){
							if( !this.isConnected() )
								this.socksConnect();
							var chatId = this.opened().id;
							if( typeof  announcedTyping[chatId] == 'undefined' ){
								
								//console.log("announceTyping ----"+(typeof this.announcedTyping[chatId]));
								if( typeof sockjs != 'undefined' )
									sockjs.send( JSON.stringify({'type':'typing','writer': this.getWriter(), 'chatId':chatId,'users':this.getUsers(chatId) } ) );   
								announcedTyping[chatId] = 1;	
								delete announcedNOTTyping[chatId];
							}
					},
						
					announceNoLongerTyping: function(   ){
						var chatId = this.opened().id;
						if( !this.isConnected() )
							this.socksConnect();
					 
							if( typeof announcedNOTTyping[chatId] == 'undefined' ){
								delete announcedTyping[ chatId ];	
								announcedNOTTyping[chatId] = 1;	
								//console.log("not typing ----"+(typeof this.announcedTyping[chatId]));
								if( typeof sockjs != 'undefined' )
									sockjs.send( JSON.stringify({'type':'not-typing','writer': this.getWriter(), 'chatId':chatId,'users':this.getUsers(chatId) } ) );   
							}
					},
                	submitMessage: function(  message ){
                		if( !this.isConnected() )
							this.socksConnect();
			 
						if( typeof message == 'undefined' )
							message = document.getElementById('chat-textarea').value;
						
						if( message.length < 1 )
							return 1;
					 
						document.getElementById('chat-textarea').value = ''; 
						
						//var message = chatMessage.value;
						var chat	= this.opened();
						var chatId  = chat.id;
						var tempId  = this.getTemporaryId();
						var obj		= this;
						
						this.saveMessage( chat, {'message':message,'id_account':me.get('id_account'),'seen':{'loading':1},'tempId':tempId,'writer':this.getWriter(),'chatId':chatId}, 'append', this.getLastMessage( chat ) );
						try{
							//console.log("[1]>>>>>>>>>>>>>>>>>> sockjs.send << ");
							sockjs.send( JSON.stringify({'type':'send','message':message,'id_account':me.get('id_account'),'writer': this.getWriter(),'chatId':chatId,'tempId':tempId,'users':this.getUsers(chatId)}));   
							obj.announceNoLongerTyping(  );
						}
						catch(e){
									//console.log("error --> "+JSON.stringify(e)+" <-- ");
									var obj = this;
									sendingInterval[tempId] = setInterval(function(){ 
									//console.log("message interval");
									if( obj.isConnected() ){ 
										//console.log("connected");
										//console.log("[2]>>>>>>>>>>>>>>>>>> sockjs.send << ");
							
										sockjs.send( JSON.stringify({'type':'send','message':message,'id_account':me.get('id_account'),'writer': obj.getWriter(),'chatId':chatId,'tempId':tempId,'users':obj.getUsers(chatId)}));   
										obj.announceNoLongerTyping(  );
										clearInterval( sendingInterval[tempId] );
									}else obj.socksConnect();
									
							}, 1000 ); 
						}  
                	},
                	
                	openChatJS: function(){
                		$scope = window.SC();
                		$scope.centerAnchor 		= true;
						$scope.toggleCenterAnchor 	= function () {$scope.centerAnchor = !$scope.centerAnchor}
						$scope.draggableObjects 	= [{name:'one'}, {name:'two'}, {name:'three'}];
						$scope.droppedObject 		= [];
						$scope.chat.setVar('magnet-class','hidden');
						$scope.onDropComplete		=function(data,evt){
						 
							  if( chat.openendChat( data.id ) )
							  	  chat.closeChats();
						}
						 $scope.$on('draggable:start', function(evt, data){
						 	//console.log('started dragging');	
						 	$scope.chat.setVar('magnet-class','fadeIn');
						 	$scope.chat.setVar('show-magnet',1);
						 	$scope.chat.setVar('chat-box-drag', 'hiddenOut');
						 });
						 
						 $scope.$on('draggable:drop', function(evt, data){ 
						 //	console.log('dropped');	 
						 });
						 
						 $scope.$on('draggable:end', function(evt, data){
						 	//console.log('stopped dragging');	 
						 	$scope.chat.setVar('magnet-class','hidden');
						 	$scope.chat.setVar('show-magnet',0);
						 	$scope.chat.setVar('chat-box-drag', '');
						 });
						
						$scope.onDragSuccess =function(data,evt){
							 
							var index = $scope.droppedObjects1.indexOf(data);
							if (index > -1) {
								$scope.droppedObjects1.splice(index, 1);
							}
						}
						
						var inArray = function(array, obj) {
							var index = array.indexOf(obj);
						}

                	},

                    setScope: function(angularScope) {
                        scopePointer = angularScope;
                    },

                    setVar: function(which, to) {
                        vars[which] = to;
                    },

                    getVar: function(which, to) {
                        return vars[which];
                    },
                    
                    setFriends: function( to ){  
                    	friends = to;
                    },
                    
                    setHeads: function( how, list ){
                    	//console.log('settings heads ---> '+how);
                    	if( how == 'unread' )
                    	{
                    		for( var i in list )
                    		{
                    			//console.log(">>>> list["+i+"] ==> "+JSON.stringify(list[i])+" <<<< ");
                    			if( parseInt(list[i].unread) >= 1 )
                    				this.addHead( list[i] );
                    		}	
                    	} 	 
                    },
                    
                    addHead: function( obj ){
                    	
                    	for( var i in heads )
                    		if( heads[i].id == obj.id )
                    			return 1;
                    	//console.log("add Head   -->"+JSON.stringify(obj));
                    	//console.log("before | heads --> "+JSON.stringify(heads) );
                    	heads.push(obj);
                    	//console.log("add head"+    JSON.stringify( obj ) );
                    	//console.log(" heads ===> "+JSON.stringify( heads ) );
                    },
                    
                    isOpen: function( id_chat ){
                    	
                    	if( this.boxOpened() )
                    		if( this.opened().id == id_chat ) 
                    			return 1;
                    		
                    		return 0;
                    },
                    
                    boxOpened: function(){
                    	//console.log(">>>>"+(typeof opened.id)+"<<<<");
                    	if( typeof opened == 'undefined' )
                    		return 0;
                    	
                    	if( typeof opened.id != 'undefined' )
                    		return 1;
                    	else
                    		return 0;  
                    },
                    
                    singleUser: function( item ){ 
                    	var items = item.id.split("-"); 
                    	if( items[0] == 'u' )
                    		if( items.length == 3 )
                    			return 1;
                    		
                    	return 0;
                    },
                    unread: function( item ){ if(item.unread>=1) return 1;else return 0; },
                    
                    timeSince: function( item ){
                     
                    	var date = item.last_login;
                    	if( typeof date == 'undefined' )
                    		return '';
                    
                    date = date.replace(' ','T');
                    	
                    var unixTimestamp  = new Date( date ).getTime()/1000
                     	  	 
                     //console.log("unixTimestamp "+(unixTimestamp)+" date == > "+date);
                     //console.log('current date '+((new Date().getTime()/1000)));
                     	  	 
						var seconds = Math.floor(( (new Date().getTime()/1000) -  (unixTimestamp)))
						
						var interval = Math.floor(seconds / 31536000);
					
					  //console.log("seconds = "+seconds);
						
						interval = Math.floor(seconds / 86400);
						var v = {};
						v.interval = interval;
						if (interval >= 1 && interval <= 31) {
								
							return tr('{interval}d',v);
						}
						else if( interval >= 31 )
						{
								interval = Math.floor(seconds / (7*86400)); 
								v.interval = interval;
								return tr('{interval}w',v);
						}
						
						interval = Math.floor(seconds / 3600);
						v.interval = interval;
						if (interval > 1 ) {
						return tr('{interval}h',v);
						}
						interval = Math.floor(seconds / 60);
						 v.interval = interval;
						if (interval > 1  ) {
							
						 return tr('{interval}m',v);
						}
					   
						if( seconds <= 0 )
								seconds = 1;
						 v.interval = seconds;
						return tr('{interval}s',v);
                    },
                    
                    openedChat: function( id ){
                    	if( typeof opened.id == 'undefined' )
                    		return 0;
                    	
                    	if( id == opened.id )
                    		return 1;
                    	else
                    		return 0;
                    },
                    
                    opened: function(){
                    	return opened;
                    },
                    
                    getHeads: function(){ 
                    	
                    	return heads;
                    },
                    
                    getFriends: function(){
                    	return friends;	
                    },
                    
                    shortText: function( text ){
                    	return text.substr(0,3);
                    },
                    
                    setScrollbars: function(){
                    	//window.SC().$broadcast('rebuild:me');   
                    },
                    
                    disableScrollbars: function(){ 
                    	 
                    	document.getElementsByTagName('body')[0].className+=' noScroll'; 
                    	 
                    	//$('body').on('touchmove', function(e){ 
						//	if($('.noScroll').has($(e.target)).length) e.preventDefault();
						//});
                    	//document.documentElement.style.overflow = 'hidden';  // firefox, chrome
                    	//document.body.scroll = "no"; // ie only 
                    },
                    
                    enableBodyScrollbar: function(){
                   
                    	document.getElementsByTagName('body')[0].className = 'ng-scope';
                    	//document.documentElement.style.overflow = 'auto';  // firefox, chrome
                    	//document.body.scroll = "yes"; // ie only
                    },
                    
                    closeFriendList: function(){
                    	this.setVar('chat-friends-list','chat-friends-list hidden');
                    	this.enableBodyScrollbar();
                    },
                    
                    openFriendList: function(){
                    	number=0;
                    	for( var i in this.getFriends() )
                    		number++;
                    	
                    	if( number == 0 ) 
                    		this.load();   
                    		
                    	this.setVar('chat-friends-list','chat-friends-list show');
                    	this.disableScrollbars();
                    },
                    
                    getSeenIcon: function( m ){
                    	 
                    	if( typeof m.seen == 'undefined' )
                    		return '<img src="pics/chat/sent.svg" title="'+this.getSeenIconText( [],m )+'" style="width:12px;">';  
                    	
                    	var seen 	= m.seen;
                    	var loading = seen.loading;
                    	if( loading )
							return '<img src="pics/chat/sending2.svg" style="width:12px;">';
						
						var seenCheck = ''; 
						if( typeof seen == 'undefined' )
							return '<img src="pics/chat/sent.svg" title="'+this.getSeenIconText( seen,m )+'" style="width:12px;">';  
						
						//console.log(" seen.legnth ==> "+seen.length);
						if( seen.length == 0 )
								seenCheck = '<img src="pics/chat/sent.svg"  style="width:12px;" title="'+this.getSeenIconText( seen,m )+'">'; 
							if( seen.length == 1 )
								seenCheck = '<img src="pics/chat/seen.svg"  style="width:12px;" title="'+this.getSeenIconText( seen,m )+'">';
							if( seen.length >= 2 )
								seenCheck =  '<font class="chat-seen-number"  style="width:12px;"  title="'+this.getSeenIconText( seen,m )+'"><img src="pics/chat/seen.svg" title="'+this.getSeenIconText( seen,m )+'"  style="width:8px;">'+(seen.length)+'</font>';
							
						return seenCheck;
                    },
                    getSeenIconText: function( seen,m ){
               
						var seenText = [];
						var sent	 = m;
						 
						//console.log(">>>>>>>>>>>>SEEEN>>>>>>>>>>>>>>"+JSON.stringify(seen)+">>>>>>M>>>>>>>>>>>>"+JSON.stringify(m));
						if( typeof seen != 'undefined' )
						if( typeof seen[0] != 'undefined' )
						if( typeof seen[0].from_user != 'undefined' ){
								var writer = {username: this.getUser( seen[0].from_user).username };
								sent.when  = seen[0].when;
								
								console.log("sent.when[2] ==> "+sent.when+" seen[0].when = "+seen[0].when );
							}
							else var writer = m.writer; else var writer = m.writer;
						 
				 
						seenText.push( this.transformTimestamp( sent.when )+' -- '+tr('Sent by {username}',writer).toUpperCase() );
							if( typeof seen == 'undefined' )
								return seenText.join('\n');
						 
						
						for( var i in seen ){
							 
							seenText.push( this.transformTimestamp( seen[i].seen )+' -- '+tr('Seen by {username}',this.getUser(  seen[i].to_user ) ).toUpperCase() );	
						}
						
						return seenText.join('\n');
					},
					
					lookForUnseen: function( chatId ){
						if( typeof unseenMessages[chatId] != 'undefined' )
						{
							if( unseenMessages[chatId].length > 0 ){
				 
								//console.log("DA SENDING => "+JSON.stringify({'type':'seen','writer': this.getWriter(),'messages':this.unseenMessages[chatId], 'chatId':chatId,'users':this.getUsers(chatId) } )+"<<<" );
								sockjs.send( JSON.stringify({'type':'seen','writer': this.getWriter(),'messages': unseenMessages[chatId], 'chatId':chatId,'users':this.getUsers(chatId) } ) );   
								unseenMessages[chatId] = []; 
							} 
						}
					}, 
					setSeenAndTypingListener: function( chatId ){
	
						//console.log("set listener");
						this.lookForUnseen( chatId ); 
					},
					
					openedHead: function( chatId ){
						//are heads opened anyway ?
						//alert(this.boxOpened() + ' || ' + this.getVar('minimized-heads') );
						if( this.boxOpened() || this.getVar('minimized-heads')=='minimized-heads' ){
							for( var i in heads )
								if( heads[i].id == chatId )
									return 1;
								
							return 0;
						}
						
						return 0;
					},
					
					setUnreadChats: function(chatId, to ){
						
						//heads
						for( var i in heads )
							if( heads[i].id == chatId )
								if( to == '+' )
									heads[i].unread++;
								else
									heads[i].unread = to;
						
						//friendlist
						for( var i in friends )
							if( friends[i].id == chatId )
								if( to == '+' ) 
									friends[i].unread++; 
								else
									friends[i].unread = to;
							
						
						window.SC().$apply();
						
					},
					
					setEverythingToSeen: function( chatId ){
						var obj = this;
						try{
							sockjs.send( JSON.stringify({'type':'seen','writer': obj.getWriter(),'messages':[0,1], 'chatId':chatId,'users':obj.getUsers(chatId) } ) );   
							obj.setVar('active-'+chatId,'animated fadeOutLeft');
							setTimeout(function(){  obj.setUnreadChats( chatId, 0 );}, 3000);	
						}
						catch(e){
							setTimeout(function(){ sockjs.send( JSON.stringify({'type':'seen','writer': obj.getWriter(),'messages':[0,1], 'chatId':chatId,'users':obj.getUsers(chatId) } ) );    }, 3000);
						}
					},
					
					loadMore: function(){
						
						var obj  = this;
						var to   = maxMessages;
						var chat = this.opened();
						var direction = 'bottom';
						//ajax call for content
						var from = obj.getVar('last-load-'+chat.id )+maxMessages;
                    	var promise = AJAX.get('CHAT', 
                    							{'id_chat'  : chat.id,
                    							 'get'		: 'messages',
                    							 'limit'	: from+','+to 
                    							},0);
						promise.success(function(data, status, headers, config) {  
					 
								if( data.status == 'SUCCESS' ){
									
									 
									obj.setVar('last-load-'+chat.id, from );
									
									if( typeof direction == 'undefined' )
										data.ret.messages.reverse();
									else{
										if( direction == 'append' )
											data.ret.messages.reverse();
									}
										
									for( var i in data.ret.messages ){
										var m = data.ret.messages[i];
										  
										
										obj.saveMessage( chat,m, direction );
										//save last message, we'll check whether to add a
										//timestamp. if new message after 6 hours of silence 
										
										if( !obj.iveSeenThis( m ) )
											obj.addUnseenMessage( m );
									}
									
									 
									if( data.ret.messages.length == maxMessages )
										obj.setVar('can-load-more',1);	
									else
										obj.setVar('can-load-more',0);
									
								obj.lookForUnseen( chat.id ); 
								}
									
						}); 
						
						promise.error(function(data, status, headers, config) {
									window.SC().API.setResting(false);
									window.SC().API.setError( data.ret.message );
						}); 
                   
					},
					
					performSearch: function( searchString ){
						if (searchTimer) 
							clearTimeout(searchTimer);
					
					
					var search  = searchString;
					var obj     = this;
					searchTimer = setTimeout(function( ){ obj.load( search ); }, 400); 
						
					},
					
					changeOpened: function( which, to ){
						opened[which] = to;
						for( var i in heads )
							if( heads[i].id == opened.id )
								heads[i][which] = to;
					},
					
                    openChat: function( chat, direction, from, to, flag ){
                    	//unminimize heads
                    	this.closeFriendList();
                    	this.setVar('minimized-heads','');
                    	//add heads
                    	this.addHead(chat);
                    	this.disableScrollbars();
                    	
                    	//
                    	this.setEverythingToSeen(chat.id);
                    	
                    	opened 		= chat;	
                    	var obj 	= this;
                    	
                    	//show the chat
                    	if( typeof direction == 'undefined' )
                    	{
                    		this.setVar('chat-openend-how','vertical animated slideInRight');
                    		this.setVar('textbox-class',' animated slideInRight');	
                    	}
                    	else
                    	{
                    		this.setVar('chat-openend-how','vertical animated '+direction);
                    		this.setVar('textbox-class',' animated '+direction);
                    	}
                    	
                    	
                    	//hide load more
                    	obj.setVar('can-load-more',0);
                    	obj.setVar('chat-error', '');
                    	obj.setVar('last-load-'+chat.id, 0 );
                    	
                    	if( typeof from == 'undefined' )
                    		from = 0;
                    	
                    	if( typeof to == 'undefined' )
                    		to   = maxMessages;
                    	
                    	
                    	//ajax call for content
                    	var promise = AJAX.get('CHAT', 
                    							{'id_chat'  : chat.id,
                    							 'get'		: 'fields,picture,messages,users,muted',
                    							 'limit'	: from+','+to 
                    							},0);
                    	
                    	//clear messages and lastmessage
                    	var lastMessage = {};
                    	 
                    	messages[chat.id] = [];
						promise.success(function(data, status, headers, config) {  
					 
						 
								if( data.status == 'SUCCESS' ){
									
									obj.setUsers( chat.id, data.ret.users );
									obj.setVar('last-load-'+chat.id, from );
									obj.changeOpened('text',   data.ret.fields.text   ); 
									obj.changeOpened('picture',data.ret.fields.picture); 
									
									
									if( typeof direction == 'undefined' )
										data.ret.messages.reverse();
									else{
										if( direction == 'append' )
											data.ret.messages.reverse();
									}
										
									for( var i in data.ret.messages ){
										var m = data.ret.messages[i];
										
										//add to unseen list of messages
										if( !obj.iveSeenThis( m ) )
											obj.addUnseenMessage( m );
									 
									 
										obj.saveMessage( chat,m, direction, lastMessage );
										//save last message, we'll check whether to add a
										//timestamp. if new message after 6 hours of silence
										lastMessage = m;
									}
									
									obj.setVar('chat-muted',data.ret.muted);
									 
									if( data.ret.messages.length == maxMessages ){
										obj.setVar('can-load-more',1);	
									}
									else
										obj.setVar('can-load-more',0);
									
									window.SC().$broadcast('rebuild:messages');
									//chiar nu pot urmari nenorocirea aia de anchorScroll :))
									var objDiv = document.getElementById("#chat-scroll");
									if( typeof objDiv != 'undefined' )
										if( objDiv != null )
											objDiv.scrollTop = objDiv.scrollHeight;
									
									//typing listener is direclty set into the javascript function at the bottom
									obj.setSeenAndTypingListener( chat.id ); 
							 
								}
								else
									obj.setVar('chat-error', data.ret.message);
						}); 
						
						promise.error(function(data, status, headers, config) {
									window.SC().API.setResting(false);
									window.SC().API.setError( data.ret.message );
						}); 
                    },
                    
                    toggleMute: function(){
                    	var obj = this;
                    	var promise = AJAX.patch('CHAT', 
                    							{'id_chat'  : this.opened().id,
                    							 'edit':{'mute'		: obj.getVar('chat-muted')==1?0:1}  } 
                    	);
                    	var obj = this;
                    	promise.success(function(data, status, headers, config) {  
					 
                    			//alert(data.status);
								if( data.status == 'SUCCESS' ){
									obj.setVar('chat-muted',(obj.getVar('chat-muted')==1?0:1) );
									window.SC().API.setMessage( data.ret.message );
									//window.SC().$apply();
								}
								else{
									window.SC().API.setResting(false);
									window.SC().API.setError( data.ret.message );
								}
								});
                    	promise.error(function(data, status, headers, config) {
									window.SC().API.setResting(false);
									window.SC().API.setError( data.ret.message );
						});
                    },
                    
                    iveSeenThis: function( message ){
                    	if( typeof message.seen == 'undefined' )
                    		return 0;
                    	var seen = message.seen;
                    	var iveSeenThis = 0;
						for( var i in seen )
							if( seen[i].id_account == me.get('id_account') )
								iveSeenThis = 1;
                    },
                    
                    addUnseenMessage: function( opt ){
						//console.log("add UNSEEN MESSAGE -- "+opt.chatId);
						var chatId = opt.chatId;
						if( typeof unseenMessages[chatId] == 'undefined' )
							unseenMessages[chatId] = [];
						
						if( typeof opt.id == 'undefined' ) var id_message = opt.id_message; else var id_message = opt.id;
				 
						unseenMessages[chatId].push( id_message ); 
					},
					
					showSeens: function( ){
						
					},
					
					showTimestamp: function( index, item ){
						
				 
						var messages = this.getMessages(this.opened());
					
						//console.log("index = "+index+">>>"+ messages[parseInt(index)]);
						if( typeof messages[parseInt(index)-1] != 'undefined' ){
							var date1 = new Date( item.when 			 	);
							var date2 = new Date( messages[index-1].when 	);
							var hours = Math.abs( date1 - date2 			) / 36e5;
							//console.log(">>>>"+hours);
							if( hours >= 3 )
								return 1;
							else
								return 0;
						}
						else
							return 1;
						
						return 0;
						
					},
					
					parseTimestamp: function( dateTime ){
					 
						var months = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];
						var dt = new Date( dateTime );
						return dt.getDate()+' '+ tr(months[ dt.getMonth() ])+' @ '+((dt.getHours()<10?'0':'') + dt.getHours())+':'+((dt.getMinutes()<10?'0':'') + dt.getMinutes());
					},
                    
                    saveMessage: function( chat, message, direction, lastMessage ){
                    		
                    	//console.log("id="+message.id+" when="+message.when+"add");	
                    	//compare two dates. if more than 6 hours 
                    	//add new timestamp 
                    	//console.log('>>ADD>>'+JSON.stringify(message));
                    	if( typeof messages[chat.id] == 'undefined' )
                    		messages[chat.id] = [];
                    	 
                    	if( typeof direction == 'undefined' )
                    		messages[chat.id].push( message );
                    	else if( direction == 'append' )
                    		messages[chat.id].push( message );
                    	else
                    		messages[chat.id].unshift( message );
                    	 
                    },
                    
                    getMessages: function( chat ){
                    	
                     
                    	if( typeof messages[chat.id] != 'undefined' )
                    		return messages[chat.id];
                    	
                    	return [];	
                    },
                    
                    linkify: function(str){
						// order matters
						if( typeof str == 'undefined' )
							return '';
						
						var re = [
						"\\b((?:https?|ftp)://[^\\s\"'<>]+)\\b",
						"\\b(www\\.[^\\s\"'<>]+)\\b",
						"\\b(\\w[\\w.+-]*@[\\w.-]+\\.[a-z]{2,6})\\b", 
						"@([a-z0-9]+)"];
						re = new RegExp(re.join('|'), "gi");
					
						return str.replace(re, function(match, url, www, mail, twitler){
						if(url)
							return "<a href=\"" + url + "\">" + url + "</a>";
						if(www)
							return "<a href=\"http://" + www + "\">" + www + "</a>";
						if(mail)
							return "<a href=\"mailto:" + mail + "\">" + mail + "</a>";
						if(twitler)
							return '<a href="#account/'+twitler+'">'+twitler+'</a>'; 
						
						// shouldnt get here, but just in case
						scopePointer.apply();
						return match;
				
						});
					},
                    
					getAvatar: function( item ){
						//console.log("AVATAR ==> "+JSON.stringify(  ( item.writer ) ) );
						var picture = item.writer.picture;
						if( picture == null )
							picture =   'images/fb/avatar'+parseInt(item.writer.id_account%13)+'.png';
					 
						return '<img src="https://cyberdunk2.com/'+picture+'">';
					},
					
                    isMyMessage: function( message ){
                    	
                    	if( message.id_account == me.get('id_account') )
                    		return 1;
                    	
                    	return 0;
                    	
                    },
                    
                    setUsers: function( chatId, userList ){
                    	
                    	for( var id in userList ){
                    		users[id] = userList[id];	
                    		if( typeof usersByChat[chatId] == 'undefined' )
                    			usersByChat[chatId] = [];
                    		usersByChat[chatId].push(id);
                    	} 
                    },
                    
                    getUsers: function( chatId ){
                    	return usersByChat[chatId];
                    },
                    
                    getUser: function( id ){
                    	return users[id];
                    },
                    
                    transformTimestamp: function( dateTime ){
						var d = new Date(dateTime);
						months = ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec'];
						var hours   = d.getHours();
						var minutes = d.getMinutes();
						var seconds = d.getSeconds();
						var formattedDate = (hours<=9?'0'+hours:hours)+":"+(minutes<=9?'0'+minutes:minutes)+":"+(seconds<=9?'0'+seconds:seconds)+"  "+d.getDate()+" "+tr(months[d.getMonth()])+" "+d.getFullYear();
						return formattedDate;
					},
                    
                    clickedHead: function( obj ){
                    	 
                    	//1. heads are minimized, show.
                    	
                    	if( typeof this.opened() != 'undefined' ){
                    		 
                    		if( obj.id == this.opened().id )
                    		{
                    			//2. chat already open so close all heads and move to right	
                    			this.minimizeHeads();
                    			this.closeChats(); 
                    			return 1;
                    		}
                    		 
                    	}
                    	
                    		//3. else open chat
                    		this.openChat( obj, 'slideInUp' );
                    		this.setVar('minimized-heads','');
                    },
                    
                    closeChats: function(){
                    	opened 						   = {}; 
                    	this.setVar('textbox-class','hidden');
                    	this.enableBodyScrollbar();
                    },
                    
                    minimizeHeads: function(){
                    	 
                    	this.setVar('minimized-heads','minimized-heads');
                    },
                    
                    hasUnread: function( obj ){ return parseInt(obj.unread); },
                    
                    start: function(){
                    	heads = [ {'id':-1,'unread': -99} ]; 
                    },
                    
                    load: function( search ){
                    
                    		//this.disableTouchStartFunctions(); 
                    	    this.start();
                    		//heads.push( {'id':-1},{'id':2,'username':'Talad','pic':'http://cyberdunk2.com/images/wall_avatars/1502.jpg'} );
                    		 
                    		var obj = this; 
							var searchType = 'ajax';
							var what = {get:'friends', fields: 'username,last_login,team' };
							if( typeof search != 'undefined' )
								if( search.length >= 1 )
									if( this.lastSearch != search )
									{
										lastSearch = search;
										what.search	= search;
										doSearch 	= 'ajax';
									}
									else
										return 1;
							
							 
							if( typeof search == 'undefined' || ( typeof search != 'undefined' && searchType == 'ajax' ) )
							{ 
								var promise = AJAX.get('CHAT', what,1 );
								promise.success(function(data, status, headers, config) {  obj.setFriends( data.ret.friends );   
								
								obj.setScrollbars(); 
						
								});
								promise.update(function(data, status, headers, config) {  
								obj.setFriends( data.ret.friends );  
								 
								obj.setScrollbars();
							 
								
								obj.setHeads( 'unread',  data.ret.friends  );  });
								promise.error(function(data, status, headers, config) {
									scopePointer.API.setResting(false);
									scopePointer.API.setError( data.ret.message );
								}); 
							}
                    }
                }

            }
        ]);
}());


function onChatSend( event, obj ){
	  
                		var message = obj.value;
                		
                		if (message != '' ) 
								window.SC().chat.announceTyping(  );
									else
									  window.SC().chat.announceNoLongerTyping(  );	
                		 
                		//alert(document.getElementById('chat-textarea').value);
                		if( event.shiftKey && event.which == 13)
						{ 
							obj.rows = obj.rows + 1;
							 
						}
						else
						{ 
							if(event.which == 13   ) {  
								event.stopPropagation();
								event.preventDefault();
								obj.rows  = 2; 
								
								window.SC().chat.submitMessage(  message  );  
								window.SC().$apply();
								obj.value = '';
								document.getElementById('chat-textarea').value = ''; 
							} 
						}	  
}

function onChatSendClick(){
	//alert('clicked');
}