(function () {
  
    var scopePointer;
    var id      	= 0;
    var type		= 1;
    var teams		= {};
    var previousSeason;
    var page;
    var dbHelp		= {};
    
      
		
    angular.module('myApp.comp', ['myApp.AJAX','myApp.me' ])
        .service('comp', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                	get: function( compType, compId, $scope, season )
                	{
                		 
                		scopePointer = $scope;
                		id	     = compId;
                		type	     = compType;
                	
                		
                		if( scopePointer.tutorial )
                			scopePointer.tutorial.doneStep( 'viewLeague' );
                		
                		/* CURRENT FROM SERVER */
                		if( typeof season == 'undefined'  )
                			previousSeason = me.get('season');
                				else
                					previousSeason = season;
                		
                		
                		//sql for team data
                		var obj = this; 
                		var table = this.getTable( compType );
                		 
                		var sqlCompId = compType+"-"+compId+"-"+previousSeason;
                	 
                		me.get('competitions', sqlCompId ).then(function( result ) { 
                			 
                			if( typeof result[0] != 'undefined' )
                			{
                				obj.parseData( 'competition', result[0] );
                				if( obj.needsAjax( result[0] ) )
                					obj.ajaxForIt();
                					}
                					else
                						obj.ajaxForIt();
                			
                    	    	});
                    	    	var fields = {};
                    	    	fields.location = compType;
                    	    	fields.id	= compId+'-'+compType;
                    	    	
                    	    	me.get('wall', fields.id, fields ).then(function( result ) { 
                    	    	
                    	    		if( typeof result[0] != 'undefined' )
                    	    			obj.parseData( 'wall', result[0] );
                    	    				
                    	    	});
                    	    	 
                    	    
                    	    	//this.ajaxForIt();
                	},
                	
                	needsAjax: function( result ) 
                	{
                		
                		if( result.fields.season == me.get('season') )
                		{
                			
                			if( result.timestamp.day != me.get('day') )
                				return 1;
                			
                			//if( result.next_round[0].sim.day == me.get('day') )
                			//	return 1;
                		}
                		
                		return 0;
                	},
                	
                	parseData: function( which, result )
                	{
                		 
                		var obj = this;
                		if( which == 'competition' )
                		{  
					scopePointer.data 	 = result; 
					scopePointer.data.title	 = result.fields.name;
					for( var poolNum in result.standings )
						for( var item in result.standings[poolNum] )
							if( typeof result.standings[poolNum][item].team != 'undefined' )
								teams[ result.standings[poolNum][item].team.fields.id ] = result.standings[poolNum][item].team;
					
						
					var option 	= {}; 
					scopePointer.knockSelector = [];
					if( typeof result.playoffs != 'undefined' )
						for( var numRunda in result.playoffs )
						{
							option 	= {};
							option.name  	= obj.getKnockName( numRunda, result.playoffs[numRunda].length );
							option.value 	= numRunda;
						
							scopePointer.knockSelector.push( option );
							scopePointer.data.knockFilter = numRunda;
							scopePointer.maxRound	 = numRunda; 
						}
						 
					if(  scopePointer.data.last_round )
						obj.createSelectOptions('last_round', result);
						
					if(  scopePointer.data.next_round  )
						obj.createSelectOptions('next_round', result);
						 
					if( previousSeason != me.get('season') ) 
					{
						var v = {};
						v['season'] = previousSeason;
						v['name']   = result.fields.name;
						scopePointer.data.title = tr('{name} during S{season}',v); 
							}
							else
								scopePointer.data.title	 = result.fields.name;
			 
					
					obj.createSelectOptions('previousSeasons', result );
					
					if( type != 1 )
						obj.getTeamsFromKnockoutTable( result );
				}
				else
				{ 
					scopePointer.data.posts = result.posts;
				}
						
                	},
                	
                	getTable: function( compType )
                	{
                		if( compType == 1 )
                			return 'leagues';
                				else
                					return 'tournaments';
                	},
                	
                	getId: function()
                	{
                		return id;	
                	},
                	
                	//1=league, 2=intl 
                	getType: function()
                	{
                		return type;	
                	},
                	
                	getPlayoffString: function()
                	{
                		if( typeof scopePointer.data.fields == 'undefined' )
                			return tr('Playoffs');
                				else
                				{
                					var v = {};
                					v.playoff_start = scopePointer.data.fields.playoff_start;
                					v.last_day 	= me.get('days');
                					//return tr('Playoffs - day {playoff_start} through {last_day}',v);
                					return tr('Playoffs',v);
                				}
                		return tr('Playoffs');
                	},
                	
                	ajaxForIt: function()
                	{ 
                		//performs ajax request for data 	
                		
                		if( type == 10 )
                			var getWhat = { 'get':'fields,teams,playoffs,mvp_race,last_round,next_round,stats,schedule,allstar','id':id, 'location':type, 'season': previousSeason };			
                				else
                					var getWhat = { 'get':'fields,standings,playoffs,mvp_race,last_round,next_round,previous_winners,stats,schedule,posts,allstar','id':id, 'location':type, 'season': previousSeason };
				var promise = AJAX.get('COMPETITION', getWhat, 1 ); 
				var myPos = 0;
				scopePointer.API.setResting(true);
				var obj = this;
				promise.success(function(data, status, headers, config) {
					obj.updateView( data );
				}); 
				
				if( promise.update )
					promise.update(function(data, status, headers, config) {
						obj.updateView( data );
					}); 				
					
				promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );	
				}); 
                	},
                	
                	updateView: function( data )
                	{
                		var obj = this;
                		if( data.status == 'SUCCESS' )
				{
					scopePointer.cachedCopy = data.cache;
					if( !data.cache )
						scopePointer.API.setResting(false);
					scopePointer.API.checkNotifications( data, scopePointer);
					//aici o sa fie mai multe synch-uri
						  
					scopePointer.data 	 = data.ret;
					scopePointer.data.title	 = data.ret.fields.name;
					for( var poolNum in data.ret.standings )
						for( var item in data.ret.standings[poolNum] )
						{ 
							teams[ data.ret.standings[poolNum][item].team.fields.id ] = data.ret.standings[poolNum][item].team;
							if( me.get('season') == data.ret.fields.season )
								me.synch('teams', data.ret.standings[poolNum][item].team, null, data.timestamp );
						}
						 
					data.ret.id = data.ret.fields.type+"-"+data.ret.fields.id+"-"+previousSeason;
						
					me.synch('competitions', data.ret, null, data.timestamp  );
						
					scopePointer.knockSelector = [];
					if( typeof data.ret.playoffs != 'undefined' )
						for( var numRunda in data.ret.playoffs )
						{
							option 	= {};
							option.name  	= obj.getKnockName( numRunda, data.ret.playoffs[numRunda].length );
							option.value 	= numRunda;
								 
							scopePointer.knockSelector.push( option );
							scopePointer.data.knockFilter = numRunda;
							scopePointer.maxRound	 = numRunda; 
						}
							
					scopePointer.form.help = obj.getHelp('page');
						 
					if( type != 1 )
						obj.getTeamsFromKnockoutTable( data.ret );
						
					var insertPosts 	= {fields:{}};
					insertPosts.posts 	= data.ret.posts;
					insertPosts.fields.id  	= data.ret.fields.id + '-'+  data.ret.fields.type;
					insertPosts.fields.location  	= data.ret.fields.type;
						 
					me.synch('wall', insertPosts, null, data.timestamp  );
						
					if(  scopePointer.data.last_round )
						obj.createSelectOptions('last_round', data.ret);
						
					if(  scopePointer.data.next_round  )
						obj.createSelectOptions('next_round', data.ret);
						
					obj.createSelectOptions('previousSeasons', data.ret );
						 
					
					if( typeof data.ret.allstar != 'undefined' )
						if( data.ret.allstar.fields.status == 'manager' ){
							scopePointer.selector.options.allstar_manager = [];
							scopePointer.selector.options.allstar_manager.push({name: tr("Don't manage an all star team"), 	value:'dont'});
							scopePointer.selector.options.allstar_manager.push({name: tr('Apply for free'), 	value:'apply'});
							scopePointer.selector.options.allstar_manager.push({name: tr('Buy a team for {teamCost} CyberPoints ({teamsBought} / {teamsBuyable})', data.ret.allstar.fields), 	value:'buy'});
							 
							if( data.ret.allstar.currentChoice == 'dont' )
								scopePointer.selector.model.allstar_manager = scopePointer.selector.options.allstar_manager[0];
							if( data.ret.allstar.currentChoice == 'apply' )
								scopePointer.selector.model.allstar_manager = scopePointer.selector.options.allstar_manager[1];
							if( data.ret.allstar.currentChoice == 'buy' )
								scopePointer.selector.model.allstar_manager = scopePointer.selector.options.allstar_manager[2];
					}
					
					if( previousSeason != me.get('season') ) 
					{
						var v = {};
						v['season'] = previousSeason;
						v['name']   = scopePointer.data.fields.name;
						scopePointer.data.title = tr('{name} during S{season}',v); 
							}
							else
								scopePointer.data.title	 = scopePointer.data.fields.name;
				}
				else
					scopePointer.API.setError( data.ret.message, scopePointer );  		
                	},
                	
                	setAllStarManagementChoice: function( location, id, choice ){
                		
                		//alert(" location: "+location+" id="+id+" choice "+choice);
                		var promise = AJAX.put('ALLSTAR_MANAGERS', {'where_id': id, 'location': location, 'choice': choice} ); 
				 
				scopePointer.API.setResting(true);
			 
				promise.success(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					if( data.status == 'SUCCESS' )
						scopePointer.API.setMessage(  data.ret.message, scopePointer );
					else
						scopePointer.API.setError( data.ret.message, scopePointer );	
				});  			
					
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );	
				});
                	},
                	
                	getTeamsFromKnockoutTable: function( data )
                	{
                		 
                		if(  type != 1 )
				{
					for( var numRunda in data.playoffs )
					{
						for( var gameNum in data.playoffs[numRunda] )
						{ 
							 
							var game = data.playoffs[numRunda][gameNum][0]; 
							if( typeof game.home_team != 'undefined' )
								teams[game.fields.home_team] = game.home_team;
										
							if( typeof game.away_team != 'undefined' )
								teams[game.fields.away_team] = game.away_team;
							
						} 
					}
				}	
                	},
                	
                	getKnockName: function( runda, matches )
                	{
                		if( runda == 8 )
                			return tr('Quarterfinals');
                		if( runda == 4 )
                			return tr('Semifinals');
                		if( runda == 2 && matches == 2)
                			return tr('Gold & Bronze');
                		
                		if( runda == 2 && matches == 1)
                			return tr('Gold');
                		var v = [];
                		v['runda'] = runda;
                		return tr('{runda} Table',v);
                		
                	},
                	
                	//update next_round or last_round from dropdown
                	updateGames: function( forWhom )
                	{
                		var getDay = scopePointer.selector.model[forWhom];
                		var day    = getDay.value;
                		
                		if( typeof scopePointer.data[forWhom] != 'undefined' )
                			if( typeof scopePointer.data[forWhom][0] != 'undefined' )
                				if( scopePointer.data[forWhom][0].fields != 'undefined' )
                					if( scopePointer.data[forWhom][0].fields.ziua != 'undefined' )
								if( day != scopePointer.data[forWhom][0].fields.ziua )
									return this.ajaxForGames( forWhom, day );
				this.ajaxForGames( forWhom,day );
                	},
                	
                	ajaxForGames: function( forWhom,day )
                	{
                		var getWhat = { 'get':'fields,sim','where_id':id, 'location':type, 'day': day, 'season': previousSeason };
				var promise = AJAX.get('GAMES', getWhat ); 
				scopePointer.loading[forWhom] = 1;		
				promise.success(function(data, status, headers, config) {
				
					scopePointer.loading[forWhom] = 0;
					if( data.status == 'SUCCESS' )  
						scopePointer.data[forWhom] = data.ret;	
				 
						
				});	
                	},
                	
                	createSelectOptions: function( forWhom,  result )
                	{ 
                		
                		var arrayIndex    = 0;   
                		var obj		  = {};
                		var currentSeason = me.get('season');
                		
                		if( typeof result.timestamp != 'undefined' )
                			currentSeason = result.timestamp.season; 
                		
                		if( forWhom == 'previousSeasons' )
                		{
                			var award	= {};
                			var added	= {};
                			var option 	= {};
                			option.value	= currentSeason;
                			option.name 	= tr('Current Season {value}',option);
                			scopePointer.selector.options.previousSeasons = [];
                			scopePointer.selector.options.previousSeasons.push( option );
                			arrayIndex++;
                			added[option.value] = 'yes';
                			if( previousSeason == option.value )
                				scopePointer.selector.model.previousSeasons = scopePointer.selector.options.previousSeasons[0];
                			 
                			for( var awIndex in result.previous_winners )
                			{
                				award = result.previous_winners[awIndex];
                				if( typeof added[award.season] == 'undefined' )
                				{
                					option		= {};
                					option.value 	= award.season;
                					
                					if( scopePointer.form.season == award.season )
                						option.name = tr('Browsing Season {season}', award );
                							else
                								option.name  	= tr('Browse Season {season}', award);
							  
							 
							scopePointer.selector.options.previousSeasons.push( option );
							 
							if( previousSeason == award.season )
								scopePointer.selector.model.previousSeasons = scopePointer.selector.options.previousSeasons[arrayIndex];
							
							arrayIndex++;
							added[award.season] = 'yes';
						}
                			}
                			
                		}
                		else
                		{
					for( var numIndex in result.schedule )
					{ 
						obj = result.schedule[numIndex];
						var option 	= {};
						option.name  	= this.getOptionString( obj );
						option.value 	= obj.day;
						scopePointer.selector.options[forWhom].push( option );
						delete option;
						if( typeof result[forWhom] != 'undefined' )
							if( typeof result[forWhom][0] != 'undefined' )
								if( typeof result[forWhom][0].fields != 'undefined' )
									if( result[forWhom][0].fields.ziua == obj.day )
										scopePointer.selector.model[forWhom] = scopePointer.selector.options[forWhom][arrayIndex];
						arrayIndex++;
					} 
				}
                	},
                	
                	getName: function( teamId, obj, flag )
                	{ 
                		
                		if( !isNaN(teamId) )
                		{
					if( typeof teams[teamId] != 'undefined' )
						if( typeof teams[ teamId ].fields != 'undefined' )
							return teams[ teamId ].fields.name;	
				} 
				else
				{
					
					if( typeof obj == 'undefined' )
						return tr('walkover');
					
					if( isNaN( teamId ) && isNaN( obj ) && typeof flag != 'undefined' )
					{
						if( 1 )
						{
							if( flag == 'home_team' )
								return tr('Wait for previous');
									else
										return tr('round to finish.'); 
						} 
					}
					 
					return tr('walkover');	
				}
						
                	},
                	
                	getFlag: function( teamId )
                	{
                 		if( typeof teams[teamId] != 'undefined' )
                			if( typeof teams[ teamId ].fields != 'undefined' )
                				return teams[ teamId ].fields.id_country;	               		
                	},
                	
                	getOptionString: function( day )
                	{  
                		var diff = parseInt(day.round) - parseInt(scopePointer.data.fields.playoff_runda);
                		if( diff == 0 )
                			return tr('Day {day}, Playoffs QF',day);
                			else if( diff == 1 )
                				return tr('Day {day}, Playoffs SF',day);
                					else if( diff == 2 )
                						return tr('Day {day}, Finals.',day);
                							else
                								return tr('Day {day}, Round {round}',day);
                		
                	},
                	
                	getWinner: function( season )
                	{
                		var award = {};
                		for( var i in scopePointer.data.previous_winners )
                			if( scopePointer.data.previous_winners[i].season == scopePointer.form.season )
                			{
                				obj = 	scopePointer.data.previous_winners[i];
                		 
                				award.id_item   = obj.id_item;
                				if( scopePointer.data.previous_winners[i].type != 'mvp' )
                				{ 
                					award.team 	= obj.name;
                					award.manager 	= obj.username;
                					award.id_club   = obj.id_item;
                				}
                				else
                				{ 
                					award.mvp 	= obj.name;
                					award.owner 	= obj.username;	
                					award.id_player = obj.id_item;
                				}
                			}
                			
                		return award;
                	},
                	
                	needsAjax: function( result )
                	{	
                		//checks whether the data has been updated today
                		//or if a game was scheduled to play today and it is likely to have simmed
                		//in which case its time to update
                		return 1;
                	},
                	
                	createSelectOption: function( careerId )
                	{ 
                		var careers = me.get( 'careers' );
                		var options = {};
                		var v	    = {};
                		scopePointer.form.options.careerList = [];
                		for( var i in careers )
                		{
                			if( parseInt( i ) <= me.get('season') )
                			{
						v.career       = careers[i];
						options 	= {};
						options.label 	= this.getPage()=='leagues'?tr('{career} Leagues',v):tr('{career} Tournaments',v);
						options.value 	= i;
						scopePointer.form.options.careerList.push( options ); 
					}
				}
                		
                		options = {};
                		if( this.getPage() == 'leagues' )
                			options.label 	= tr('Leagues I play in');
                				else
                					options.label 	= tr('Competitions I play in');
                		options.value 	= 'allmy';              		
                		scopePointer.form.options.careerList.push( options );
                		
                		if( typeof careerId == 'undefined' )
                		{
                			scopePointer.form.careerSelection = scopePointer.form.options.careerList[0];
                			return 1;
                		}
                		if( careerId == 1 )
                		{
                			scopePointer.form.careerSelection = scopePointer.form.options.careerList[0];
                			return 1;
                		}
                		
                		if( isNaN( careerId ) )
                		{ 
                			scopePointer.form.careerSelection = scopePointer.form.options.careerList[parseInt(scopePointer.form.options.careerList.length)-1];
                		}
                	},
                	
                	setScopePointer: function( to ){
                		scopePointer = to;	
                	},
                	
                	getCompetitionsSetup: function( day ){
                		
                		var promise = AJAX.get('NEW_COMPETITIONS', {day: day, id_account: me.get('id_account')},1 );  
				scopePointer.API.setResting(true);
			  
				promise.success(function(data, status, headers, config) { 
			
				if( data.status == 'SUCCESS' ){
					scopePointer.data = data.ret;
					scopePointer.API.setResting(false);
				}
				else
					scopePointer.API.setError( 'REST', scopePointer );	
				});
					
				if( promise.update )
					promise.update(function(data, status, headers, config) { 
						if( data.status == 'SUCCESS' ){
							scopePointer.data = data.ret;
							scopePointer.API.setResting(false);
						}
						else 
							scopePointer.API.setError( 'REST', scopePointer );
					}); 
					
				
				promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );	
				}); 
                	},
                	
                	getList: function( careerId, $scope )
                	{  
                		if( typeof $scope != 'undefined' )
                			scopePointer = $scope;	 
                		
                		if( this.getPage() == 'leagues' )
                			var getWhat = { 'get':'leagues=fields-simtime-momentum' };
                				else
                					var getWhat = { 'get':'leagues=fields-simtime-momentum,tournaments=fields-simtime-momentum' };
                		if( isNaN( careerId ) )
                		{ 
                			var getWhat = { 'get':'myCompetitions=fields-simtime-momentum' };
                				}
                				else
                				{
                					getWhat.careerId = careerId;
                					scopePointer.API.setForm('leagues',0);  	
                				}
                				
                		var obj = this;		
                		me.get('competitionList', careerId ).then(function( result ) { 
                			 
                			if( typeof result[0] != 'undefined' )
                			{
                				scopePointer.leagues		= result[0].leagues; 
                				scopePointer.tournaments 	= result[0].tournaments;
                				obj.updateHelp();
                			}
                			
                    	    	});
                		 
				var promise = AJAX.get('COMPETITION', getWhat,1 );  
				scopePointer.API.setResting(true);
			  
				promise.success(function(data, status, headers, config) { 
				 	obj.updateTournamentListView( data,careerId ); 
				});
				
				if( promise.update )
					promise.update(function(data, status, headers, config) {   
						obj.updateTournamentListView( data,careerId ); 
					}); 
				
				promise.error(function(data, status, headers, config) {
					$scope.API.setResting(false);
					scopePointer.API.setError( 'REST', scopePointer );	
				});  
                	},
                	
                	updateTournamentListView: function( data,careerId )
                	{  
                		var obj = this;
                		if( data.status == 'SUCCESS' )
				{
					scopePointer.cachedCopy = data.cache; 
					
					if( !data.cache   )
						scopePointer.API.setResting(false);
					 
					scopePointer.API.checkNotifications( data, scopePointer);
					//aici o sa fie mai multe synch-uri
					data.ret.fields = {'id': careerId };
					me.synch('competitionList', data.ret, scopePointer, data.timestamp );
					 
					scopePointer.leagues		= data.ret.leagues;
						 
					delete data.ret.leagues;
					scopePointer.tournaments 	= data.ret.tournaments;
					obj.updateHelp();
				}      
                	},
                	
                	getTeamList: function( leagueId, $scope )
                	{  
                		if( typeof $scope != 'undefined' )
                			scopePointer = $scope;	
                	 
                	    var getWhat = { 'get':'fields,place,count,league=fields-simtime','id_league':leagueId ,'orderBy':'place' };
                    	    var promise = AJAX.get('TEAMS', getWhat ); 
                    	    var obj	= this;
                    	    $scope.API.setResting(true);
                    	    promise.success(function(data, status, headers, config) {
                    	    		    
                    	        $scope.API.setResting(false);
                    	        scopePointer.API.checkNotifications( data, scopePointer);
                		//succesful get event. 
                		scopePointer.data.hidden = 0;
                		var humans = 0;
                		for( var i in data.ret )
                			if( typeof data.ret[i].fields != 'undefined' )
                			{
                				if( data.ret[i].fields.id_account > 0 )
                				{
                					scopePointer.data.hidden++;   
                					humans++;
                				}
                			}
                			
                			var teams = []; 
					for( var i in data.ret )
						if( typeof data.ret[i].fields != 'undefined' ) 
							teams.push(data.ret[i]); 
						
                		scopePointer.data.teams   	= teams; 
                		
                	 
                		scopePointer.data.league    		= data.ret[1].league; 
                		scopePointer.data.league.time		= me.getTime( me.getTimestamp( scopePointer.data.league.simtime.date ) ); 
                		scopePointer.data.league.human		= humans;
                		
                		scopePointer.restLoading 	= false;
			    });
			
			     promise.error(function(data, status, headers, config) {
			     	$scope.API.setResting(false); 
			     	scopePointer.API.setError( 'REST', scopePointer );
			     }); 
                	},
                	
                	updateHelp: function()
                	{
                		
                		dbHelp.items = {};
                		if( typeof scopePointer.leagues != 'undefined' )
                		{
					dbHelp.items.a1_leagues = {text: scopePointer.leagues.fields.description, title: scopePointer.leagues.fields.title};
					var tourney = {};
					for( var i in scopePointer.tournaments )
					{
						tourney = scopePointer.tournaments[i];
						dbHelp.items['tournament_'+tourney.fields.importance] = {text:tourney.fields.description, title:tourney.fields.title }
					}
                		}
                		scopePointer.form.help = dbHelp;
                	},
                	
                	getLink: function( location, compId )
                	{ 
                		if( this.getPage() == 'leagues' )
                			return '/choose_team_to_buy/'+compId;
                				
                		return '/competition/'+location+'/'+compId;
                	},
                	
                	browsingPreviousSeason: function()
                	{
                		return previousSeason;
                	},
                	
                	setPage: function( method )
                	{
                		page = method;	
                	},
                	
                	getPage: function()
                	{
                		return page;	
                	},
                	
                	getHelp: function( page, item )
                        {
                		var help = { items:{} };
                		var v	 = { 'top_mvp': 50, 'top_mvp_1':51, 'from_tns': 4, 'to_tns': 7,'games_per_career':30, 'season_days':61,'teams_per_league':16,'regular':30,'playoff':'3/3/3','playoff_teams':8,'playoff_start':53,'length': 12, '/a':'', pos:tr('C/PF/SF/SG/PG'),'cyberpoints_link':'','career_link':'', 'goals':3,'per_game':1, 'games':10,'sp_rewardable':30 };
                		 
                		v.season = previousSeason;
                		switch( page )
                		{
                			case "page":
                				
                				if( previousSeason != me.get('season') )
                				{
                				 	help.items.a0a_winner  	= {'text':tr('Team that won the competition.')+' '+tr('Tap the team to browse their lineup during that season, complete results etc.'), title:tr('Winner')};
                				 	help.items.a0b_manager 	= {'text':tr('User that was managing the winning team at the time.'), title:tr('Manager')};
                				 	help.items.a0c_mvp 	= {'text':tr('Most valuable player in that season.'), title:tr('MVP')};
                				 	help.items.a0d_owner	= {'text':tr('User who owned the most valuable player.'), title:tr('Owner')};
                				}
                				
                				if( location == 1 )
                				{
                					if( typeof scopePointer.data.fields != 'undefined' )
                					{
								help.items.a1_standings = {'text'	:tr('In each season (~{season_days} days) teams play {regular} regular season games, after which a {playoff} playoff system to decide the winner.',v)+' '+tr('Leagues have a single conference.'), 'title':tr('Standings')};
								help.items.a2_playoff	= {'text' 	:tr("Top {playoff_teams} teams qualify for the playoffs, scheduled to start on day {playoff_start}.",scopePointer.data.fields)+' '+tr('The playoff system will be {playoff_system}.',v), 'title':tr('Playoffs')};
							}
							
						}
                				else
                				{
                					help.items.a1_standings = {'text'	:tr('This competition has a set of pools. After all teams play each othe in each pool they will be seeded on a knockout table based on wins and point differential.'), 'title':tr('Standings')};
							help.items.a2_playoff	= {'text' 	:tr("Knockout table to decide the winner.")+' '+tr('Teams are seeded based on pool play.')+' '+tr('If competition has no pools then they are seeded by their league records.')+' '+tr('Custom seeding rules may exist.'), 'title':tr('Kockout table')};
                		
                				}
						help.items.a3_lastround = {'text'	:tr('Last games played in this competition.'), title:tr('Last round')};
                				help.items.a4_nextround = {'text'	:tr('Upcoming games.'), title:tr('Next round')};
                				help.items.a5_mvprace   = {'text'	:tr('Players who seem to have the best chance at winning the MVP.')+' '+tr('The coefficient is calculated based on how many appeareances each player has among the top {top_mvp} players in each stat category.',v)+' '+tr('Each position becomes a number of points. If he is not among the top {top_mvp} in one of the categories ( for example in "steals" ), he gets {top_mvp_1} points. All those points are then added, and the lowest becomes MVP.',v), title:tr('Next round')};
                				help.items.a7_stats 	= {'text'	:tr('Players who have recorded most such stats.',v)+' '+tr('The ranking is cummulative and not "per-game".'), 'title':tr('Leaders in each stat category')};
                				help.items.a8_previous_w= {'text'	:tr('Champions and distinguished player performances in previous seasons.')+' '+tr('Tap on each entry in order to browse that season.'), title: tr('Previous Winners')};
                				help.items.a9_previous_seasons= {'text'	:tr('Browse results from previous seasons (~{season_days} days / season).',v), title: tr('Previous Seasons')};
                			break;	
                			
                			case "list":
                				if( this.getPage() == 'leagues' )
                				{
                					help.title = tr('Choose a team based on their league.')+' '+tr('Games are live so it might be wise to choose a league that sims at a time that is good for you.')+' '+tr('The human owners number on the right helps you identify the most competitive leagues.');	
                				}
                				else
                					help.title = tr('On this view you can find the competitions you currently play in or all the team competitions in the game sorted by career stage.');
                			 
                				 
                				if( typeof dbHelp.items == 'undefined' )
                					return '';
                				
                				if( typeof dbHelp.items[item] == 'undefined' )
                					return '';
                				
                				if( typeof item != 'undefined' )
                					return dbHelp.items[item].text;
                			break;
                			
                			case "buy":
                				help.title = tr('Buying a team will allow you to choose its tactics, sign players, arena etc.')+' '+tr("Games are live.")+' '+tr("While the manager is not required to be present at gametime we recommend choosing a league who's simtime matches your schedule in order to be present for the important games.");
                			break;
                		}
                	
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		
                		return help; 
                    	},
                }

            }]);
}());
