(function () {
  
    var scopePointer; 
    var id; 
    var search = {};
    var votingStarts ='';
    var votingStartsDay = 25;
     	
    angular.module('myApp.country', ['myApp.AJAX','myApp.me' ])
        .service('country', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return { 
                	get: function( idCountry, $scope )
                	{ 
                		id = idCountry;
                		if( typeof $scope != 'undefined' )
                			scopePointer= $scope; 
                		 
				var promise = AJAX.get('COUNTRIES', {'id':id,'get':'topPlayers=username,wc,posts'}, 1 ); 
				var obj	    = this;
				scopePointer.API.setResting(true);
				promise.success(function(data, status, headers, config) {
					obj.updateView( data );
				});
				
				if( promise.update )
					promise.update(function(data, status, headers, config) {
					obj.updateView( data );
				});
				
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				});
                	},
                	
                	voteable: function()
                	{
                		//1. voting season
                		if( scopePointer.data.wc.schedule != null )
                		{
                			for( var i in scopePointer.data.wc.schedule )
                			{
                				var item = scopePointer.data.wc.schedule[i];
                				if( item.event == 'coach_election' )
                				{
                					votingStarts 	= me.dateFormat('F jS',me.getTimestamp(item.startTimestamp));
                					votingStartsDay = item.start_day;
                					if( me.getDay() >= item.start_day && me.getDay() <= item.end_day )
                						return 1;	
                							
                					if( me.getDay() < item.start_day )
                						return -2;
                					
                					if( me.getDay() > item.start_day )
                						return -3;
                				
                					break;
                				}
                				
                			}
                		}
                		
                		return 1; 
                	},
                	votingStarts: function()
                	{
                		return {date: votingStarts, day: votingStartsDay };
                	},
                	
                	getCountryId: function()
                	{
                		return id;	
                	},
                	
                	updateView: function( data )
                	{
                		var previousTitle 	= scopePointer.data.title;
                		scopePointer.cachedCopy = data.cache;
				if( !data.cache ){
					 scopePointer.API.setResting(false);
					 scopePointer.API.checkNotifications( data, scopePointer);
				} 
                		scopePointer.data 	= data.ret; 
                		scopePointer.data.title = previousTitle;
                		
                		scopePointer.sortOptions  = {};
                		scopePointer.sortByOption = {};
                		scopePointer.data.disableLoadMore = {};
                		for( var i in scopePointer.data.topPlayers )
                		{
                			scopePointer.data.disableLoadMore[career] = 0;
                			var career = scopePointer.data.topPlayers[i].career;
                			 
                			
                			scopePointer.sortOptions[career] = [
						{ value:'points',name:tr('Points')	},
						{ value:'assists',name:tr('Assists')    },
						{ value:'steals', name:tr('Steals')	},
						{ value:'blocks', name:tr('Blocks')     },
						{ value:'rebounds',  name:tr('Rebounds')} 
                			];
                			
                			scopePointer.sortByOption[career] = scopePointer.sortOptions[career][0];
                				
                			
                		}
                	},
                	
                	updateListing: function( career, i )
                	{
                		if( typeof i == 'undefined' )
                			i=1;
                		//alert(value);
                		//alert(JSON.stringify(scopePointer.sortByOption[career]) );
                		var stat = scopePointer.sortByOption[career].value;
                		var promise = AJAX.get('COUNTRIES', {'id':id,'get':'topPlayers=username','topPlayersCareer':career,'topPlayersOrderBy':stat, 'topPlayersFrom':i}, 1 ); 
				var obj	    = this;
				scopePointer.API.setResting(true);
				promise.success(function(data, status, headers, config) {
					obj.updatePlayerListingView( career, data, i );
				});
				
				if( promise.update )
					promise.update(function(data, status, headers, config) {
					obj.updatePlayerListingView( career, data, i );
				});
				
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
                	},
                	
                	getStat: function( career )
                	{
                		return tr(scopePointer.sortByOption[career].value);
                	},
                	
                	updatePlayerListingView: function( career, data, add )
                	{
                		scopePointer.API.checkNotifications( data, scopePointer);
                		scopePointer.API.setResting(false);
                		scopePointer.data.disableLoadMore[career] = 0;
                		
                		 
                		if( typeof add == 'undefined' || add == 0 || add == 1 )
                		{
					for( var i in scopePointer.data.topPlayers )
					{
						if( scopePointer.data.topPlayers[i]['career'] == career )
							scopePointer.data.topPlayers[i].players = []; 
					}
				}
                		
                		if( data.status == 'SUCCESS' )
                		{ 
                			if( typeof scopePointer.data.topPlayers == 'undefined' )
                			{
                				scopePointer.data.topPlayers 	     = [];
                				scopePointer.data.topPlayers.career  = career;
                				scopePointer.data.topPlayers.players = [];
                			}
                			
                			if( data.ret.topPlayers == null )
                				return scopePointer.API.setError( tr('Nothing to show'), scopePointer );
                			
                			var added = 0;
                			for( var j in scopePointer.data.topPlayers )
					{
						console.log( scopePointer.data.topPlayers[j]['career']+" == "+career);
						if( scopePointer.data.topPlayers[j]['career'] == career )
							for( var i in data.ret.topPlayers[j].players )
							{ 
								++added;
								console.log(">>>>add+>>>"+JSON.stringify( data.ret.topPlayers[j].players[i] )+"<<<<");
								scopePointer.data.topPlayers[j].players.push( data.ret.topPlayers[j].players[i] );
							}
					}
					
					if( added != 10 )
						scopePointer.data.disableLoadMore[career] = 1;
                		}
                	},
                	
                	loadMore: function( career )
                	{ 
                		var size = this.getRankingSize( career );
                		if( typeof size == 'undefined' )
                			size = 1;
                				else
                					++size;
                			
                		this.updateListing( career, size );
                	},
                	
                	getRankingSize: function( career )
                	{
                		for( var j in scopePointer.data.topPlayers )
				{
					if( scopePointer.data.topPlayers[j]['career'] == career )
					{
						if( scopePointer.data.topPlayers[j] == null )
							return 0;
								else
									return scopePointer.data.topPlayers[j].players.length;
					}
				}	 
                	},
                	
                	
                	getNationalTeam: function(  career )
                	{
                		if( scopePointer.data.wc.teams != null )
                		{ 
                			for( var i in scopePointer.data.wc.teams )
                			{ 
                				 if( typeof  scopePointer.data.wc.teams[i][0] != 'undefined' )
                				 {
                				 	var item = scopePointer.data.wc.teams[i][0];
                				        if( typeof item.team != 'undefined' )
								if( item.team != null )
									if( item.team.fields.career == career )
										return item.team ;
                						
                				}
                			}
                		}
                		
                		return null;
                	},
                	
                	
                	 
                	
                	getStat: function( career )
                	{
                		if( typeof search[career] == 'undefined' )
                			return 'points';
                		
                		return this.search[career];
                	},
                	
                	setStat: function( career, to )
                	{
                		this.search[career]=to;	
                	},
                	 
			
			getHelp: function( page, item )
                        {
                        	var help = { items:{} };
                		
                		
                		switch( page )
                		{
                			case "country":
                				help.items.a1_national_team	= {text:tr('National elections are held each season.')+' '+tr('To vote in a national election you need to have created a player from that country.')+' '+tr('You can coach any national team if you are voted.')+' '+tr('It is free to own a national team.'), title:tr('National teams')};
                				help.items.a2_career		= {text:tr('By stats accumulated in each career stage.'), title:tr('Top players')};
                				break;
                			 
                		}
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help; 
                       } 
                }

            }]);
}());
