'use strict';

(function () {
  
    var scopePointer;
    var fields	= { myPlayer: 'fields,skills,fixtures=2,results=3,salary,expiration,training,equipment,career,club' };
    var id      = 0;
    var cache;
    var data;
    var drafting = 0;
    
 
		
    angular.module('myApp.draft', ['myApp.AJAX','myApp.me' ])
        .service('draft', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                    	
                
                    init: function ( ) {
                    	
                    },
                   
                    //GET LEAGUES TO DRAFT IN
                    //THIS SHOULD BE DEPRECATED
                    getLeagues: function( career, $scope, pid  )
                    { 
                    	    this.setDrafting( 0 );
                    	    scopePointer = $scope;
                    	 
                    	    var getWhat = { 'get':'fields,draft','career':career,'id_player':pid,'orderBy':'sim_time' };
                    	    var promise = AJAX.get('LEAGUES', getWhat ); 
                    	    $scope.API.setResting(true);
                    	    var obj = this;
                    	    promise.success(function(data, status, headers, config) { 
                    	    	obj.parseLeagues( data.ret );
			    });
			
			    promise.error(function(data, status, headers, config) {
				$scope.API.setResting(false);
			    }); 
                    },
                    
                    setScopePointer: function( to ){
                    	scopePointer = to;    
                    },
                    
                    parseLeagues: function( data ){
                    	scopePointer.API.checkNotifications( data, scopePointer);
                    	
                	var leagues = []; 
                	for( var i in data )
                		if( typeof data[i].fields != 'undefined' ) 
                			leagues.push(data[i]); 
                		 
                	scopePointer.data.leagues   	= leagues; 
                		 
                	//window.SC().$apply(); 
                	// alert(JSON.stringify( scopePointer.data.leagues ) );
                	scopePointer.API.setResting(false);     
                    },
                    
                    //SEND RESTful DRAFT REQUEST
                    to: function( playerId, teamId )
                    {
                    	    var getWhat = { 'return':'fields,skills,fixtures=2,results=3,salary,expiration,training,equipment,career,club','id_team':teamId , 'id_player':playerId };
                    	    var promise = AJAX.put('DRAFT', getWhat ); 
                    	    this.setDrafting( 1 );
                    	    var obj = this;
                    	    scopePointer.API.setResting(true);
                    	    scopePointer.API.clearErrors();
                    	    
                    	    promise.success(function(data, status, headers, config) {
                    	    		    
                    	    	obj.setDrafting( 0 );	
                    	    	scopePointer.API.setResting(false);
                    	    	scopePointer.API.checkNotifications( data, scopePointer);
                    	    	
                    	    	if( data.status == 'SUCCESS' )
                    	    	{ 
                    	    		if( scopePointer.tutorial )
                    	    			scopePointer.tutorial.doneStep('draft');
                    	    		
					me.synch( 'player', data.ret, cache, data.timestamp ); 
					scopePointer.go('/myPlayer/'+data.ret.fields.id);
				}
				else
					scopePointer.API.setError( data.ret.message, scopePointer );
                    	    		    
                    	    });
                    	    
                    	     promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting( false );
					this.setDrafting( 0 ); 
					scopePointer.API.setError( 'REST', scopePointer );
					
			     }); 
                    },
                    
                    //Disables draft buttons during RESTful request
                    setDrafting: function( to )
                    {
                    	drafting = to;    
                    },
                    
                    getDrafting: function()
                    {
                    	return drafting;    
                    },
                    
                    //GET POSSIBILE TEAMS TO DRAFT IN
                    getTeams: function( leagueId, $scope )
                    {
                    	    this.setDrafting( 0 );
                    	    scopePointer = $scope;
                    	    
                    	    var getWhat = { 'get':'fields,draft,place,count','id_league':leagueId ,'orderBy':'place' };
                    	    var promise = AJAX.get('TEAMS', getWhat ); 
                    	    var obj = this;
                    	    $scope.API.setResting(true);
                    	    promise.success(function(data, status, headers, config) {
                    	    		    
                    	        $scope.API.setResting(false);
                    	        scopePointer.API.checkNotifications( data, scopePointer);
                		//succesful get event. 
                		 
                		scopePointer.data.hidden = 0;
                		for( var i in data.ret )
                			if( typeof data.ret[i].fields != 'undefined' )
                			{
                				if( data.ret[i].fields.id_account > 0 )
                					scopePointer.data.hidden++; 
                				else if( data.ret[i].draft[scopePointer.data.player.pos] == 0 )
                					scopePointer.data.hidden++; 
                				else;
                				
                				me.synch( 'teams', data.ret[i], cache, data.timestamp );
                			}
                		
                		scopePointer.loaded		= true; 
                		//maintain order sent from API
                		var teams = []; 
                		for( var i in data.ret )
                			if( typeof data.ret[i].fields != 'undefined' ) 
                				teams.push(data.ret[i]); 
                		 
                		scopePointer.data.teams   	= teams; 
                		var total = 0; 
                		scopePointer.restLoading 	= false;
                		for( var j in scopePointer.data.teams ){
                			total += obj.getAvailable(scopePointer.data.teams[j].draft, scopePointer.data.player.pos)
                			console.log(">>>>>>>>"+total+" <<< <BR>");
                		}
                		scopePointer.form.totalAvailableHere = total;
			    });
			
			     promise.error(function(data, status, headers, config) {
			     	$scope.API.setResting(false); 
			     	scopePointer.API.setError( 'REST', scopePointer );
			     }); 
                    	    
                    },
                     
                    getAvailable: function( list, pos )
                    {     
                    	  //console.log(">>>> "+pos+"<<< LIST "+JSON.stringify(list));
                    	  if( typeof list == 'undefined' )
                    	  	  return 0;
                    	    
                    	  if( typeof list[pos] == 'undefined' )
                    	  	  return 0;
                    	  
                    	  return list[pos];
                    },
                	
                    getHelp: function( page, item )
                    {
                		var help = { items:{} };
                		var v	 = { 'num': 8 };
                		switch( page )
                		{
                			case "leagues":
                				
                				 
                				help.title 			= tr('Choose a league for your player.');
                				help.items.a1_simtime 		= {'text' :tr("At which time each round is simmed LIVE, converted into your local timezone.")+' '+tr('Also, shown below the actual game time of the simulation. Announcements are usually made using that timezone.'), 'title':tr('Simtime')};
                				help.items.a2_simtime 		= {'text' :tr("Each COMPUTER managed team in this league may need a number of players. This is a cummulative for that."), 'title':tr('Spots available')};
                				   
                			break; 
                			
                			case "teams":
                				help.title 			= tr("Teams that need players at your position in this league.")+' '+tr('You can only draft into computer teams.');
                				help.items.a1_simtime 		= {'text' :tr("At which time each round is simmed LIVE, converted into your local timezone."), 'title':tr('Simtime')};
                				
                				help.items.a1_human_owners 	= {'text' 	:tr("Users who bought a team in this league and are managing a team filled with their players or other people's players."), 'title':tr('Human team owners')};
                				help.items.a2_human_players 	= {'text' 	:tr("Number of human controlled players in each team. A team may have NPC ( computer controlled ) players in their lineup. As more human-controlled players join, those are removed. They usually have the 'NPC' shorthand in their name. "), 'title':tr('Human players')};
                				help.items.a3_league_position	= {'text' 	:tr("Current standings position in the regular season. During the regular season, teams are ranked by victories vs losses and in case of a tie: points scored vs points received. Top {num} usually make it to the playoffs, all though this number may change season by season.",v), 'title':tr('League Position')};
                				//help.items.a3_league_position	= {'text' 	:tr(""), 'title':tr('')};
                			
                			break;
                		}
                		
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help;
                	}
                }

            }]);
}());
