(function () {
  
    var scopePointer;  
    var needsRest 			= 1;
    var id;
    var quarters;
    var playerData			= {};
    var starters;
    var playing;
    var pbp;
    var liveConnectionEstablished 	= 0;
    var liveQuarter			= 1; 
    var selectedDay			= 0;
    var showDays			= [];
    var location;
    var undraftedPlayerId;
    var vars				= {};
		
    angular.module('myApp.games', ['myApp.AJAX','myApp.me','myApp.gameLog' ])
        .service('games', [ 'AJAX','me' , 'gameLog' ,
            function ( AJAX,me, gameLog ) { 
                return {
                	
                	pbp: gameLog, 
                	setupData: function( gameId, data, timestamp )
                	{
                		var obj = this;
                		scopePointer.data.fields 	= data.fields;  
                		scopePointer.data.attendance 	= data.attendance;
				scopePointer.data.home_team 	= data.home_team; 
				scopePointer.data.away_team 	= data.away_team;   
				scopePointer.data.sim 		= data.sim;
				scopePointer.data.mom 		= data.mom;
				 
				scopePointer.data.mySkillpoints = data.mySkillpoints;
				scopePointer.data.competition 	= data.competition;
				starters			= data.starters;
						
				obj.setUpPlayerData( data.players );
						 
				if( data.fields.stat <= 2 )
				{  
					scopePointer.connecting 	= 0;
					scopePointer.liveGame    	= 0;
							
					scopePointer.data.stats 	= data.stats; 
				 
					obj.createQuarterDropDowns();
					scopePointer.data.quarterScores = data.quarterScores; 
							 
					obj.addBulkPbp( data );
							
					if( typeof timestamp != 'undefined' )
						me.synch('games',data.ret,scopePointer.data,timestamp);
							
				}
				else
					obj.connectLiveGame( gameId, scopePointer );	
                	},
                	
                	//game view
                	getGame: function( gameId, $scope )
                	{
                		var obj = this;
                		liveConnectionEstablished = 0;
                		this.pbp.setScope( $scope );
                		scopePointer = $scope;
                		
                		if( !scopePointer.liveGame )
                		{
                			me.get('games', gameId ).then(function( result ) { 
                				 
						if( typeof result[0] != 'undefined' )
						{
							obj.setupData( gameId, result[0] ); 
						}
						else
							obj.ajaxForIt( gameId ); 
                			});	
                			
                		}
                		
                		id 	     = gameId;
                		var obj      = this;
                		
                	},
                	
                	ajaxForIt: function( gameId)
                	{ 
                		var obj     = this;
                		var getWhat = {'get':'fields,competition=fields,starters,attendance,home_team=fields-manager,away_team=fields-manager,sim,mom,stats,quarterScores,players,mySkillpoints,play_by_play', id_game:  gameId };            	 	 
                	 	var promise = AJAX.get( 'GAMES', getWhat, 1 );
                	 	scopePointer.API.setResting(true);
                		promise.success(function(data, status, headers, config) { 
				 	obj.updateGameView( data, gameId );
				});
				
				if( promise.update )
					promise.update(function(data, status, headers, config) { 
						obj.updateGameView( data, gameId );
					});
				
				 promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
		
					scopePointer.API.setError( data.ret.message, scopePointer );
				 }); 	
                	},
                	
                	updateGameView: function( data, gameId )
                	{
                		var obj = this;
                		scopePointer.cachedCopy = data.cache;
                		if( !data.cache ){
                			scopePointer.API.setResting(false);
                			scopePointer.API.checkNotifications( data, scopePointer);
                		}
				 	 
				if( data.status == 'SUCCESS' )
				{ 
					obj.setupData( gameId, data.ret, data.timestamp ); 
					obj.updateTitle( tr('Match Summary') );  
				}
				else
					scopePointer.API.setError( data.ret.message, scopePointer );
                	},
                	 
                	connectLiveGame: function( gameId, $scope )
                	{ 
                		id = gameId;
                		if( scopePointer.liveListen != 'undefined' )
                		{
                			if( liveConnectionEstablished != 1 )
                			{
						scopePointer.liveListen.getStream( gameId, $scope );
						scopePointer.liveGame = 1;
						liveConnectionEstablished = 1;
					}
                		} 		
                	},
                	
                	isOnCourt: function( idPlayer )
                	{
                	 
                		if( scopePointer.liveGame )
                		{ 
					var id_club = this.getIdClub( idPlayer ); 
					if( typeof id_club!='undefined' )
						for( var pos in playing[ id_club ] )
						{ 
							if( idPlayer ==  playing[ id_club ][pos] )
								return 1;
						}
					 
					return 0;
				}
				else
					return 1;
                	},
                	
                	getPlaying: function()
                	{
                		return playing;	
                	},
                	
                	updateScore: function( data )
                	{
                			
                	},
                	
                	loadStarters: function( starters )
                	{
                		playing = starters;
                	},
                	
                	loadLiveData: function( data )
                	{
                		this.pbp.clear();
                		scopePointer.data.fields 	= data.calendar;
                		scopePointer.data.starters 	= data.starters;
                		this.loadStarters( data.starters[1]);
                		 
                		for( var i in data.players )
                		{
                			playerData[ i ] = {};
                			playerData[ i ].fields = data.players[i];
                		}
                		
                	 
                		scopePointer.data.stats		= {};
                		scopePointer.data.stats[data.calendar.home_team] = [];
                		scopePointer.data.stats[data.calendar.away_team] = [];
                		scopePointer.data.stats[data.calendar.home_team][0] = {};
                		scopePointer.data.stats[data.calendar.away_team][0] = {};
                		this.updateStats(  data.stats );
                	},
                	
                	//update stats when live gaming
                	updateStats: function( statsString )
                	{
                	
                		var stats = tryParseJSON( statsString );
                		for( var idPlayer in stats  )
                		{ 
                			var id_club = this.getIdClub( idPlayer ); 	  
                				 
                			//console.log( idPlayer+".id_club = "+id_club +" <<< ");
                			//console.log( JSON.stringify( this.getPlayerData() )+" <<< ");
                			statsItem = {};
                			statsItem = stats[idPlayer];
                			statsItem.id_player = idPlayer; 
                			
                			if( typeof scopePointer.data.stats == 'undefined' )
                				scopePointer.data.stats = {};
                			
                			if( typeof scopePointer.data.stats[id_club] == 'undefined' )
                				scopePointer.data.stats[id_club] = [];
                			
                			if( typeof scopePointer.data.stats[id_club][0] == 'undefined' )
                				scopePointer.data.stats[id_club][0] = {};
                			
                			scopePointer.data.stats[id_club][0][idPlayer] = statsItem; 
                		}
                	},
                	
                	//get stats, needed because to save bandwidth the JSON from the live game
                	//does not return 0, but a missing field
                	getStat: function( item, which )
                	{
                		if( which == 'minutes' )
                			if( typeof item[which] == 'undefined' )
                				return item.seconds;
                					else
                						return item.minutes;
                			
                		if( which == 'seconds' )
                			if( typeof item[which] == 'undefined' )
                				return item.minutes;
                					else
                						return item.seconds;
                					
                		if( typeof item[which] == 'undefined' )
                			return 0;
                		
                		return item[which];
                		
                	},
                	
                	//switch player currently online in a live game 
                	switchPlayer: function( switchThis, withThis )
                	{
                		if(scopePointer.liveGame )
                		{
					var id_club = this.getIdClub( switchThis );;
					//$("body").append( " switch player " + switchThis + " << " + withThis + " || id_club = "+id_club+" <BR><BR>" );
					pozitii 	 = me.getPositions();
					for( var pos in pozitii )
					{
						if( playing[id_club][pozitii[pos]] == switchThis )
						{
							playing[id_club][pozitii[pos]] = withThis;
						}
						
					}	
				}
                	},
                	
                	showStatsPid: function( idPlayer )
                	{
                		if( scopePointer.liveGame )
                		{
                			if( this.isOnCourt( idPlayer ) )
                				return 1;
                					else
                					{
                						if( scopePointer.form.bench )
                							return 1;
                						
                						return 0;	
                					}
                		}
                		
                		return 1;
                	},
                	
                	//getCurrentQuarter when live game
                	getLiveQuarter: function()
                	{
                		return liveQuarter;
                	},
                	
                	//setCurrentQuarter when live game
                	setLiveQuarter: function( q )
                	{
                		liveQuarter = q;	
                	},
                	
                	//get browsing quarter of the stat drop down
                	//0 when live game
                	getStatsQuarter: function()
                	{	
                		 
                		if( scopePointer.liveGame )
                			return 0;
                		  
                		if( typeof scopePointer.form.selectedQ == 'undefined' )
                			return 0;
                		
                		if( typeof scopePointer.form.selectedQ.value == 'undefined' )
                			return 0;
                		
                		return scopePointer.form.selectedQ.value;
                		
                	},
                	
                	//listen for the stream from the live game
                	listen: function( story ){
                		
                		if( typeof story.starters != 'undefined' )
                			this.loadStarters( story.starters );
                		
                		if( typeof story.stats != 'undefined' ) 
                			this.updateStats( story.stats );
                			
                		if( typeof story.pbp != 'undefined' )
                		{
                			this.pbp.addUnparsed( story.pbp );
					this.pbp.parse();
				}
				
				//if( typeof story.viewers != 'undefined' )
				//
                	},
                	
                	//get PBP from restAPI
                	getPbp: function( q )
                	{
                		var obj	    = this;
                	  
                		var getWhat = {'get':'fields,play_by_play='+q, id_game:  id };            	 	 
                	 	var promise = AJAX.get( 'GAMES', getWhat );
                	 	scopePointer.API.setResting(true);
                		promise.success(function(data, status, headers, config) {
						  
				 	scopePointer.API.setResting(false);
				 	scopePointer.API.checkNotifications( data, scopePointer);
				 	
					if( data.status == 'SUCCESS' )
					{  
						obj.addBulkPbp( data.ret );  
					}
					else
						scopePointer.API.setError( data.ret.message, scopePointer );
                	 
				});
				
				 promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.setError( data.ret.message, scopePointer );
				 }); 
                	},
                	
                	//add bulk PBP, most certainly received from rest api
                	addBulkPbp: function( data )
                	{
                		this.pbp.clear();
                		scopePointer.stories = [];
                			
                		for( var i in data.play_by_play )
                		{
                		
                			story = data.play_by_play[i];
                			this.pbp.addUnparsed( story );
                		}
                		 
                		this.pbp.parse(); 
                				
                	},
                	
                	//swipe play-by-play to the right/left and change scroll view
                	pbpSwipeRight: function()
                	{
                	 
                	},
                	
                	pbpSwipeLeft: function()
                	{
                		
                	},
                	
                	//get starter position when normal game
                	//get current game position when live game
                	getStarterIcon: function(id_player, q)
                	{
                		if( q==0 )
                			q=1;
                		
                		var id_club = this.getIdClub( id_player );
                		if( scopePointer.liveGame )
                		{
                			
                			for( var pos in playing[ id_club ] )
					{ 
						if( id_player ==  playing[ id_club ][pos] )
							return pos;
					}
                		}
                		else
                		{
                		
					if( typeof starters[q] != 'undefined' )
					{
						if( starters[q] != null )
							if( starters[q][id_club] != 'undefined' )
								if( 1 )
								{
									
									for( var i in starters[q][id_club] )
									{ 
										if( starters[q][id_club][i] == id_player )
											return i; 
									}
								}
					}
				}
                		
                		return '';
                	},
                	
                	//angular has this ugly way of creating drop downs
                	//create drop downs for the normal game
                	createQuarterDropDowns: function()
                	{
                		if( scopePointer.data.fields.stat == 2 )
                		{
					scopePointer.statQuarters = [];
					scopePointer.pbpQuarters = [];
					scopePointer.statQuarters.push( {name: tr('All',v), value: 0 } );
					var v = {};
					  
					for( var i in scopePointer.data.stats[scopePointer.data.fields.home_team] )
					{
						if( parseInt( i ) >= 1 )
						{
							v = {};
							v['num'] = i;
							 
							scopePointer.statQuarters.push( {name: tr('Q{num}',v), value: v.num } );
							scopePointer.pbpQuarters.push( {name: tr('Q{num}',v), value: v.num } );
						}
				
					}
					
					
					scopePointer.form.selectedQ 	= scopePointer.statQuarters[0]; 
					scopePointer.selectedPBPQ 	= scopePointer.pbpQuarters[3]; 
					  
				} 
                	},
                	
                	//get player info
                	getPlayer: function( pid )
                	{ 
                		if( typeof playerData[ pid ] != 'undefined' )
                			return playerData[pid];	
                				else
                					return {fields:{}};
                	},
                	
                	//this was different than the above getPlayer because
                	//i was considered different methods to proveide the [ id_club ] field
                	//when we are dealing with WC, but ultimatley we return id_team from API
                	getIdClub: function( idPlayer )
                	{
                		 
                		if( typeof this.getPlayer(idPlayer).fields.id_team != 'undefined' )
                			return this.getPlayer(idPlayer).fields.id_team;
                				else
                					return this.getPlayer(idPlayer).fields.id_club;			
                		
                	},
                	
                	//save playerData from REST
                	setUpPlayerData: function( dataRetPlayers )
                	{
                		for( var i in dataRetPlayers )
                		{
                			var player = dataRetPlayers[i];
                			if( typeof player.fields != 'undefined' )
                			{
						if( typeof playerData[ player.fields.id ] == 'undefined' )    
							playerData[ player.fields.id ] = {}; 
						playerData[ player.fields.id ] = player;
						
					}
					else
					{
						if( typeof player.id != 'undefined' )
						{ 
							playerData[ player.id ] = player;
						}
					}
                		}
                	},
                	
                	 //gameList	
                	 getList: function( $scope )
                	 {  
                	 	scopePointer = $scope; 
                	 	this.updateTitle( tr('Results & Fixtures') );
                	 	this.getListFromDB();
                	 	if( needsRest )
                	 		this.getListFromRest(); 
                	 },
                	 
                	 //...
                	 getListFromDB: function()
                	 {
                	 	 me.get('gameList', me.get('id_account') ).then(function( result ) { 
								 
					//alert(JSON.stringify(result[0]));		
					if( typeof result[0] != 'undefined' )
						scopePointer.games = result[0].games;  
				
				});
                	 }, 
                	 
                	 getBrowsingInterval: function( pointer, before, after )
			 {
				if( pointer - before <= 0 )
					return this.getBrowsingInterval( pointer, --before,  after );
				
				var days = [];
				
				if( before >= 1 )
					for( day = pointer - before; day < pointer; day++ )
					{
						days.push( day );
						//console.log("NEWPUSH-IN-BEFORE @ "+day+" = "+JSON.stringify( days ));
					}
				//console.log("BEFORE"+JSON.stringify( days ));
				days.push(pointer);
					
				if( after >= 1 )
					for( day = pointer + 1; day <= pointer+after ; day++ )
					{
						//console.log("NEWPUSH-IN-AFTER @ "+day+" = "+JSON.stringify( days ));
						if( day <= me.get('days') )
							days.push( day );
					}
				//console.log("AFTER"+JSON.stringify( days ));		
				return days;
			 },
                	 
                	 // [outsideDay][outsideDay] {{TODAY}} [outsideDay][outsideDay]
                	 getOutsideDays: function()
                	 {
                	 	var width = me.getDisplayWidth();
                	 	//console.log("width= "+width);
                	 	var possible = width / 200;
                	 	
                	 	if( possible <= 3 )
                	 		return 1;
                	 	
                	 	if( possible > 3 && possible <= 5 )
                	 		return 2;
                	 	
                	 	return 3; 
                	 },
                	 
                	 redirectTo: function( day )
                	 {
                	 	//location.url('/games/'+day)
                	 	this.setSelectedDay( day );
                	 	this.getListFromRest( 1 );	 
                	 	 
                	 },
                	 
                	 noPlayers: function( )
                	 {
                	 	 var myPlayers = me.get('myPlayersArray');
                	 	
                	 	 if( myPlayers.length == 0 )
                	 	 	 return 1;
                	 	 
                	 	 if( myPlayers.length > 0 )
                	 	 	 return 0;
					 
				//this is BAD ! , not sure where / if this is used anywhere else like this otherwie i'd change it
                	 },
                	 
                	 noTeams: function( )
                	 {
                	 	 var myTeams = me.get('myClubs');
                	 	 if(   myTeams == false )
                	 	 	 return 1; 
                	 	 if( myTeams.length == 0 )
                	 	 	 return 1;
                	 	 
                	 	 if( myTeams.length > 0 )
                	 	 	 return 0;
					
                	 	//update: when adding noTeams. It's probably because it using a defferred object quazi-synchronously
				//this is BAD ! , not sure where / if this is used anywhere else like this otherwie i'd change it
                	 },
                	 
                	 confirmNoPlayers: function()
                	 {
                	 	if( typeof scopePointer.players == 'undefined' )
                	 		return 0;
                	 	
                	 	if( scopePointer.players.length == 0 )
                	 		return 1;
                	 	
                	 	return 0; 
                	 },
                	 
                	 undraftedPlayers: function()
                	 {
                	 	 var myPlayers = me.get('myPlayersArray');
                	 	 
                	 	 if( myPlayers.length > 0 ){
					 for( var pl in myPlayers )
						 if( myPlayers[pl].fields.id_club != 0 )
							return 0;
						else
							undraftedPlayerId = myPlayers[pl].fields.id;
                	 	 	
						return 1;
				}
				
				return 1; 
                	 },
                	 
                	 getUndraftedPlayerId: function()
                	 {
                	 	 console.log(">>> AICI ??? <<< ");
                	 	 console.log(" uPId = "+undraftedPlayerId+" <<< ");
                	 	return undraftedPlayerId;	 
                	 },
                	 
                	 confirmUndraftedPlayers: function()
                	 {
                	 	//console.log("scopePointer.players>>>"+(scopePointer.players)+"<<");
                	 	for( var pl in scopePointer.players )
                	 	{
                	 		//console.log(">>>"+(scopePointer.players[pl].fields)+"<<<");
                	 		if( typeof scopePointer.players[pl].fields != 'undefined' )
                	 		{
                	 			if( scopePointer.players[pl].fields.id_club != 0 )
                	 			{
                	 				return 0;
                	 			}
                	 			else
                	 				undraftedPlayerId = scopePointer.players[pl].fields.id;
                	 		}
                	 	}
                	 				
                	 	return 1;
 
                	 },
                	 
                	 getListFromRest: function( noSchedule )
                	 { 
                	 	 //1435030
                	 	 var getWhat = {'gamelist':'fields,home_team,away_team,sim,day,competition=fields-importance', 
                	 	 'season_schedule':'fields' };
                	 	 
                	 	 if( this.undraftedPlayers() || this.noPlayers() )
                	 	 	 getWhat.players = 'fields';
                	 	 
                	 	 if( typeof noSchedule != 'undefined' )
                	 	 	 delete getWhat.season_schedule;
                	 	 
                	 	 var promise = AJAX.get( 'MULTI', {get:getWhat,'day':this.getSelectedDay(), id_account:  me.get('id_account'), id:{ players:'id_account-'+me.get('id_account')}},1 );
                	 	 
                	 	 scopePointer.API.setResting(true);
				 var obj = this;
				 
				 if( promise.update )
				 	promise.update(function( data ) {
					//alert("in update");
					obj.updateGameListView( data, 0 );
				 });
				 
				 
				 promise.success(function(data, status, headers, config) { 
				 	//alert('in success');
				 	obj.updateGameListView( data, 1 );
				
				});
				
				 promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					scopePointer.API.setError( data.ret.message, scopePointer );	
				 }); 
                	 },
                	 
                	 getSelectedDay: function()
                	 {
                	 	return selectedDay;	 
                	 },
                	 
                	 setSelectedDay: function( to )
                	 {
                	 	//console.log('setSelectedDay = '+to);
                	 	selectedDay = to;
                	 	var before = this.getOutsideDays();
                	 	showDays = this.getBrowsingInterval( parseInt(to), parseInt(before), parseInt(before) );
                	 	//console.log(JSON.stringify(showDays) );
                	 },
                	 
                	 inInterval: function( day )
                	 { 
                	 	 for( var i in showDays )
                	 	 {
                	 	 	//console.log(  showDays[i] +" == "+ day);
                	 	 	if( showDays[i] == day )
                	 	 		return 1;
                	 	 }
                	 	 
                	 	 return 0;
                	 },
                	 
                	 updateGameListView: function( data, cache )
                	 {  
                	 	//alert("in updateView"+JSON.stringify(data))
                	 	scopePointer.cachedCopy = data.cache;
                	 	var obj = this;  
                	 	//alert( typeof data.cache );
                	 	if( !data.cache   ) 
                	 		scopePointer.API.setResting(false);
                	 	
				scopePointer.API.checkNotifications( data, scopePointer);
				 	
				if( data.status == 'SUCCESS' )
				{ 
					//console.log(">>>"+(parseInt(obj.getSelectedDay())-obj.getOutsideDays()-1.5) * 150);
					//scopePointer.games 	     = data.ret.gamelist; 
					obj.organizeJSON( data.ret.gamelist );
					if( typeof data.ret.season_schedule != 'undefined' )
						scopePointer.season_schedule = data.ret.season_schedule;
					
					if( typeof data.ret.players != 'undefined' )
						scopePointer.players = data.ret.players;
					
					obj.updateTitle( tr('Results & Fixtures') );
					var insert = {};
					insert.fields = {id_account: me.get('id_account'), id: me.get('id_account') };
					insert.games  = data.ret;
					me.synch('gameList', insert, scopePointer.games, data.timestamp );
				
					//console.log('aici ==>'+document.getElementById('daysWrapper').offsetWidth );
					//document.getElementById('daysWrapper').scrollLeft  = 0;
					var scrollLeft = ((obj.getSelectedDay()-obj.getOutsideDays()-1.5) * 150);
					document.getElementById('daysWrapper').scrollLeft  = scrollLeft;
					//console.log(">>>>>>>> [ SCROLL LEFT ] >>>>> "+ (document.getElementById('daysWrapper').scrollLeft)+" <<< outsideDays="+(obj.getOutsideDays())+" Minus = "+(obj.getOutsideDays()-1.5)+" --- "+(obj.getSelectedDay()-obj.getOutsideDays()-1.5)+" << selecteDay = "+obj.getSelectedDay()+" SUM="+ ((obj.getSelectedDay()-obj.getOutsideDays()-1.5) * 150)+"<< ");
					if( document.getElementById('daysWrapper').scrollLeft == 0 )
						setTimeout(function(){ document.getElementById('daysWrapper').scrollLeft = parseInt(scrollLeft); }, 1500);
						
					
				}
					else
					scopePointer.API.setError( data.ret.message, scopePointer );
                	
                	 	 
                	 },
                	 
                	organizeJSON: function( result )
			{
				scopePointer.byCompType = {};
				//for( var i = 1; i<=9; i++ )
				//	this.byComp[ i ] = {};
				scopePointer.gameCount = 0;
				var gameCount = 0;
				for( var i in result ) 
				{
					var game   	 = result[i];
					var importance   = game.competition.fields.importance;
					var compId 	 = game.fields.where_id; 
					if( typeof scopePointer.byCompType[ importance ] == 'undefined' )
						scopePointer.byCompType[ importance ] = { 'importance':game.competition.importance, 'fields': game.competition.fields, 'games': [] };
					
					gameCount++;
					scopePointer.byCompType[ importance ].games.push( result[ i ] );
				}
				
				if( gameCount >= 1 )
					scopePointer.gameCount = gameCount;
			 
			},
			
			getSkillpointsLink: function( )
			{
				if( scopePointer.data.mySkillpoints )
					if( scopePointer.data.mySkillpoints.players == 1 )
						return '/skillpoints/'+scopePointer.data.mySkillpoints.id_players[0];
					else
						return '/skillpointsReceived/'+scopePointer.data.fields.id+'/'+scopePointer.data.mySkillpoints.id_players.splice(",");
				else
					return 'missing';
			},
                	 
                	 updateTitle: function( to )
                	 {
                	 	scopePointer.data.title = to;	 
                	 },
                	 
                	 getPlayerData: function()
                	 {
                	 	return playerData; 
                	 },	
                	 
                	 setGameId: function( to )
                	 {
                	 	id = to;	 
                	 },
                	 
                	 getGameId: function(   )
                	 {
                	 	return id;	 
                	 },
                	 
                	 setLocation: function( $location )
                	 {
                	 	location = $location;	 
                	 },
                	 
                	 setVar: function( what, to )
                	 {
                	 	vars[what] = to;	 
                	 },
                	 
                	 getVar: function( what )
                	 {
                	 	return vars[what]; 
                	 },
                	 
                	 getHelp: function( page, item )
                         {
                		var help = { items:{} };
                		
                		
                		switch( page )
                		{
                			case "gameList":
                				help.items.what		= {text:tr('This is a list of the upcoming and latest games of the teams you are a part of: either as player, comanager or manager.')+' '+tr('Tap each for more details.'), title:tr('What is this')};
                			break;
                			
                			default:
                				help.items.a0_info 	= {text:tr('The team with the "@" in front of its name is the home team.'), title: tr('Home team')};
                				help.items.a1_info 	= {text:tr('Basic game information.'), title: tr('Info')};
                				help.items.a2_stats 	= {text:tr('Stats for players on this team.')+' '+tr("PTS")+': '+tr('Points scored')+' '+tr("AST")+": "+tr('Assists')+' '+tr("BLK")+": "+tr('Blocks')+' '+tr("STL")+": "+tr('Steals')+' '+tr("ORB")+": "+tr('Offensive Rebounds')+' '+tr("DRB")+": "+tr('Defensive Rebounds')+' '+tr("TO")+": "+tr('Turnovers')+' '+tr("REB")+": "+tr('Rebounds')+' '+tr("FLS")+": "+tr('Fouls')+' '+tr("MIN")+": "+tr('Minutes'), title: tr('Player Stats')};
                				help.items.a3_pbp 	= {text:tr('Game narration.')+' '+tr('Swipe right or left to change time period.'), title: tr('Play by play')};
                			break;
                		}
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help; 
                    	} 
                	
                	
                }

            }]);
}());


