'use strict';

(function () {
  
    var scopePointer;
    var idAccount   = 0;
    var currentHall = '';
    var hallType    = '';
    var rankeeType  = ''; 
    var rankType    = 'rank';
    var rankSubdivision = '';
		
    angular.module('myApp.halloffame', ['myApp.AJAX','myApp.me' ])
        .service('halloffame', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return { 
                    init: function ( ) {
                    	
                    },
                    
                    get: function( $scope ){
                    	   
                    	  scopePointer = $scope;
                    	  var getWhat = { get:'all',id_account:this.getIdAccount(),per:'game' };
                    	  var promise = AJAX.get('HALL_OF_FAME', getWhat, 1); 
			  var obj     = this;
                    	  promise.success(function(data, status, headers, config) {
				obj.updateView( data );	 
			  });
			  
			  if( promise.update )
			  promise.update(function(data, status, headers, config) {
				obj.updateView( data );	 
			  });	
			  
			  promise.error(function(data, status, headers, config) {
				scopePointer.API.setResting(false);
			  }); 
                    },
                    
                    updateView: function( data )
                    {  
                    	    scopePointer.cachedCopy = data.cache;
                	    if( !data.cache )
                		scopePointer.API.setResting(false);
                    	    if( data.status == 'SUCCESS' )
                    	    { 
				scopePointer.myRankings = data.ret.all;
			    }	
                    },
                    
                    getRankingName: function()
                    {  
                    	     
                    	    var items = {};
                    	    items = this.getDefault();
                    	    for( var i in items )
                    	    {
                    	    	//console.log("[i].name = "+(currentHall)+" >> [[["+(items[i].title)+"]]] "+JSON.stringify(items[i])+">>>"+items[i].item );
                    	    	if( items[i].item == currentHall )
                    	    		return tr(items[i].title,items[i].v);
                    	    }
                    	    return ' ';
                    },
                    
                    setLastRank: function( to )
                    {  
                    	    scopePointer.data.lastRank = to;
                    	    //console.log(">>>>>last rank ="+lastRank+" to = "+to);
                    },
                     
                    
                    getType: function()
                    {
                    	return hallType;    
                    },
                     
                    setType: function( to )
                    {
                    	    hallType = to;
                    },
                    
                    getRankeeType: function()
                    {
                    	    return rankeeType;    
                    },
                    
                    setRankeeType: function( to )
                    {
                    	rankeeType = to;    
                    },
                    
                    setRankType: function( to )
                    {
                    	rankType = to;    
                    },
                    
                    getRankType: function()
                    {
                    	return rankType;    
                    },
                    
                    getRankSubdivision: function()
                    {
                    	return rankSubdivision;    
                    },
                    
                    setRankSubdivision: function( to )
                    {
                    	  rankSubdivision = to;    
                    },
                    
                    getExtraLinkItems: function()
                    {
                    	if( this.getRankType() != 'rank' ) 
                    		return '/'+this.getRankType()+'/'+this.getRankSubdivision();
                    	
                    	return '/'; 
                    },
                    
                    getTopPlayerOptions: function()
                    {
                    	var obj = [];
                    	//global
                    	obj.push( {name:tr('Global'), value: '/'  } );
                    	//careers/
                    	var careers = me.getCareers();
                    	for( var index in careers )
                    	{
                    		var cr = careers[index];
                    		obj.push( {name:cr.label, value: '/career/'+cr.value  } );
                    	}
                    	//countries
                    	var countries = me.get('countries');
                    	for( var cn in countries )
                    		obj.push( {name:countries[cn], value: '/country/'+cn  } );
                    	
                    	return obj;
                    },
                    
                    getTopPlayerSelectedOption: function()
                    {
                    	    for( var i in scopePointer.hallOptions )
                    	    {
                    	    	    if( scopePointer.hallOptions[i].value == this.getExtraLinkItems() )
                    	    	    	    scopePointer.selectOption = scopePointer.hallOptions[i];
                    	    	    
                    		}
                    },
                    
                    
                    getHall: function( ranking, place, $scope )
                    {  
                    	   currentHall  = ranking; 
                    	   scopePointer = $scope;
                    	   if( typeof place == 'undefined' )
                    	    	   var place = 1;
                    	    
                    	   if( place == 'undefined' || isNaN( place ) )
                    	    	   place = 1;
                    	   
                    	   //place = this.parsePlace( place );
                    	   if( ranking == 'top_players:minute' )
                    	   	   var perWhat = 'minute';
                    	   		else
                    	   			var perWhat = 'game';
                    	    
                    	   var obj     = this;
                    	   
                    	   var getWhat = { get:ranking,per:perWhat,rank: place };
                    	   if( this.getRankType() != 'rank' )
                    	   	   getWhat[ this.getRankType() ] = this.getRankSubdivision();
                    	   scopePointer.API.setResting(true);
                    	   var promise = AJAX.get('HALL_OF_FAME', getWhat ); 
                    	   var lastRank= 0;
                    	   var firstRank = -1;
                    	   promise.success(function(data, status, headers, config) {
						
                    	   		   scopePointer.API.setResting(false);
                    	        var rank = 0;
				if( data.status == 'SUCCESS' )
				{ 
					scopePointer.list	= data.ret[currentHall];
					obj.setType( data.ret[currentHall].typeOfValue );
					obj.setRankeeType( data.ret[currentHall].typeOfRankee );
					scopePointer.data.title = obj.getRankingName();
					for( var is in data.ret[currentHall].rankings )
					{ 
						//console.log("lastRank >>"+JSON.stringify(data.ret[currentHall].rankings[is]));
						lastRank = data.ret[currentHall].rankings[is].rank;	
						if(firstRank==-1)
							firstRank = lastRank;
					}
					scopePointer.data.lastRank  = parseInt(lastRank);
					scopePointer.data.firstRank = parseInt(firstRank)-50;
				}	
			  });
				
			  promise.error(function(data, status, headers, config) {
				scopePointer.API.setResting(false);
			  }); 
                    }, 
                    
                    getValue: function( placing )
                    { 
                    	if( typeof placing.coefficient != 'undefined' )
                    		return placing.coefficient;
                    	
                    	return placing.value;
                    },
                    
                    parsePlace: function( place )
                    {
                    	var real = parseInt(place / 10);    
                    	return real*10;
                    },
                    
                    getMyRanking: function( which )
                    {
                    	    if( which == 'top_players:game' || which == 'top_players:minute' )
                    	    	    return ' ';
                    	    if( typeof scopePointer.myRankings[ which ] != 'undefined' )
                    	    {
                    	    	    var op = scopePointer.myRankings[ which ];
                    	    	    // console.log(JSON.stringify(op.rankings[ 0 ])+" >>> ["+which+"]<<<<<<<<");
                    	   
                    	    	    if( typeof op.rankings != 'undefined' )
                    	    	    {	if( typeof op.rankings[ 0 ]!= 'undefined' )
                    	    	    		if( typeof op.rankings[ 0 ].rank != 'undefined' )
                    	    	    			return op.rankings[ 0 ].rank
                    	    	    		
                    	    	    	if( typeof scopePointer.myRankings[ which ].rankings.rank != 'undefined' ) 
                    	    	    			return scopePointer.myRankings[ which ].rankings.rank;
                    	    	    }
                    	    }
                    	    
                    	    return '-';  	    
                    },
                    
                    changePlayerRanking: function(   )
                    {
                    	  //console.log(">>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> aici???");
                    	  var to = document.getElementById("player_ranking").value;
                    	   
                    	  scopePointer.data.selection = to;
                    	  var getWhat = { get:'myTopPlayers',id_account:this.getIdAccount(),per:'game' };
                    	  if( to =='game' )
                    	  {
                    	  	  getWhat.get ='myTopPlayers';
                    	  	  getWhat.per = 'game';
                    	  }
                    	  else if( to == 'minute' )
                    	  {
                     	  	  getWhat.get ='myTopPlayers';
                    	  	  getWhat.per = 'minute';        
                    	  }
                    	  else
                    	  {
                    	  	  getWhat.get = 'player_awards'; 
                    	  }
                    	  
                    	
                    	  var promise = AJAX.get('HALL_OF_FAME', getWhat ); 
			
                    	  promise.success(function(data, status, headers, config) {
						   
				if( data.status == 'SUCCESS' )
				{ 
					if( to == 'awards' )
						scopePointer.myRankings.top_players = data.ret.player_awards;
							else
								scopePointer.myRankings.top_players = data.ret.myTopPlayers;
				}
					
			 });
				
			 promise.error(function(data, status, headers, config) {
				scopePointer.API.setResting(false);
			 }); 
                    },
                   
		    getDefault: function( ){
			    var obj = [
			    {item: 'active_managers', 		title: tr('Top Active Managers'), 			rank: -1, v:{}},
			    {item: 'top_players:game', 		title: tr('Top Players')+' / '+tr('Game'), 		rank: -1, v:{}},
			    {item: 'top_players:minute', 	title: tr('Top Players')+' / '+tr('Minute'), 		rank: -1, v:{}},
			    {item: 'account_awards',		title: tr('Total Awards per Account'),			rank: -1, v:{}},
			    {item: 'last:3',			title: 'Users joined in the last {num} days',		rank: -1, v:{num:3}},
			    {item: 'last:7',			title: 'Users joined in the last {num} days',		rank: -1, v:{num:7}},
			    {item: 'last:14',			title: 'Users joined in the last {num} days',		rank: -1, v:{num:14}},
			    {item: 'last:31',			title: 'Users joined in the last {num} days',		rank: -1, v:{num:31}},
			    {item: 'last:60',			title: 'Users joined in the last {num} days',		rank: -1, v:{num:60}},
			    {item: 'last:90',			title: 'Users joined in the last {num} days',		rank: -1, v:{num:90}},
			    {item: 'last:180',			title: 'Users joined in the last {num} days',		rank: -1, v:{num:180}},
			    {item: 'last:365',			title: 'Users joined in the last {num} days',		rank: -1, v:{num:365}},
			    {item: 'club_awards',		title: tr('Total Awards per Club'),			rank: -1, v:{}},
			    {item: 'player_senior_awards',	title: tr('Total Awards per Player'),			rank: -1, v:{}},
			    {item: 'account_player_awards',	title: tr('Player Awards per Account'),			rank: -1, v:{}},
			    {item: 'account_team_awards',	title: tr('MVP Awards per Account'),			rank: -1, v:{}},
			    {item: 'account_team_awards',	title: tr('Manager Awards per Account'),		rank: -1, v:{}},
			    {item: 'account_stat_races_awards',	title: tr('Stat Race Medals per Account'),		rank: -1, v:{}},
			    {item: 'player_senior_stat_races_top3',	title: tr('Stat Race Medals per Player '),	rank: -1, v:{}},
			   
			    ];
			    
			    return obj;
		    },
		    
		    getIdAccount: function()
		    {
		    	  
		    	return idAccount;    
		    },
		    
		    setIdAccount: function( to )
		    { 
		    	idAccount = to;    
		    },
                	
                    getHelp: function( page, item )
                    {
                		var help = { items:{} };
                		var v	 = { 'num': 8 };
                		switch( page )
                		{
                			case "leagues":
                				
                				 
                				help.title 			= tr('Choose a league for your player.');
                				help.items.a1_simtime 		= {'text' :tr("At which time each round is simmed LIVE, converted into your local timezone.")+' '+tr('Also, shown below the actual game time of the simulation. Announcements are usually made using that timezone.'), 'title':tr('Simtime')};
                				help.items.a2_simtime 		= {'text' :tr("Each COMPUTER managed team in this league may need a number of players. This is a cummulative for that."), 'title':tr('Spots available')};
                				   
                			break; 
                			
                			case "teams":
                				help.title 			= tr("Teams that need players at your position in this league.")+' '+tr('You can only draft into computer teams.');
                				help.items.a1_simtime 		= {'text' :tr("At which time each round is simmed LIVE, converted into your local timezone."), 'title':tr('Simtime')};
                				
                				help.items.a1_human_owners 	= {'text' 	:tr("Users who bought a team in this league and are managing a team filled with their players or other people's players."), 'title':tr('Human team owners')};
                				help.items.a2_human_players 	= {'text' 	:tr("Number of human controlled players in each team. A team may have NPC ( computer controlled ) players in their lineup. As more human-controlled players join, those are removed. They usually have the 'NPC' shorthand in their name. "), 'title':tr('Human players')};
                				help.items.a3_league_position	= {'text' 	:tr("Current standings position in the regular season. During the regular season, teams are ranked by victories vs losses and in case of a tie: points scored vs points received. Top {num} usually make it to the playoffs, all though this number may change season by season.",v), 'title':tr('League Position')};
                				//help.items.a3_league_position	= {'text' 	:tr(""), 'title':tr('')};
                			
                			break;
                		}
                		
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help;
                	}
                }

            }]);
}());
