 app.factory('liveGamesListener', ['$http','$timeout' ,'me', function($http, $timeout,me) {
  var data 		= { games: {}, count: 0, refresh:0 }; 
  var liveGamesArray 	= {};
  var scopePointer	= null;
  var lastConnection;
   
    
  var connect = function( id_game, updateScopePointer ) { 
			//console.log("connect");
			if( typeof updateScopePointer != 'undefined' )
				scopePointer = updateScopePointer;
					else
						scopePointer = null;
			obj 		= this;
			var sockjs_url 	= 'https://cyberdunk2.com:11799';
		 
			var sockjs 	= new SockJS(sockjs_url);
			
			var login = {
					type	  : 'auth',
					id_account: me.get('id_account'),
					username:   me.get('username'),
					token:	    me.get('token'),
					view:       {'mygames':1 }
			};
			
			if( typeof id_game != 'undefined' )
			{
				login.view.game = id_game;
				printMessage(tr('Connecting'));
				if( scopePointer != null )
					scopePointer.connecting = 1;
				lastConnection  = id_game;
			}		
			else
				lastConnection = 0;
			//auth.login
			sockjs.onopen    = function()  {  
				sockjs.send( JSON.stringify(login) );  
				//console.log("onOpen"); 	
				liveGameCount  = 0;
				liveGamesArray = {}; 
				updateLiveGames();
				
			};
			
			sockjs.onclose   = function(e)  { 
				//console.log("closed "); 
				if( typeof e != 'undefined' )
				{
					//console.log(" e != 'undefined' ");
					//console.log( JSON.stringify( e ) );
				}
				if( typeof id_game != 'undefined' )
					connect( id_game );
						else
							connect();
			};
			
			sockjs.onmessage = function(e) { 
				// console.log("onMessage"+JSON.stringify(data));
				
				if( typeof e.data != 'undefined' )
				{
					var o = tryParseJSON( e.data );
					console.log(">>>"+o.type+"<<<");
					if( o !== false )
						if( typeof o.type != 'undefined' )
							switch( o.type )
							{
								case "score":   
									updateLiveGames( o.result ); 
								break;
								
								case "greeting":
									if( scopePointer != null )
										scopePointer.connecting = 1;
									printMessage(tr('Waiting for game stream'));
								break;
								
								case "pbp": 
									//console.log("pbp");
									//console.log(JSON.stringify(o.result.pbp));
									if( o.result.pbp.id_game == scopePointer.game.getGameId() )
										scopePointer.game.listen( o.result );
								break;
								
								case "close":
									stopLiveGame( o.result );
								break;
								
								case "gameData":
									if(  scopePointer != null  )
									{ 
										//for( var i in o.result )
										//	console.log("["+i+"] >> ");
										//console.log("gameData");
										//console.log(JSON.stringify(o.result));
										if( o.result.calendar.id == scopePointer.game.getGameId() )
										{
											scopePointer.connecting = 0;
											scopePointer.game.loadLiveData( o.result );
										}
										 
									}
								break;
							}		 
				}
			}  
  };
  
  var printMessage = function( message )
  {
  	if( scopePointer != null )
  	{
  		scopePointer.connectingMessage = message;
  	} 
  };
  
  var stopLiveGame = function( result ) 
  {
  	  if( typeof liveGamesArray[result.id_game]  != 'undefined' )
  	  	  delete liveGamesArray[result.id_game];
  	  console.log("close >> "+JSON.stringify( result.id_game )+" <<< ");
  	  updateLiveGames();
  };
  
  
  		
  var updateLiveGames = function( result ){
  	  		
  	 	 	if( typeof result != 'undefined' )
  	 	 	 	if( typeof result.id_game != 'undefined' )
  	  				liveGamesArray[result.id_game] = result;
                		
                		
                	var liveGameCount = 0;
                	
                	for( var i in liveGamesArray )
                	{
                		var game = liveGamesArray[i];
                		if( game.quarter <= 3 || ( game.quarter==4 && game.time >= 10 ) )
                			liveGameCount++;
                				else
                					liveGameCount--;
                			
                	} 
                	var vary = {};
                	vary.games   = liveGamesArray; 
                	vary.count   = liveGameCount;  
                	data = vary;
                	//3 HOURS OF BEING UNABLE TO ACCESS THE SCOPE VIA THE OTHER METHODS USED THROUGHOUT THE APP
                	//THIS FINALLY WORKED.
                	var myDomElement  = document.getElementById('body');
                	if( typeof angular.element( myDomElement ).scope().live == 'undefined' )
                		angular.element( myDomElement ).scope().live = {};
                	
                	angular.element( myDomElement ).scope().live = data;
                	angular.element( myDomElement ).scope().$apply();
                	
                		
  };
  	
  	
  	
  connect();
  
  return {
    data: data,
    setScope: function( $scope )
    {
    	scopePointer = $scope;	    
    },
    
    getStream: function( id_game, scope )
    {
    	connect( id_game, scope );	    
    }
  };
}]);


