(function() {

    var scopePointer;
    var id = 0;
    var season = 0;
    var player = {};
    var cacheSearch = {};
    var vars = {};

    angular.module('myApp.manageTeam', ['myApp.AJAX', 'myApp.me'])
        .service('manageTeam', ['AJAX', 'me',
            function(AJAX, me) {
                return {

                    get: function(teamId, $scope, setSeason) {
                        season = 0;
                        scopePointer = $scope;
                        id = teamId;

                        var fields = {};
                        if (typeof setSeason != 'undefined' && setSeason != me.get('season')) {
                            table = 'teamHistory';
                            season = setSeason;
                            fields.season = season;
                            getId = teamId + "-" + setSeason;
                        } else {
                            getId = teamId;
                            table = 'teams';
                        }

                        //sql for team data
                        var obj = this;

                        me.get('myTeams', me.get('id_account')).then(function(result) {

                            scopePointer.teams = result;

                            if (typeof teamId == 'undefined')
                                teamId = result[0];

                            obj.loadTeam('team');
                            for (var i in result) {
                                if (result[i].fields.id == teamId) {
                                    scopePointer.data = scopePointer.team;

                                    //if( me.needsAjax( result[0] ) )
                                    //	obj.ajaxForIt();
                                }
                            }
                        });


                        if (typeof setSeason == 'undefined' || setSeason == me.get('season')) {

                            //CURRENT SEASON ONLY
                            me.get('players', teamId, 'id_club').then(function(result) {
                                if (typeof result != 'undefined') {
                                    scopePointer.data.players = [];

                                    for (var i in result) {
                                        scopePointer.data.players.push(result[i]);
                                    }
                                }
                            });
                        }

                        var getId = teamId + '-25';

                        me.get('wall', getId).then(function(result) {

                            if (typeof result[0] != 'undefined')
                                scopePointer.data.posts = result[0].posts;

                        });

                        this.ajaxForIt();
                    },
                    
                    openChat: function( data ){
                		 
                		var id_chat = 'c-'+data.fields.id;
                	
                		var icon = data.fields.logo;
                		var text = data.fields.name;
                		
                		if( icon == '' )
                			icon = 'images/noteamlogo.png';
                		else
                			icon = 'images/teams/'+icon;
                		 
                		scopePointer.chat.openChat( {'id':id_chat ,'text': text, 'icon': icon   } );
                	},

                    openContract: function(id_player, id_contract) {

                    },

                    release: function(id_player) {
                        var getWhat = {
                            'release': id_player,
                            id_club: id
                        };
                        if (season != 0)
                            getWhat.season = season;
                        var obj = this;
                        var promise = AJAX.patch('CONTRACT', getWhat);
                        promise.success(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            if (data.status == 'SUCCESS') {
                                scopePointer.API.setMessage(data.ret.message);
                                obj.removePlayer(id_player);
                            }

                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },

                    removeNationalPlayer: function(id_player) {
                        var getWhat = {
                            'uncall': id_player,
                            id_club: id
                        };

                        var obj = this;
                        var promise = AJAX.patch('CONTRACT', getWhat);
                        promise.success(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            if (data.status == 'SUCCESS') {
                                scopePointer.API.setMessage(data.ret.message);
                                obj.removePlayer(id_player);
                            }

                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });

                    },

                    removePlayer: function(id_player) {
                        var player = {};
                        var obj = this;
                        for (var i in scopePointer.data.players) {
                            player = scopePointer.data.players[i];
                            if (id_player == -1) {
                                if (player.fields.id_account == 0) {
                                    scopePointer.data.players[i].fields.id_club = 0;
                                    me.synch('player', scopePointer.data.players[i]);

                                    scopePointer.data.players.splice(i, 1);
                                }
                            } else {
                                if (player.fields.id == id_player) {
                                    scopePointer.data.players[i].fields.id_club = 0;
                                    me.synch('player', scopePointer.data.players[i]);
                                    scopePointer.data.players.splice(i, 1);
                                }
                            }
                        }
                    },

                    allStarDraft: function() {
                    	
                        if (typeof scopePointer.data != 'undefined')
                            if (typeof scopePointer.data.fields != 'undefined')
                            	if(   scopePointer.data.allstar != null )
                            	if( typeof scopePointer.data.allstar.fields != 'undefined' )
									if (scopePointer.data.fields.club_type == 10 || scopePointer.fields.club_type == 11) {
										if (scopePointer.data.allstar.fields.stat ==  1 ) {
											return 1;
										} else
											return 0;
                                } else
                                    return 0;
                               else
                               	   return 0;
                               else 
                               	   return 0;
                                    
                        return 0;
                    },

                    clubType: function(){
                    	
                    	if( scopePointer.data.fields.club_type==5 ) 
                    		return 'national';
                    	
                    	if( scopePointer.data.fields.club_type==0 || scopePointer.data.fields.club_type == 2  ) 
                    		return 'club';
                    	
                      	if( scopePointer.data.fields.club_type==10  ) 
                    		return 'allstar';
                    	
                    	//veteran ?
                      	if( scopePointer.data.fields.club_type==11  ) 
                    		return 'veteran';
                    	
                    },
                    

                    ajaxForIt: function() {
                        //performs ajax request for data 	

                        var getWhat = {
                            'get': 'fields,fixtures=3,results=3,standings,players=fields-contract-tactics-skills-last_login-profile,league,tactics,posts,allstar',
                            'id': id
                        };


                        var promise = AJAX.get('TEAM', getWhat, 1);
                        var myPos = 0;
                        scopePointer.API.setResting(true);
                        var obj = this;
                        promise.success(function(data, status, headers, config) {
                            obj.updateView(data);
                        });

                        if (promise.update)
                            promise.update(function(data, status, headers, config) {
                                obj.updateView(data);
                            });
                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },

                    updateView: function(data) {
                        var obj = this;
                        scopePointer.cachedCopy = data.cache;
                        if (!data.cache) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.checkNotifications(data, scopePointer);
                        }

                        scopePointer.API.setResting(false);
                        //aici o sa fie mai multe synch-uri

                        scopePointer.data = data.ret;
                        
                        if( this.allStarDraft() ) {
                        	//connect to node.js
                        	scopePointer.allstar.connect();
                        	scopePointer.allstar.parseAllStar(scopePointer.data.allstar);
                        } 
                        


                        scopePointer.data.npcs = 0;
                        for (var i in data.ret.players)
                            if (data.ret.players[i].fields.id_account == 0)
                                scopePointer.data.npcs++;


                        if (typeof data.ret.posts != 'undefined')
                            if (typeof data.ret.posts.error == 'undefined') {
                                var insertPosts = {
                                    fields: {}
                                };
                                insertPosts.posts = data.ret.posts;
                                insertPosts.fields.id = data.ret.fields.id + "-25";
                                insertPosts.fields.location = 25;
                                me.synch('wall', insertPosts, null, data.timestamp);
                            }

                        scopePointer.data.title = tr('Manage Team');

                        scopePointer.form.help = scopePointer.teamClass.getHelp('manageTeam');
                    },

                    updateTitle: function() {
                        scopePointer.data.title = tr('Manage Team');
                    },

                    createHistoryDropdown: function(data) {
                        var arrayIndex = 0;
                        scopePointer.form.modelHistory;
                        scopePointer.form.optionsHistory = [];
                        for (var i in data.history) {
                            var option = {};
                            option.value = data.history[i];

                            if (option.value == me.get('season')) {
                                option.name = tr('Current season {value}', option);
                            } else {
                                if (option.value == season)
                                    option.name = tr('Browsing season {value}', option);
                                else
                                    option.name = tr('Browse season {value}', option);
                            }

                            scopePointer.form.optionsHistory.push(option);
                            if (!season) {
                                if (option.value == me.get('season'))
                                    scopePointer.form.modelHistory = scopePointer.form.optionsHistory[arrayIndex];
                            } else
                            if (option.value == season)
                                scopePointer.form.modelHistory = scopePointer.form.optionsHistory[arrayIndex];

                            arrayIndex++;
                        }

                    },

                    makeOffer: function() {

                        var send = scopePointer.offer;
                        send.id_player = scopePointer.player.fields.id;
                        send.id_club = scopePointer.team.fields.id;


                        send['extra'] = '0&return[player]=fields,contract,club&return[team]=fields';

                        var promise = AJAX.put('CONTRACTS', send);

                        scopePointer.API.setResting(true);
                        var obj = this;
                        scopePointer.sendingOffer = 1;
                        promise.success(function(data, status, headers, config) {
                            scopePointer.sendingOffer = 0;
                            scopePointer.API.setResting(false);
                            if (data.status == 'SUCCESS') {
                                if (typeof data.ret['return'] != 'undefined') {
                                    me.synch('player', data.ret['return']['player'], scopePointer.data.player, data.timestamp);
                                    me.synch('team', data.ret['return']['team'], scopePointer.data.team, data.timestamp);
                                }
                                if (typeof data.ret.message != 'undefined')
                                    scopePointer.API.setMessage(data.ret.message, scopePointer);
                            } else
                                scopePointer.API.setError(data.ret.message, scopePointer);

                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });

                    },

                    saveCountry: function(id_country) {
                        for (var i in scopePointer.form.countryOptions)
                            if (scopePointer.form.countryOptions[i].value == id_country)
                                scopePointer.form.selectCountry = scopePointer.form.countryOptions[i];
                    },

                    loadTeam: function(type, dontForceSet) {
                        var team;
                        var set = 0;
                        var selectIndexToId = {};
                        var arrayIndex = 0;
                        var arrayTwoIndex = 0;
                        var selectOfferIndexToId    = {};
                        scopePointer.teamOptions    = [];
                        scopePointer.teamOptions2   = [];
                        scopePointer.contractOffer  = [];
                        scopePointer.selectTeam 	= {}; 
                        scopePointer.selectTeam2 	= {}; 
                        //console.log("aici?"+JSON.stringify(scopePointer.teams));
                        for (var i in scopePointer.teams) {
                        	team = scopePointer.teams[i];
                            //console.log(">>>i=["+i+"]......"+JSON.stringify(scopePointer.teams)+"<<< ");
                            scopePointer.teamOptions.push({
                                name: scopePointer.teams[i].fields.name,
                                value: scopePointer.teams[i].fields.id
                            });
                            scopePointer.teamOptions2.push({
                                name: scopePointer.teams[i].fields.name,
                                value: scopePointer.teams[i].fields.id
                            });
                            
          
                            if(  team.fields.club_type != 10 && team.fields.club_type != 11 ){
                            	
								scopePointer.contractOffer.push({
									name: scopePointer.teams[i].fields.name,
									value: scopePointer.teams[i].fields.id
								});
								 selectOfferIndexToId[team.fields.id] = arrayTwoIndex++;
                            }


                            
                           
                            selectIndexToId[team.fields.id] = arrayIndex;
                            console.log(team.fields.id + " == " + id);
                            if (team.fields.id == id) {
                                scopePointer.team = scopePointer.teams[i];
                                //console.log(">>>> "+JSON.stringify(scopePointer.team)+" <<<< ");
                                this.saveCountry(team.fields.id_country);

                                set = 1;
                                scopePointer.noTeam = 0;
                            }
                            arrayIndex++;
                           // alert(JSON.stringify( scopePointer.teamOptions[ arrayIndex-1 ] ) );
                             
                            //scopePointer.selectTeam =  scopePointer.teamOptions[ arrayIndex-1 ] ; 
                            //scopePointer.form.selectTeam =  scopePointer.teamOptions[ arrayIndex-1 ] ;
                             
                        }

                        //console.log(JSON.stringify( scopePointer.team ) );
                        if (typeof scopePointer.form != 'undefined')
                            if (typeof scopePointer.form.promotesTo != 'undefined')
                                scopePointer.form.promotesTo = scopePointer.team.fields.promotes_to;

                            /*
                            scopePointer.promotionOptions.push( {name: tr('Promotes to the next career stage'),  value: 0 } );
                            scopePointer.promotionOptions.push( {name: tr('Will play in the same career stage'), value: scopePointer.team.fields.id_career } );
                            	
                            if( scopePointer.team.fields.id_career == scopePointer.team.fields.promotes_to )
                            	scopePointer.selectPromotion = scopePointer.promotionOptions[1];
                            		else
                            			scopePointer.selectPromotion = scopePointer.promotionOptions[0];
                             */
                        if (!set) {
                        	
                            //alert( scopePointer.player + type );
                            for (var i in scopePointer.teams) {
                                team = scopePointer.teams[i];

                                //console.log( ">>>>>>>>>>>>>>>>>>>>>>"+team.fields.career+" == "+scopePointer.player.career.career + " == "+ id );
                                if (typeof scopePointer.player != 'undefined') {
                                    if (team.fields.career == scopePointer.player.career.career) {
                                        scopePointer.team = scopePointer.teams[i];
                                        set = 1;
                                        scopePointer.noTeam = 0;
                                        break;
                                    }
                                }
                            }
                        }

                        if (!set) {
                            //console.log("noTeam ??");
                            if (typeof dontForceSet == 'undefined') {

                                id = 0;
                                scopePointer.noTeam = 1;
                            }
                        } else {
                            id = scopePointer.team.fields.id;
                            scopePointer.playWith = scopePointer.teamOptions[selectIndexToId[id]];
          
                            scopePointer.selectTeam = scopePointer.contractOffer[selectOfferIndexToId[id]];
                            scopePointer.form.selectTeam = scopePointer.contractOffer[selectOfferIndexToId[id]];
                            
                            scopePointer.selectTeam2 = scopePointer.teamOptions[selectIndexToId[id]]; 
                        }
                        
                        for( var i in scopePointer.teamOptions )
                        	if( scopePointer.teamOptions[i].value == scopePointer.team.fields.id )
                        		scopePointer.selectTeam = scopePointer.teamOptions[i];
                         
                    },

                    getAllStarSort: function() {
                        return [{
                            value: 'points',
                            name: tr('Points')
                        }, {
                            value: 'assists',
                            name: tr('Assists')
                        }, {
                            value: 'steals',
                            name: tr('Steals')
                        }, {
                            value: 'blocks',
                            name: tr('Blocks')
                        }, {
                            value: 'offensive_rebounds+defensive_rebounds',
                            name: tr('Rebounds')
                        }, {
                            value: 'points:minute',
                            name: tr('Points per minute')
                        }, {
                            value: 'assists:minute',
                            name: tr('Assists per minute')
                        }, {
                            value: 'steals:minute',
                            name: tr('Steals per minute')
                        }, {
                            value: 'blocks:minute',
                            name: tr('Blocks per minute')
                        }, {
                            value: 'offensive_rebounds+defensive_rebounds:minute',
                            name: tr('Rebounds per minute')
                        }];

                    },

                    setScope: function(saveScope) {
                    	 
                        scopePointer = saveScope;
                    },

                    getCareers: function() {
                        var v = {};
                        v['teamCareer'] = scopePointer.team.fields.career;

                        v['playerCareer'] = scopePointer.player.career.career;
                        return v;
                    },

                    canSign: function() {
                        var v = this.getCareers();
                        if (v['teamCareer'] == v['playerCareer'])
                            return 1;
                        else
                            return 0;
                    },

                    selectTeam: function(item) {
                        for (var i in scopePointer.teams) {
                            if (scopePointer.teams[i].fields.id == item.value) {
                                id = item.value;
                                scopePointer.team = scopePointer.teams[i];
                            }
                        }
                    },

                    getOfferInfo: function(id_player, id_team, offerType, $scope) {
                        scopePointer = $scope;
                        id = id_team;
                        if (typeof id_team == 'undefined')
                            id = -1;
                        var obj = this;
                        var needsAjax = 1;
                        me.get('myTeams', me.get('id_account')).then(function(result) {

                            scopePointer.teams = result;

                            if (typeof id_team == 'undefined') {
                                id_team = result[0];
                                needsAjax = me.needsAjax(result[0], 1);
                            }
                            //obj.loadTeam( 'team' ); 
                        });

                        me.get('player', id_player).then(function(result) {
                            if (typeof scopePointer.player == 'undefined') {
                                scopePointer.player = result[0];
                                needsAjax = me.needsAjax(result[0], 1);
                            }

                            //obj.loadTeam( 'player' ); 
                            obj.updateContractOfferTitle(offerType);
                        });


                        if (needsAjax) {
                            //console.log(">>GET<<");
                            var getWhat = {
                                'get[teams]': 'fields',
                                'id[teams]': 'id_account-' + me.get('id_account'),
                                'get[player]': 'fields,contract,profile,career',
                                'id[player]': 'id_player-' + id_player
                            };
                            if (season != 0)
                                getWhat.season = season;

                            var promise = AJAX.get('MULTI', getWhat);
                            var myPos = 0;
                            scopePointer.API.setResting(true);
                            var obj = this;
                            promise.success(function(data, status, headers, config) {
                                //  console.log(">>da<<"); 
                                scopePointer.API.setResting(false);
                                //aici o sa fie mai multe synch-uri
                                if (data.status == 'SUCCESS') {
                                    scopePointer.player = data.ret.player;
                                    //console.log("MULT?>>>>>>>"+JSON.stringify(scopePointer.player)+"<<<");
                                    scopePointer.teams = data.ret.teams;

                                    obj.loadTeam('success');
                                    me.synch('player', data.ret.player, scopePointer.player, data.timestamp);
                                    me.synch('team', data.ret.team, scopePointer.team, data.timestamp);
                                    obj.updateContractOfferTitle(offerType);
                                } else scopePointer.API.setError('REST', scopePointer);
                            });

                            promise.error(function(data, status, headers, config) {
                           
                                scopePointer.API.setResting(false);
                                scopePointer.API.setError('REST', scopePointer);
                            });
                        }
                    },

                    

                    getButtonText: function(q, pos) {
                        return tr('Add Starter');

                    },

                    setPointer: function($scope) { 
                        scopePointer = $scope;
                    },

                    setId: function(clubId) {
                        console.log("set clubId =" + clubId);
                        id = clubId;
                    },

                    getId: function() {
                        return id;
                    },

                    //TACTICS PAGE ESSENTIALLY
                    getTacticsInfo: function(id_team, $scope) {
                        //id = id_team;
                        this.setId(id_team);
                        scopePointer = $scope;
                        scopePointer.sharingOptions.tactics = [{
                            value: 'passing_preferences',
                            name: tr('Passing Preferences')
                        }, {
                            value: 'shooting_parameters',
                            name: tr('Shooting Parameters')
                        }, {
                            value: 'play_intensity',
                            name: tr('Intensity')
                        }, {
                            value: 'play_style',
                            name: tr('Play Style')
                        }, {
                            value: 'off_the_ball_d',
                            name: tr('Off the ball D')
                        }, {
                            value: 'defensive_bonus',
                            name: tr('Defensive Bonus')
                        }];

                        for (var i = 1; i <= 5; i++) {
                            scopePointer.sharingOptions[i] = [];

                            var option = {};
                            var v = {};
                            for (var st = 10; st <= 90; st = st + 10) {
                                v['percent'] = st;
                                option = {};
                                option.name = tr('Under {percent}% Stamina', v);
                                option.value = 's_' + st;
                                scopePointer.sharingOptions[i].push(option);

                            }

                            for (var st = 1; st <= 4; st = st + 1) {
                                v['no'] = st;
                                option = {};
                                option.name = tr('More than {no} fouls', v);
                                option.value = 'f_' + st;
                                scopePointer.sharingOptions[i].push(option);
                            }

                            scopePointer.sharingModel[i] = scopePointer.sharingOptions[i][0];
                        }

                        scopePointer.sharingModel.tactics = scopePointer.sharingOptions.tactics[0];

                        var skills = me.get('skills');
                        var option = {};
                        scopePointer.sharingOptions.skills = [];
                        for (var sk in skills) {
                            option = {};
                            option.value = skills[sk];
                            option.name = me.getSkillTranslation(skills[sk]);
                            scopePointer.sharingOptions.skills.push(option);
                        }

                        scopePointer.sharingModel.skills = scopePointer.sharingOptions.skills[0];
                        //console.log("id = "+id_team+" [id_team] = "+id_team+" <<< ");

                        var obj = this;
                        scopePointer.data.title = tr('Tactics');

                        me.get('myTeams', me.get('id_account')).then(function(result) {

                            scopePointer.teams = result;
                            if (typeof id_team == 'undefined')
                                id_team = result[0];
                            obj.loadTeam('team', 1);
                        });
                        id = id_team;

                        var getWhat = {
                            'get': 'fields,tactics,players=fields-profile-tactics-skills',
                            id_team: id_team
                        };

                        var promise = AJAX.get('TEAM', getWhat);
                        scopePointer.API.setResting(true);
                        promise.success(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);
                            //aici o sa fie mai multe synch-uri
                            if (data.status == 'SUCCESS') {
                                scopePointer.data = data.ret;
                                obj.updateChangeModels(data.ret.tactics);
                                scopePointer.data.title = tr('Tactics');
                                obj.loadTeam('success', 1);
                                obj.loadPlayers();
                                //me.synch( 'player', data.ret.player, scopePointer.player, data.timestamp );
                                //me.synch( 'team',   data.ret.team, scopePointer.team, data.timestamp );

                            } else scopePointer.API.setError('REST', scopePointer);
                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });

                        //console.log("id = "+id_team+" [id_team] = "+id_team+" <<< ");
                    },

                    updateChangeModels: function(result) {
                        if (typeof result != 'undefined')
                            for (var q = 1; q <= 5; q++) {
                                if (typeof result.changer != 'undefined')
                                    if (typeof result.changer[q] != 'undefined') {
                                        if (typeof scopePointer.sharingOptions[q] != 'undefined') {
                                            for (var item in scopePointer.sharingOptions[q])
                                                if (result.changer[q] == scopePointer.sharingOptions[q][item].value)
                                                    scopePointer.sharingModel[q] = scopePointer.sharingOptions[q][item];

                                        }
                                    }
                            }
                    },

                    setForm: function(to) {
                        scopePointer.API.createBackButton('form', scopePointer);
                        scopePointer.form.status = to;
                    },

                    closeForm: function() {
                        scopePointer.form.status = 'form';
                        if( typeof scopePointer.API.deleteButton != 'undefiend' )
                        scopePointer.API.deleteButton();
                    },

                    submitSave: function() {
                        //restrictions

                        var byShot = {};

                        if (typeof scopePointer.data.tactics != 'undefined')
                            if (typeof scopePointer.data.tactics.restrictions != 'undefined')
                                for (var pid in scopePointer.data.tactics.restrictions) {

                                    if (typeof byShot[scopePointer.data.tactics.restrictions[pid]] == 'undefined')
                                        byShot[scopePointer.data.tactics.restrictions[pid]] = [];

                                    byShot[scopePointer.data.tactics.restrictions[pid]].push(pid);
                                }

                        var restrictionString = '';
                        var comma = '';
                        var players = [];
                        //alert( JSON.stringify( byShot ) );
                        for (var shot in byShot) {
                            players = byShot[shot];
                            if (shot.length >= 2)
                                if (typeof players != 'undefined')
                                    if (players.length > 0) {
                                        restrictionString += '' + comma + '' + shot + ':' + players.join("-");
                                        comma = '|';
                                    }
                        }


                        var changer = [];
                        var parameters = '';
                        for (var q = 1; q <= 5; q++) {
                            changer != '';

                            //player change mode
                            if (typeof scopePointer.sharingModel != 'undefined')
                                if (typeof scopePointer.sharingModel[q] != 'undefined')
                                    changer = scopePointer.sharingModel[q].value;

                                //lineups

                            if (typeof scopePointer.data.tactics.lineups != 'undefined')
                                if (scopePointer.data.tactics.lineups != null)
                                    if (typeof scopePointer.data.tactics.lineups[q] != 'undefined')
                                        for (var pos in scopePointer.data.tactics.lineups[q]) {
                                            parameters = parameters + '&q_' + q + '_' + (pos) + '=' + this.getSavePlayerString(scopePointer.data.tactics.lineups[q][pos]);
                                        }



                            parameters = parameters + '&change_' + q + '=' + changer;
                            parameters = parameters + '&q_' + q + '_restriction=' + restrictionString;
                        }


                        var getWhat = {
                            'do': 1 + '' + parameters,
                            'get': 1,
                            'return': 'fields,tactics',
                            'id_club': id
                        };
                        var promise = AJAX.patch('TEAMTACTICS', getWhat);

                        promise.success(function(data, status, headers, config) {


                            scopePointer.API.setResting(false);
                            scopePointer.API.checkNotifications(data, scopePointer);

                            if (data.status == 'SUCCESS') {
                                scopePointer.changes = 0;
                                me.synch('team', data.ret['return'], scopePointer.team, data.timestamp);
                                scopePointer.API.setMessage(tr('Saved'));
                            } else scopePointer.API.setError('REST', scopePointer);
                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },

                    clearTactics: function() {

                        var promise = AJAX.hit('TEAMTACTICS/REMOVE/?id_club=' + id + '&token=' + AJAX.getToken());
                        promise.success(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);
                            scopePointer.API.checkNotifications(data, scopePointer);

                            if (data.status == 'SUCCESS') {
                                scopePointer.API.setMessage(tr('Cleared'));
                                scopePointer.back();
                                //scopePointer.data.tactics = null;
                                me.synch('team', scopePointer.data, null, data.timestamp);
                            } else {
                                //alert("aaa");
                                scopePointer.API.setError(data.ret.message);
                            }
                        });

                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });

                    },

                    getSavePlayerString: function(array) {
                        var string = '';
                        var comma = '';
                        if (typeof array != 'undefined')
                            for (var k in array) {
                                string += comma + array[k];
                                comma = ',';
                            }
                        return string;
                    },

                    loadPlayers: function() {
                        var pl;
                        for (var i in scopePointer.data.players) {
                            pl = scopePointer.data.players[i];
                            player[pl.fields.id] = i;
                        }
                    },

                    updateContractOfferTitle: function(offerType) {
                        if (typeof scopePointer.player != 'undefined')
                            if (offerType == 'renewal') {
                                scopePointer.data.title = tr('Renewal to {first_name} {last_name}', scopePointer.player.fields);
                            } else {
                                scopePointer.data.title = tr('Sign {first_name} {last_name}', scopePointer.player.fields);
                            }
                    },

                    getLineupName: function(obj) {
                        return (!this.getSeason() ? (obj.first_name + ' ' + obj.last_name) : obj.name);
                    },

                    getName: function(pid) {
                        var name = this.getItem(pid, 'name');

                        if (typeof name == 'undefined')
                            return tr('Player no longer on team');
                        else
                            return name;
                    },

                    getItem: function(pid, what) {
                        if (typeof scopePointer.data.players != 'undefined')
                            if (typeof player != 'undefined')
                                if (typeof player[pid] != 'undefined') {
                                    switch (what) {
                                        case "name":
                                            return scopePointer.data.players[player[pid]].fields.first_name + ' ' + scopePointer.data.players[player[pid]].fields.last_name;
                                            break;

                                        case "id_country":
                                            return scopePointer.data.players[player[pid]].fields.id_country;
                                            break;

                                        case "username":

                                            if (typeof scopePointer.data.players[player[pid]].profile != 'undefined')
                                                return scopePointer.data.players[player[pid]].profile.username;

                                            break;
                                    }

                                }




                    },

                    addPlayerToLineup: function(pid) {
                        scopePointer.data.title = tr('Tactics');
                        scopePointer.form.status = 'form';
                        var q = scopePointer.form.q;
                        var pos = scopePointer.form.pos;

                        if (typeof scopePointer.data.tactics == 'undefined')
                            scopePointer.data.tactics = {};

                        if (typeof scopePointer.data.tactics.lineups == 'undefined')
                            scopePointer.data.tactics.lineups = {};

                        if (scopePointer.data.tactics.lineups == null)
                            scopePointer.data.tactics.lineups = {};

                        if (typeof scopePointer.data.tactics.lineups[q] == 'undefined')
                            scopePointer.data.tactics.lineups[q] = {};

                        if (typeof scopePointer.data.tactics.lineups[q][pos] == 'undefined')
                            scopePointer.data.tactics.lineups[q][pos] = [];

                        scopePointer.data.tactics.lineups[q][pos].push(pid);
                        scopePointer.changes++;
                    },

                    backToTactics: function() {
                        scopePointer.form.status = 'form';
                        scopePointer.data.title = tr('Tactics');
                        scopePointer.API.deleteBackButton();
                    },

                    restrictThisGuy: function(pid) {
                        scopePointer.form.status = 'choose_restriction';
                        var player = {};
                        player.name = this.getName(pid);
                        scopePointer.data.title = tr('Restrict {name}', player);
                        scopePointer.form.restrictPid = pid;
                    },

                    removeRestriction: function(pid) {
                        if (typeof scopePointer.data.tactics.restrictions != 'undefined')
                            if (typeof scopePointer.data.tactics.restrictions[pid] != 'undefined')
                                delete scopePointer.data.tactics.restrictions[pid];

                        scopePointer.changes++;
                    },

                    restrictShot: function(which) {
                        scopePointer.form.status = 'form';
                        var pid = scopePointer.form.restrictPid;
                        if (typeof scopePointer.data.tactics == 'undefined')
                            scopePointer.data.tactics = {
                                restrictions: []
                            };

                        if (typeof scopePointer.data.tactics.restrictions != 'undefined') {
                            if (scopePointer.data.tactics.restrictions == null)
                                scopePointer.data.tactics.restrictions = {};

                            scopePointer.data.tactics.restrictions[pid] = which;
                        }
                        scopePointer.changes++;
                    },

                    createRestrictionForm: function() {
                        scopePointer.API.createBackButton('form', scopePointer);
                        scopePointer.data.title = tr('Restrict a player');
                        scopePointer.form.status = 'restriction';
                        var player = {};
                        scopePointer.restrictable = [];
                        var positions = me.getPositionText();

                        for (var pl in scopePointer.data.players) {
                            player = scopePointer.data.players[pl];
                            doit = 1;
                            if (typeof scopePointer.data.tactics != 'undefined')
                                if (typeof scopePointer.data.tactics.restrictions != 'undefined')
                                    if (scopePointer.data.tactics.restrictions != null)
                                        if (typeof scopePointer.data.tactics.restrictions[player.fields.id] != 'undefined')
                                            doit = 0;

                            if (doit)
                                scopePointer.restrictable.push(player.fields.id);
                        }

                    },

                    removePlayer: function(q, pos, num) {
                        if (typeof scopePointer.data.tactics.lineups[q] != 'undefined')
                            if (typeof scopePointer.data.tactics.lineups[q][pos] != 'undefined') {
                                scopePointer.data.tactics.lineups[q][pos].splice(num, 1);
                                scopePointer.changes++;
                            }
                    },

                    addPlayerTo: function(q, posu) {
                        scopePointer.API.createBackButton('form', scopePointer);
                        scopePointer.data.title = tr('Choose Player');
                        scopePointer.form.status = 'choice';
                        scopePointer.form.q = q;
                        scopePointer.form.pos = posu;
                        scopePointer.choices = [];
                        var player = {};
                        var positions = me.getPositionText();

                        for (var pl in scopePointer.data.players) {
                            player = scopePointer.data.players[pl];
                            doit = 1;
                            if (typeof scopePointer.data.tactics != 'undefined')
                                if (scopePointer.data.tactics.lineups != null)
                                    if (typeof scopePointer.data.tactics.lineups[q] != 'undefined') {
                                        for (var pos in positions)
                                            if (typeof scopePointer.data.tactics.lineups[q][pos] != 'undefined') {
                                                if (parseInt(scopePointer.data.tactics.lineups[q][pos][0]) == parseInt(player.fields.id)) {
                                                    doit = 0;
                                                }
                                            }


                                        if (typeof scopePointer.data.tactics.lineups[q][posu] != 'undefined')
                                            for (var iPid in scopePointer.data.tactics.lineups[q][posu])
                                                if (parseInt(scopePointer.data.tactics.lineups[q][posu][iPid]) == parseInt(player.fields.id))
                                                    doit = 0;

                                    }


                            if (doit)
                                scopePointer.choices.push(player.fields.id);
                        }

                    },

                    getButtonText: function(q, pos) {

                        if (typeof scopePointer.data.tactics != 'undefined')
                            if (typeof scopePointer.data.tactics.lineups != 'undefined')
                                if (scopePointer.data.tactics.lineups != null)
                                    if (typeof scopePointer.data.tactics.lineups[q] != 'undefined')
                                        if (typeof scopePointer.data.tactics.lineups[q][pos] != 'undefined') {
                                            var size = scopePointer.data.tactics.lineups[q][pos].length;
                                            var v = {};
                                            v['num'] = size;
                                            v['pos'] = tr(pos);
                                            if (size == 0)
                                                return tr('Add Starter');

                                            return tr('Add {pos} Sub #{num}', v);
                                        } else
                                            return tr('Add Starter');

                        return tr('Add Starter');
                    },

                    privateFroumAccess: function() {

                        if (typeof scopePointer.data.fields != 'undefined') {

                            if (scopePointer.data.fields.id_account == me.get('id_account'))
                                return 1;

                            for (var item in scopePointer.data.players)
                                if (scopePointer.data.players[item].fields.id_account == me.get('id_account'))
                                    return 1;
                        }

                        return 0;
                    },


                    getPositionText: function(andVar, teamId) {
                        var v = {};
                        var myPos = 0;
                        for (var pos in andVar)
                            if (typeof andVar[pos].team != 'undefined')
                                if (andVar[pos].team.fields.id == teamId)
                                    myPos = andVar[pos].place;
                        v['pos'] = myPos;
                        if (myPos == 1)
                            scopePointer.data.positionText = tr('1st in their league');
                        else if (myPos == 2)
                            scopePointer.data.positionText = tr('2nd in their league');
                        else if (myPos == 3)
                            scopePointer.data.positionText = tr('3rd in their league');
                        else if (myPos > 3)
                            scopePointer.data.positionText = tr('{pos}th in their league', v);
                        else
                            scopePointer.data.positionText = tr('Standing in their league');
                    },

                    submitEdit: function(which, value) {
                        if (which == 'promotes_to') {
                            scopePointer.team.fields.promotes_to = scopePointer.form.promotesTo;
                        } else if (which == 'id_country') {
                            var value = scopePointer.form.selectCountry.value;
                        } else
                            var value = scopePointer.form.newName;
                        var edit = {};

                        edit[which] = value;
                        var getWhat = {
                            'id_team': id,
                            edit: edit,
                            'return': 'fields'
                        };
                        var promise = AJAX.patch('TEAM', getWhat);

                        scopePointer.API.setResting(true);
                        scopePointer.noMore = 0;
                        promise.success(function(data, status, headers, config) {

                            scopePointer.API.setResting(false);
                            scopePointer.API.checkNotifications(data, scopePointer);
                            if (data.status == 'SUCCESS') {
                                scopePointer.form.status = 'form';
                                if (typeof data.ret['return'] != 'undefined')
                                    if (typeof data.ret['return'] != 'undefined') {
                                        me.synch('team', scopePointer.data, data.ret['return'], data.timestamp);
                                        scopePointer.data.fields = data.ret['return'].fields;
                                    }
                            } else {
                                scopePointer.API.setResting(false);
                                scopePointer.API.setError(data.ret.message);
                            }

                        });



                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },

                    getNextSeasonText: function(which) {
                        switch (which) {
                            case scopePointer.data.fields.id_career:
                                return tr('Stays in this career stage');
                                break;

                            case 0:
                            default:
                                return tr('Promotes to the next career stage');
                                break;

                        }

                    },


                    needsAjax: function(result) {
                        //checks whether the data has been updated today
                        //or if a game was scheduled to play today and it is likely to have simmed
                        //in which case its time to update
                        return 1;
                    },


                    getPlayerSearch: function(id_team, $scope) {
                        this.setId(id_team);
                        scopePointer = $scope;
                        var obj = this;
                        scopePointer.data.title = tr('Sign Players');
                        scopePointer.sortOptions = [{
                            value: 'points',
                            name: tr('Points')
                        }, {
                            value: 'assists',
                            name: tr('Assists')
                        }, {
                            value: 'steals',
                            name: tr('Steals')
                        }, {
                            value: 'blocks',
                            name: tr('Blocks')
                        }, {
                            value: 'rebounds',
                            name: tr('Rebounds')
                        }];
                        if (typeof scopePointer.sortByOption == 'undefined')
                            scopePointer.sortByOption = scopePointer.sortOptions[0];


                        me.get('myTeams', me.get('id_account')).then(function(result) {

                            if (typeof result[0] != 'undefined') {
                                scopePointer.teams = result;
                                if (typeof id_team == 'undefined')
                                    id_team = result[0];

                                obj.loadTeam('team');
                                if (typeof cacheSearch == 'undefined')
                                    obj.loadPlayerDirectory('replace', 0, 'points', -1);
                                else {
                                    if (typeof cacheSearch.data == 'undefined')
                                        obj.loadPlayerDirectory('replace', 0, 'points', -1);
                                    else {
                                        scopePointer.data = cacheSearch.data;
                                        scopePointer.sortByOption = cacheSearch.sortByOption;
                                        scopePointer.andPos = cacheSearch.andPos;
                                    }
                                }
                            } else {
                                var getWhat = {
                                    'get': 'fields',
                                    id_account: me.get('id_account')
                                };
                                var promise = AJAX.get('TEAMS', getWhat, 1);
                                promise.success(function(data, status, headers, config) {
                                    obj.updateManageTeamView(data);
                                });
                                promise.update(function(data, status, headers, config) {
                                    obj.updateManageTeamView(data);
                                });
                                promise.error(function(data, status, headers, config) {
                                    scopePointer.API.setResting(false);
                                    scopePointer.API.setError('REST', scopePointer);
                                });

                            }
                        });
                    },

                    updateManageTeamView: function(data) {
                     
                        var obj = this;
                        scopePointer.cachedCopy = data.cache;
                        if (!data.cache)
                            scopePointer.API.setResting(false);

                        scopePointer.API.checkNotifications(data, scopePointer);

          
                        if (typeof data.ret != 'undefined') {
 
                        	var teams = [];
                        	if( typeof data.ret.fields != 'undefined' )
                        		teams.push( data.ret );
                        	else
                        		teams = data.ret;
                        	
                        
                            for (var i in teams)
                           		if (teams[i] != 'undefined'){
                           			/*alert(teams[i].fields.id); */
                                    if (teams[i].fields.id == id)
                                        scopePointer.team = teams[i]; 
                            }
                        }

                        obj.loadPlayerDirectory('replace', 0, 'points', -1);

                    },

                    getOrderBy: function() {
                        if (typeof scopePointer.sortByOption != 'undefined')
                            return '-' + scopePointer.sortByOption.value;
                        else
                            return '-points';
                    },

                    loadPlayerDirectory: function(method, fromI, sort, pos) {
                        var getWhat = {
                            'career': scopePointer.team.fields.career,
                            'type': scopePointer.team.fields.club_type,
                            from: fromI,
                            sortBy: sort,
                            'pos': pos
                        }
                        if (getWhat.type == 5)
                            getWhat.id_country = scopePointer.team.fields.id_country;
                        
                        var promise = AJAX.get('PLAYER_DIRECTORY', getWhat, 1);

                        scopePointer.API.setResting(true);
                        scopePointer.noMore = 0;
                        var obj = this;
                        promise.success(function(data, status, headers, config) {
                            obj.updatePlayerDirectoryView(data, method);
                        });
                        promise.update(function(data, status, headers, config) {
                            obj.updatePlayerDirectoryView(data, method);
                        });
                        promise.error(function(data, status, headers, config) {
                            scopePointer.API.setResting(false);
                            scopePointer.API.setError('REST', scopePointer);
                        });
                    },

                    updatePlayerDirectoryView: function(data, method) {
                        var obj = this;
                        scopePointer.cachedCopy = data.cache;
                        if (!data.cache)
                            scopePointer.API.setResting(false);
                        scopePointer.API.checkNotifications(data, scopePointer);
                        if (typeof data.ret != 'undefined') {

                            if (typeof data.ret.players != 'undefined')
                                if (data.ret.players != null)
                                    if (data.ret.players.length >= 1) {
                                        if (method == 'loadMore')
                                            for (var i in data.ret.players)
                                                scopePointer.data.players.push(data.ret.players[i]);
                                        else
                                            scopePointer.data = data.ret;
                                    } else
                                        scopePointer.noMore = 1;
                            else
                                scopePointer.noMore = 1;
                            else
                                scopePointer.noMore = 1;
                        }

                        scopePointer.data.title = tr('Sign Players');
                        cacheSearch.data = scopePointer.data;
                        cacheSearch.sortByOption = scopePointer.sortByOption;
                        cacheSearch.andPos = scopePointer.andPos;
                    },

                    updateListing: function(andSize) {
                        var replace;
                        if (typeof andSize != 'undefined') {
                            fromI = andSize;
                            method = 'loadMore';
                        } else {
                            fromI = 0;
                            method = 'replace';
                        }
                        this.loadPlayerDirectory(method, fromI, scopePointer.sortByOption.value, scopePointer.andPos);
                    }




                }

            }
        ]);
}());