(function () {
  
    var scopePointer; 
    var id;
    var type;
    var addingMSG = 0;
    var browsing  = null;
    var dbCache;
    var pushChanges = 0;
    
      
		
    angular.module('myApp.notifications', ['myApp.AJAX','myApp.me' ])
        .service('notifications', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                	     
                	get: function( $scope, loadMore, ids )
                	{
                		 if( $scope != null )
                		 	 scopePointer 		= $scope;
                		 var getWhat	 	= {get:'all',setViewed:1};
                		 
                		 if( typeof loadMore != 'undefined' || loadMore == 0 )
                		 {
                		 	 var withCache=0;
                		 	 if( typeof scopePointer.alerts != 'undefined' )
                		 	 	getWhat.from = scopePointer.alerts.length;
                		 }else{
                		 	var withCache=1;	 
                		 }
                		 		
                		 if( typeof ids != 'undefined' )
                		 	 getWhat.ids = ids;
                		 	
                		 this.getFromDB();
                		 
                	 
                		 
                		 var promise 		= AJAX.get('NOTIFICATIONS', getWhat , withCache );
                		 scopePointer.API.setResting(true);
                		 scopePointer.data.title = tr('Notifications');
                		 var obj 		= this;
                		 promise.success(function(data, status, headers, config) {
                		 	obj.updateNotificationsView( data,loadMore );
				 });
				 
				 if( promise.update  )
					 promise.update(function(data, status, headers, config) {
                		 	obj.updateNotificationsView( data,loadMore  );
				 });
				
				 promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				 }); 
                	},
                	
                	setScopePointer: function( to )
                	{
                		scopePointer = to;	
                	},
                	
                	updateNotificationsView: function( data,loadMore )
                	{ 
                		scopePointer.cachedCopy = data.cache;
                		if( !data.cache ) 
                			scopePointer.API.setResting(false);
				
					
				if( data.status == 'SUCCESS' )
				{
					if( typeof loadMore == 'undefined' )
					{
						scopePointer.alerts 	= data.ret;
						var synch = {};
						synch.fields = {id: me.get('id_account')};
						synch.alerts = data.ret;
					 
						me.synch('notifications', synch, dbCache, data.timestamp );
					}
					else
						for( var i in data.ret )
							scopePointer.alerts.push( data.ret[i] );
				}
				else
					scopePointer.API.setError( data.ret.message, scopePointer );		
                		
                	},
                	
                	ajaxPushSettings: function( $scope )
                	{
                		if( $scope != null )
                		 	 scopePointer 		= $scope;
                		 
                		var getWhat	 	= {id_account: me.get('id_account'), get:'fields,devices,dnd,email_summary_settings'};
                		
                		 var promise 		= AJAX.get('ACCOUNTS', getWhat );
                		 scopePointer.API.setResting(true);
                		 scopePointer.data.title = tr('Push Settings');
                		 promise.success(function(data, status, headers, config) {	 
                		 	if( data.status == 'SUCCESS' )
					{		 
						scopePointer.data = data.ret;
					 
						scopePointer.data.title = tr('Push Notification Settings');
						scopePointer.API.setResting(false);
					}
					else
						scopePointer.API.setError( data.ret.message, scopePointer );
                		 });
                		 
                		 
                		 promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
                		
                	},
                	
                	getFromDB: function()
                	{
                		me.get('notifications', me.get('id_account') ).then(function( result ) { 
                				 
                			dbCache = {};
                			if( typeof result[0] != 'undefined' )
						if( typeof result[0].alerts != 'undefined' )
						{
							dbCache.fields 		= {id:me.get('id_account')};
							dbCache.alerts 		= result[0].alerts;
							scopePointer.alerts 	= result[0].alerts;
						}
                		});
                	},
                	
                	parseTitle: function( notification )
                	{
                		var v = this.removeUnneccessary( tryParseJSON(notification.v) );
                		
                		if( notification.type == 'login_bonus' )
                			return tr('Login bonus received. Click here to spend CyberPoints');
                		
                		if( typeof v.username == 'undefined' && typeof v.op != 'undefined' )
                			v.username = v.op;
                		else if( v.username == null &&  typeof v.op != 'undefined' )
                			v.username = v.op;
                		else;
                		//console.log(">>>>>>>>>>>>>>>>>>>>"+JSON.stringify(notification.v));
                		//console.log(">>> "+JSON.stringify(v));
                		return tr(notification.title,v).replace(/(({translate}))/ig, '').replace(/(({closelink}))/ig, '</span>').replace(/@([a-z\d-]+)/ig, "<span class='blue'>$1</span>"); 	
                	},
                	
                	parseLink: function( notification )
                	{ 
                		//console.log( me.getAddress(notification) );                 
                		return 'go(\''+me.getAddress(notification)+'\');';
                	},
                	
                	parseIcon: function( notification )
                	{
                		switch( notification.type )
                		{
                			case "tutorial_question":
                			case "contract":
                			case "private_message":
					case "offer_received":
					case "wc_vote":
					case "demo_game":
					case "release":
                			case "promotion":
                			case "cup":
                			case "like":
                			case "login_bonus":
                			case "new_post":
                			case "new_message":
                			case "mention":
 					case "accept_contract":
 					case "reject_contract":
					case "demo_game":               				
                				return notification.type+"."+(me.canSvg()?'svg':'png');
                			break;
                			
                			default:
                				return 'default.'+(me.canSvg()?'svg':'png');
                			break;
                			
                		}
                		
                	},
                	
                	removeUnneccessary: function( from )
                	{
                		if( typeof from == 'object')
                		{ 
                			from['/link'] 		= '</span>';
                			from['/a']   		= '</span>';
                			from['closelink']   	= '</span>';
                			from['openlink']   	= '<span class="blue">';
                			from['a']   		= '<span class="blue">';
                			from['link']   		= '<span class="blue">';
                		}
                		
                		return from;
                	},
                	
                	isPushSubscribed: function()
                	{
                		
                		
                	},
                	
                	
                	updatePushSettings: function( ids, to )
                	{  
                		var offset 	= new Date().getTimezoneOffset();
                		var gmtTime	= parseInt(offset/60)*(-1);
                		var options	= {gmt:gmtTime,oneSignalId: ids.userId, pushToken: ids.pushToken, id_account: me.getIdAccount(), platform:getPlatform(), device: getDevice() }; 
                		var setTo 	= ids.userId;
                		var promise 	= AJAX.put('PUSH_SETTINGS', options );
                		var obj 	= this;
                		promise.success(function(data, status, headers, config) { 
					if( data.status == 'SUCCESS' )
					{ 
						obj.updateStorage( setTo ); 
					}
					else
						obj.updateStorage( setTo ); 
				 
					  
				});
				
				promise.error(function(data, status, headers, config) {
					//obj.updateStorage( 'ALREADY_OR_ERROR' ); 	 
				});  
                	},
                	
                	updateStorage: function( setTo )
                	{
                		scopePointer.API.setOneSignalId( setTo );
                		//localStorage.setItem( 'oneSignalId', setTo  );
                	},
                	
                	getChanges: function()
                	{
                		return pushChanges;	
                	},
                	
                	setPushChanges: function( to )
                	{
                		pushChanges = to;	
                	},
                	
                	addPushChanges: function()
                	{
                		pushChanges++;	
                	},
                	
                	togglePushSetting: function( index, setting )
                	{
                		this.addPushChanges(); 
                		if( scopePointer.data.devices[index].settings == null )
                			scopePointer.data.devices[index].settings = {};
                		if( typeof scopePointer.data.devices[index] != 'undefined' )
                			if( typeof scopePointer.data.devices[index].settings != 'undefined' )
                				if( typeof scopePointer.data.devices[index].settings[setting] != 'undefined' )
                				{
                					 
                					if(   scopePointer.data.devices[index].settings[setting] == 'OFF' )
                						scopePointer.data.devices[index].settings[setting] = 'ON';
                							else
                								scopePointer.data.devices[index].settings[setting] = 'OFF';		
                				}
                				else
                				{
                					scopePointer.data.devices[index].settings[setting] = 'OFF'; 
                					if( setting == 'pregame' )
                						scopePointer.data.devices[index].settings[setting] = 'ON'; 	
                				} 
                	},
                	
                	getPushSetting: function( index, setting, selected )
                	{
                		
                		if( typeof scopePointer.data.devices[index] != 'undefined' )
                			if( typeof scopePointer.data.devices[index].settings != 'undefined' )
                				if( scopePointer.data.devices[index].settings != null )
							if( typeof scopePointer.data.devices[index].settings[setting] != 'undefined' )
							{ 
								if( typeof selected != 'undefined' )
								{
									//console.log(" index="+index+" setting="+setting+" >>> "+ ( scopePointer.data.devices[index].settings[setting] )+" << ");
									return  scopePointer.data.devices[index].settings[setting];
								}
								return scopePointer.data.devices[index].settings[setting];
								//settings[settingNum].selected == true ? 'ON' : 'OFF' ;
							}
							
							
				if( setting == 'pregame' ) 
					return 'OFF';
						else
							return 'ON'; 
                	},
                	
                	disablePushDevice: function( index )
                	{
                		scopePointer.data.devices[index].fields.stat = 'OFF';	
                	},
                	
                	enablePushDevice: function( index )
                	{
                		scopePointer.data.devices[index].fields.stat = 'ON';	
                	},
                	
                	getPossiblePushSettings: function()
                	{ 
                		 
                		var settings = [];
                		settings.push( {label: tr('When live games start'), 	value: 'pregame'} );
                		settings.push( {label: tr('After games end'), 			value: 'aftergame'} );
                		settings.push( {label: tr('Chat messages'), 			value: 'chat'} );
                		settings.push( {label: tr('League and wall posts'), 	value: 'post'} );
                		settings.push( {label: tr('Thread comments'), 			value: 'comment'} );
                		settings.push( {label: tr('Login Bonuses'), 			value: 'login_bonus'} );
                		settings.push( {label: tr('Contracts'), 				value: 'contract'} );
                		settings.push( {label: tr('Referrals'), 				value: 'referrals'} );
                		settings.push( {label: tr('Translations'), 				value: 'translation'} );
                		settings.push( {label: tr('All others'), 				value: 'all_others'} );
                	 
                		return settings;
                	},
                	
                	dndAdd: function()
                	{
                		var offset = new Date().getTimezoneOffset();
                		var opt = {};
                		opt.from = document.getElementById('from_hour').value+':'+document.getElementById('from_minute').value;
                		opt.to   = document.getElementById('to_hour').value+':'+document.getElementById('to_minute').value;
                		opt.gmt	 = parseInt(offset/60)*(-1);
                		 
                		scopePointer.data.dnd.push( opt );
                		scopePointer.form.status = 'default';
                		this.addPushChanges();
                	},
                	
                	setForm: function( to )
                	{
                		scopePointer.API.createBackButton( 'default', scopePointer );
                		scopePointer.form.status = to;	
                	},
                	
                	deleteDND: function( index )
                	{
                		this.addPushChanges();
                		scopePointer.data.dnd.splice(index,1);
                	},
                	
                	getHighlightClass: function( highlight, current ){
                		
                	 
                		if( highlight == current.value )
                			return 'highlightThis';
                		else
                			return '';
                		
                	},
                	 
                	ajaxSavePushSettings: function()
                	{
                		 
                		var string  = '';
                		var device  = {};
                		var options = {dnd:[]};
                		var comma   = '';
                		for( var dndNum in scopePointer.data.dnd )
                		{
                			var dnd = scopePointer.data.dnd[dndNum];
                			var opt = {from: dnd.from, to: dnd.to, gmt: dnd.gmt};
                			options.dnd.push( opt );
                		}
                		for( var index in scopePointer.data.devices )
                		{
                			device 		= scopePointer.data.devices[ index ];
                			 
                			string 		= "stat:"+device.fields.stat;
                			var settings 	= this.getPossiblePushSettings();
                			for( var settingNum in settings )
                			{
                				var setting = settings[settingNum].value;
                				string += ","+setting+":"+this.getPushSetting( index, setting, 'selected' ); 
                			}
                			
                			options[ device.fields.id ] = string;	
                		}
                		
                		options[ 'email_summary_settings' ] = scopePointer.data.email_summary_settings.interval;
                		
                		//options.email_summary_settings = scopePointer.email_summary_settings.value;
                		 
              			var promise = AJAX.patch('PUSH_SETTINGS', options );
              			var obj     = this;
              			promise.success(function(data, status, headers, config) {	 
                		 	if( data.status == 'SUCCESS' )
					{ 
						//if( typeof data.ret['return'][0] != 'undefined' )
						//	scopePointer.data = data.ret['return'][0];
						obj.setPushChanges( 0 );
						scopePointer.data.title = tr('Push Notification Settings');
						scopePointer.API.setResting(false);
						scopePointer.API.setMessage( data.ret.message );
					}
					else
						scopePointer.API.setError( data.ret.message, scopePointer );
                		 });
                		 
                		 
                		 promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				});  
                	},
                	
                	enablePush: function()
                	{
                		if( typeof  typeof window.plugins != 'undefined' )
					if( typeof window.plugins.oneSignal != 'undefined' )
						window.plugins.OneSignal.registerForPushNotifications();				
                	},
                	
                	disabledForThisDevice: function()
                	{
                		var md5OneSignalId = md5(scopePointer.API.getOneSignalId() );
                		if( typeof scopePointer.data != 'undefined' )
                			if( typeof scopePointer.data.devices != 'undefined' )
                				for( var i in scopePointer.data.devices )
                				{
                					var device = scopePointer.data.devices[i];
                					//console.log( device.fields.onesignalIdmd5+" == "+md5OneSignalId );
                					if( device.fields.onesignalIdmd5 == md5OneSignalId )
                					{
                						//console.log("DA! stat = "+device.fields.stat+" ");
                						if( device.fields.stat == 'ON' )
                							return 0;
                								else
                									return 1;
                					} 	
                				}
                		
                		return 1;
                	},
                	
                	getHelp: function( page, item )
                	{
                		var help = { items:{} };
                		
                		
                		switch( page )
                		{
                			case "pushSettings":
                				help.items.device		= {text:tr('What kind of notifications will be sent to your device (phone/desktop/tablet/etc.).')+' '+tr('The pre-game and post-game alerts are not saved in-game.')+' '+tr('If you disable the device, you will no longer receive push notifications from us.')+' '+tr('You will still get in-game alerts. The device can be enabled again at any time.'), title:tr('Push Notifications to device')};
                				help.items.dnd			= {text:tr('We will not bother you when you are sleeping or during an important meeting, just set the proper interval.'), title:tr('Do-not-disturb hours')};
                				help.items.email		= {text:tr('We send a short account summary to your email every now and then.'), title:tr("Email Summary")};
                		 	 break;
                			 
                		}
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help; 	
                	}
                	
                }

            }]);
}());
