(function () {
  
    var scopePointer;
    var step      	= 0;  
    var order		= {0:'-',1:'createPlayer',2:'draft', 3:'simulateGame', 4:'spendSkillpoints', 5:'statGoals', 6:'setTactics', 7: 'buyEquipment', 8: 'viewLeague', 9: 'viewGames', 10: 'homepage', 11: 'cyberpoints', 12:'cyberpoints-earn'};
    var steps		= {};
    var requestedQs	= 0;
    angular.module('myApp.tutorial', ['myApp.AJAX','myApp.me' ])
        .service('tutorial', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return {
                	getStepNum: 	  function(){ return step;   },
                	setStep: 	  function( to ){ step = to; },
                	getStep: 	  function()    { return order[step]; },
                	nextStep: 	  function(){ step++; },
                	doneStep: 	  function( which ){
                		console.log("doneSTEP - "+which);
                		if( step >= 1 ){ 
					var stepNum = this.determineStepNum( which );
					 
					if( stepNum == step )
						this.nextStep();
                		}
                	},
                	determineStepNum: function( which ){
                		var curStep = -1;
                		for( var i in order )
                			if( order[i] == which )
                				curStep = i;
                		return curStep;
                	},
                	steps: function( what )
                	{ 
                		 var v = {'num': 2 };
                		 steps['createPlayer'] 		= {'text': tr('Start by creating a player'),'page':'partials/home.html' };
                		 steps['draft'] 		= {'text': tr('Tap to join a team'),'page':'partials/home.html' };
                		 
                		 steps['draft-help']		= {'text': tr('Tap the "?" for more info where available') };
                		 
                		 
                		 steps['simulateGame'] 		= {'text': tr("Let's simulate a game now"),'page':'partials/home.html' };
                		 steps['spendSkillpoints'] 	= {'text': tr("Most games give skillpoints which can be used to improve your player. When you're done viewing the game, tap to spend."),'page':'partials/home.html' };
                		 steps['spendSkillpoints-myCrib'] 	= {'text': tr("Spend the skillpoints you've received in the last game."),'page':'partials/player/myPlayer.html' };
                		 steps['statGoals'] 		= {'text': tr("Let's set a statistical goal for the next games."),'page':'partials/player/myPlayer.html' };
                		 steps['setTactics'] 		= {'text': tr("Set tactics to help achieve that goal."),'page':'partials/player/myPlayer.html' };
                		 steps['buyEquipment']		= {'text': tr("Buy some equipment") };
                		 steps['buyEquipment-doit']	= {'text': tr("Tap to view the store") };
                		 steps['buyEquipment-cheap']    = {'text': tr("Get a cheap item, you can't afford much atm") };
                		 steps['viewLeague']		= {'text': tr("Competitions your teams are part of") };
                		 steps['viewLeague-visit']	= {'text': tr("Tap to visit your league.")+' \n '+tr('See the "?" for details on the various types of competitions.') };
                		 steps['back-to-player']	= {'text': tr("Let's go back to the player") };
                		 steps['viewGames']		= {'text': tr("Fixtures and results appear here") };
                		 steps['homepage']		= {'text': tr("Players and clubs you manage are here") };
                		 steps['cyberpoints']		= {'text': tr("To get your own team use CyberPoints") };
                		 steps['cyberpoints-switch']	= {'text': tr("You can also get extra skillpoints, custom equipment, a superstar player or more than {num} player slots",v) };
                		 steps['cyberpoints-earn']	= {'text': tr("Can be earned for free or bought") };
                		 
                		 return steps[what];
                	},
                	
                	requestQuestion: function(){
                		if( requestedQs == 0 )
                		{
                			this.doneStep('cyberpoints');
                			var promise = AJAX.put('TUTORIAL_QUESTIONS', {id_account:me.get('id_account'), 'nextQuestion':1},1 ); 
                			requestedQs = 1;
                		}
                	},
                	
                	getQuestion: function( idQuestion, $scope ){
                		 
                			 var promise = AJAX.get('TUTORIAL_QUESTIONS', {id_account:me.get('id_account'), 'get':'fields,all', 'id_question': idQuestion },1 ); 
                			 var obj     = this;
                			 promise.success(function(data, status, headers, config) { 
                			 		 
                			 		 obj.updateRequestQuestionView( data,$scope );
                			 });
				
                			 promise.update(function(data, status, headers, config) { 
                			 	 obj.updateRequestQuestionView( data,$scope );
					 });
				
					 promise.error(function(data, status, headers, config) {
					 		 $scope.API.setResting(false);
					 		 $scope.API.setError( data.ret.message, scopePointer );
					 }); 	 
                	},
                	
                	answer: function( answer, idQuestion ){
                		console.log(">>>>>>>>>>>>>>>>>"+answer+">>>>>>>>>"+idQuestion);
                		var promise = AJAX.put('TUTORIAL_QUESTIONS_ANSWERS', {'answer':answer, 'id_question':idQuestion }  ); 
                		var obj     = this;
                		promise.success(function(data, status, headers, config) { 
                				 
                			window.SC().API.setResting(false);
                			if( data.status == 'SUCCESS' ){  
                				window.SC().API.setMessage( data.ret.message  );
                				window.SC().go('/cyberpoints/spend/');
                				
                			}else
                				window.SC().API.setError( data.ret.message, window.SC() );
                				
                		});
				 
				
				promise.error(function(data, status, headers, config) {
					 $scope.API.setResting(false);
					 $scope.API.setError( data.ret.message, scopePointer );
				 }); 	 
                	},	
                	
                	shortenQuestion: function( text )
                	{
                		var box = text.split(":");
                		return box[1];
                	},
                	
                	updateRequestQuestionView: function( data,scopePointer )
                	{ 
                		if( data.status == 'SUCCESS' ){
                			scopePointer.data = data.ret;
                			if( data.ret.fields )
                				if( data.ret.fields.v )
                					for( var i in data.ret.fields.v )
                					{
                						data.ret.fields.v[i] = '<B>'+data.ret.fields.v[i]+'</B>';	
                					}
                		}
                		else
                			scopePointer.API.setError( data.ret.message );
                	},
                	
                	step: function(){
                		return this.steps( order[step] );
                	},
                	
                	get: function( idQuestion )
                	{
                		var promise = AJAX.get('TUTORIAL_QUESTIONS', {'get':'fields,all', 'id_question': idQuestion} );
                		
                	}
                	
                }

            }]);
}());
 
