(function () {
  
    var scopePointer; 
    var id; 
    var idCountry;
    var page;
    var voted = {};
    
    angular.module('myApp.wc', ['myApp.AJAX','myApp.me' ])
        .service('wc', [ 'AJAX','me' ,
            function ( AJAX,me  ) { 
                return { 
                	get: function( $scope )
                	{ 
                		if( typeof $scope != 'undefined' )
                			scopePointer= $scope;
                	  
                		 
				var promise = AJAX.get('WC', {'get':'schedule,competitions,teams=fields-manager'}, 1 ); 
				var obj	    = this;
				scopePointer.API.setResting(true);
				promise.success(function(data, status, headers, config) {
					obj.updateWCView( data );
				});
				
				if( promise.update )
					promise.update(function(data, status, headers, config) {
						obj.updateWCView( data );
					});
				
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				});
                	},
                	
                	updateWCView: function( data )
                	{
                		scopePointer.cachedCopy = data.cache;
				if( !data.cache ){
					 scopePointer.API.setResting(false);
					 scopePointer.API.checkNotifications( data, scopePointer);
				    } 
                		scopePointer.data 	= data.ret;
                		scopePointer.data.title = tr('World Championships');
                	},
                	
                	canApply: function()
                	{
                		return 1;	
                	},
                	
                	getVoting: function( idCountry, $scope )
                	{
                		
                		voted = {};
                		if( typeof $scope != 'undefined' )
                			scopePointer= $scope;
                	  
                		 
				var promise = AJAX.get('WC', {'get':'schedule,competitions,teams,countries,applications,canVote,myVotes', 'id_country': idCountry}, 1 ); 
				var obj	    = this;
				scopePointer.API.setResting(true);
				promise.success(function(data, status, headers, config) {
					voted = {};
					obj.updateVotingView( data );
				});
				
				if( promise.update )
					promise.update(function(data, status, headers, config) {
						voted = {};
						obj.updateVotingView( data );
					});
				
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
                	},
                	
                	sendApplication: function( career )
                	{
                		var promise = AJAX.put('WC_COACH_APPLICATIONS', {'career':career, 'id_country': idCountry}, 0 ); 
				var obj	    = this;
				scopePointer.API.setResting(true);
				promise.success(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					if( data.status == 'SUCCESS' )
					{
						 if( typeof scopePointer.data.election[career] == 'undefined' )
						 	 scopePointer.data.election[career] = [];
						 scopePointer.data.election[career].push( { 'career':career, 'id_country':idCountry,'id_account':me.get('id_account'),'username': me.get('username'),'votes':0, 'id_entry':data.ret.id_entry } );
						
						  
						 scopePointer.API.setMessage( data.ret.message, scopePointer );
					}
					else
					{
						scopePointer.API.setError( data.ret.message, scopePointer );		
					}
				});
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
                	},
                	
                	voteFor: function( career, id_account )
                	{
                		var promise = AJAX.put('WC_COACH_VOTES', {'career':career, 'id_country': idCountry, 'id_account': id_account }, 0 ); 
				var obj	    = this;
				scopePointer.API.setResting(true);
				promise.success(function(data, status, headers, config) {
					scopePointer.API.setResting(false);
					if( data.status == 'SUCCESS' )
					{
						 if( typeof scopePointer.data.election[career] == 'undefined' )
						 	 scopePointer.data.election[career] = [];
						 for( var i in scopePointer.data.election[career] )
						 {
						 	var item = scopePointer.data.election[career][i];
						 	obj.saveVote(career, id_account);
						 	scopePointer.data.election[career][i].votes++; 
						 }
						 
						  
						 scopePointer.API.setMessage( data.ret.message, scopePointer );
					}
					else
					{
						scopePointer.API.setError( data.ret.message, scopePointer );		
					}
				});
				promise.error(function(data, status, headers, config) {
					scopePointer.API.setResting(false); 
					scopePointer.API.setError( 'REST', scopePointer );
				}); 
                		
                	},
                	
                	applied: function( career )
                	{
                		var item = {};
                		if( typeof scopePointer.data.election == 'undefined' || scopePointer.data.election == null )
                		{
                			scopePointer.data.election = {};
                			return 0;
                		}
                		
                		if( typeof scopePointer.data.election[ career ] == 'undefined' )
                			scopePointer.data.election[ career ] = [];
                		
                		for( var i in scopePointer.data.election[ career ] )
                		{
                			item =  scopePointer.data.election[ career ][i];
                			//console.log(JSON.stringify( item ) );
                			console.log("career ["+item.career+"]  = "+career+" idCountry [ "+item.id_country+" ] = "+idCountry);
                			if( item.career == career && item.id_country == idCountry && me.get('id_account') == item.id_account )
                				return 1; 
                						
                		}
                		return 0;
                		
                	},
                	
                	canVote: function( )
                	{
                		if( scopePointer.data.canVote == 1 )
                			return 1;
                		
                		return 0;
                	},
                	
                	getTeamLink: function( career ) 
                	{                      
                		 
                		for( var i in scopePointer.data.teams[0] )
                			if( scopePointer.data.teams[0][i].fields.career ==  career )
                				return scopePointer.data.teams[0][i].team.fields.id;
                		
                	},
                	
                	votePossible: function( career, id_country, id_account )
                	{
                		if(typeof career == 'undefined' )
                			return -1;
                		//console.log("votePossible ==["+career+"] ==>"+voted[career]+"<<");
                		if( typeof voted[career] == 'undefined' )
                			return 1;
                		
                		if( voted[career] == id_account )
                			return -2;
                		
                		if( typeof voted[career] != 'undefined' )
                			return -1;
                		
                		return 0;
                		
                	},
                	
                	setIdCountry: function( to )
                	{
                		idCountry = to;	
                	},
                	
                	getIdCountry: function()
                	{
                		return idCountry;	
                	},
                	
                	updateVotingView: function( data )
                	{
                		scopePointer.cachedCopy = data.cache;
				if( !data.cache ){
					 scopePointer.API.setResting(false);
					 scopePointer.API.checkNotifications( data, scopePointer);
				    } 
				    
				    
                		scopePointer.data 	= data.ret;
                		var option = {};
                		var selectedOption = -1;
                		var cntry  = {};
                		var cntryName = '';
                		for( var i in data.ret.countries )
                		{
                			cntry = data.ret.countries[i];
                			option = {};
                			option.name 	= cntry.country;  
                			option.value    = cntry.id_country;	  
                			scopePointer.form.countryOptions.push( option );
                			//console.log("PUSH >>"+JSON.stringify(option));
                			if( cntry.id_country == this.getIdCountry()){
                				selectedOption = scopePointer.form.countryOptions.length-1;
                				cntryName = option.name;
                			}
                		}
                		
                		if( selectedOption > 0 )
                			scopePointer.form.selectCountry = scopePointer.form.countryOptions[selectedOption];
                		
                		
                		scopePointer.data.title = cntryName+' '+tr('Elections');
                		if( data.ret.applications != null )
					this.saveVotes( data.ret.applications );
				
				//if( data.ret.myVotes != null )
				this.saveMyVoteHistory( data.ret.myVotes ); 
                	},
                	
                	saveMyVoteHistory: function( voteHistory )
                	{
                		var voted = {};	
                		for( var i in voteHistory )
                		{
                			var vote = voteHistory[i];
                			var career      = vote.career;
                			this.saveVote(career, vote.voted_for); 
                		}
                		
                	},
                	
                	saveVote: function( career, voted_for)
                	{
                		if( typeof voted[career] == 'undefined' )
                				voted[career] = [];
                		console.log( " voted["+career+"] = "+voted_for+" << ");
                		voted[career] = voted_for;	
                	},
                	
                	saveVotes: function( applications )
                	{
                		var application = {};
                		scopePointer.data.election = {};
                		for( var i in applications )
                		{
                			var application = applications[i];
                			var career      = application.career;
                			if( typeof scopePointer.data.election[career] == 'undefined' )
                				scopePointer.data.election[career] = [];
                			
                			scopePointer.data.election[career].push( application );
                			
                		}
                	},
                	
                	getIcon: function( from, to )
                	{
                		var azi = me.get('day');
                		
                		if( azi >= from && azi < to )
                			return '<img style="height:24px;width:24px;" src="pics/arrow_right.'+me.imgExtension()+'">';
                		else if( azi >= from && azi >= to )
                			return '<img style="height:24px;width:24px;" src="pics/check.'+me.imgExtension()+'">';
                		else
                			return ''; 
                	},
                	
                	getStatus: function( how )
                	{
                		var day = me.get('day');
                	 
                		
                		var minFrom = 999;
                		var maxTo   = -999;
                		for( var num in scopePointer.data.schedule)
                		{
                			
                			var item = scopePointer.data.schedule[num];
                			 
                			var from = item.start_day;
                			var   to = item.end_day;
                			if( day >= from && day < to )
                			{
                				return this.parseStatus( item.event, item, how );
                			}  
                			
                			//console.log("minfrom="+minFrom+" < from="+from+" ");
                			if( minFrom >= from )
                				minFrom = from;
                			
                			if(  maxTo <= to )
                				maxTo = to;
                		}
                		
                		//console.log("day="+day+" < "+minFrom+" << ");
                		if( day < minFrom )
                			return this.parseStatus('start', item, how );
                		
                		if( day > maxTo )
                			return this.parseStatus('fin', item, how );
                	},
                	
                	getCompetitionLink: function( career )
                	{
                		for( var compId in scopePointer.data.competitions )
                		{
                			var comp =  scopePointer.data.competitions[ compId ];
                			if( comp.fields.career == career )
                				return  comp.fields.type+'/'+comp.fields.id;
                			
                		}
                	},	
                	
                	setPage: function( to )
                	{
                		page = to;	
                	},
                	
                	getPage: function()
                	{
                		return page;	
                	},
                	
                	parseStatus: function( which, item, how  )
                	{
                		if( how == 'event' )
                			return which;
                		
                		//console.log("status = "+which+" >>> how = "+how+" <<");
                		switch( how )
                		{
                			case "string":
						switch( which )
						{
							case "coach_election":
								if( this.getPage() == 'voting' )
									return  tr('Users are applying & voting for coaches in each country.');
								
								return tr('Users are applying & voting for coaches in each country.')+' '+tr("You can vote on countries you've created players from.")+' '+tr("Choose a career stage below and go to the country page of your choice to apply or vote.");
							break;
							
							case "start":
								var v = {'num': scopePointer.data.schedule[0].start_day, 'real_date': me.dateFormat('F jS', me.getTimestamp(scopePointer.data.schedule[0].startTimestamp))};
								return tr('Coach elections will start on day {num} ( {real_date} )',v);
							break;
							 
							
							case "wc_pool_games":
								return tr('Pool games are underway');
							break;
							
							case "wc_playoffs":
								return tr('Knockout games are underway');
							break;
							
							case "fin":
								return tr('The world championships for this season are over !');
							break; 
						}
					break;
					
					case "date":
						console.log(">>>"+which+"<<");
						switch( which )
						{
							case "coach_election":
								 return scopePointer.data.schedule[0].endTimestamp;
							break;
							
							case "start":
								 return scopePointer.data.schedule[0].startTimestamp;
							break;
							
						 
							
							case "wc_pool_games":
								return scopePointer.data.schedule[1].endTimestamp;
							break;
							
							case "wc_playoffs":
								return scopePointer.data.schedule[2].endTimestamp;
							break;
							
							case "fin":
								return scopePointer.data.schedule[2].endTimestamp;
							break; 
						}
					break;
				}
                		
                	},
			
			getHelp: function( page, item )
                        {
                        	var help = { items:{} };
                		
                		
                		switch( page )
                		{
                			case "wcSwitch":
                				help.items.a1_schedule		= {text:tr('Shows when coach applications and voting start, when pool games start, when does the knockout stage start.'), title:tr('Schedule')};
                				help.items.a2_career		= {text:tr('Countries that take part in this career stage and the current manager.' )+' '+tr('The coach will change every season after each election ends.'), title:tr('Career Stage')};
                				break;
                			 
                		}
                		 
                		if( typeof item != 'undefined' )
                			return help.items[item].text;
                		
                		return help; 
                       } 
                }

            }]);
}());
